
NUM_ALPHAMAP_DETAIL_TILES	= 12;
NUM_ALPHAMAP_OVERLAYS		= 40;
NUM_ALPHAMAP_POIS			= 32;

ALPHAMAP_POI_TEXTURE_WIDTH	= 64;
NUM_ALPHAMAP_POI_COLUMNS	= 4;
NUM_ALPHAMAP_MAPNOTE_POIS	  = 100;
NUM_ALPHAMAP_GATHERNOTE_POIS  = 200;

ALPHAMAP_INCREMENT		      = 0.10;

AlphaMapConfig = { enabled = true, alpha = 0.0, scale = 0.8, lock = false, combat = true, 
				   ptips = true, gtips = false, mntips = false, mngtips = false, 
				   wmclose = false, gathering = false, gatherer = false, mapnotes = false, 
				   raid = true, sliderlock = true, slider = false };

-- This makes it so you can close the AlphaMap by hitting the ESC key
-- But if used, the world map will not open with AlphaMap open
-- UIPanelWindows["AlphaMapFrame"] = { area = "center", pushable = 0 };

-- Called whenever AlphaMap is loaded
function AlphaMapFrame_OnLoad()
	SlashCmdList["ALPHAMAPSLASH"] = AlphaMap_Main_ChatCommandHandler;
	SLASH_ALPHAMAPSLASH1 = "/AlphaMap";
	SLASH_ALPHAMAPSLASH2 = "/am";
	
	this:RegisterEvent( "WORLD_MAP_UPDATE" );
	this:RegisterEvent( "ZONE_CHANGED_NEW_AREA" );
	this:RegisterEvent( "VARIABLES_LOADED" );
	this:RegisterEvent( "PLAYER_REGEN_DISABLED" );
	this:RegisterEvent( "PLAYER_REGEN_ENABLED" );
	
	AlphaMapFrame_Update();
end
function ChangeAlphaMapAlpha(toggle)	
	gLimAlphaMapAlpha = toggle;
	-- Get the frames
	alphaMapDetailFrame = getglobal( "AlphaMapDetailFrame" );
	alphaMapSliderFrame = getglobal( "AlphaMapSliderFrame" );

	-- Determine the transparency from the alpha slider
	local alpha = 1.0 - alphaMapSliderFrame:GetValue();

	-- Increment the opacity
	alpha = toggle;
	-- Clamp the opacity to 1.0
	if alpha == "0" then
		alpha = 0;
	end;
	if( alpha > 1.0 ) then
		alpha = 1.0;
	end
	
	alphaMapDetailFrame:SetAlpha( alpha );
	alphaMapSliderFrame:SetValue( 1 - alpha );
	
	-- If there is 1 alpha, then hide the markers
end
function ChangeAlphaMapScale(toggle)
	if ( toggle >= 0.1 and toggle <= 1) then
		AlphaMapConfig.scale =  toggle;
		AlphaMapFrame:SetScale( AlphaMapConfig.scale );
	end
end
function AlphaMap_Register()
	gLim_RegisterButton (
	"AlphaMap",
	"透明地图设置",
	"Interface\\AddOns\\AlphaMap\\Icon",
	function()
		gLimModSecBookShowConfig("gLimAlphaMap");
	end,
	1,
	2
	);

	gLim_RegisterConfigClass(
		"gLimAlphaMap",
		"Alpha Map",
		"Jeromy Walsh"
	);

	gLim_RegisterConfigSection(
		"gLimAlphaMapSection",
		"透明地图",
		"透明地图设置",
		"黑眼圈",
		"gLimAlphaMap"
	);  

	gLim_RegisterConfigCheckBox(
		"gLimAlphaMapShow",
		"开启透明地图",
		"选择开启游戏背景显示透明地图功能",
		AlphaMapConfig.enabled,
		ToggleAlphaMap,
		"gLimAlphaMap"
	);
	ToggleAlphaMapMoveslider(AlphaMapConfig.enabled);
	gLim_RegisterConfigCheckBox(
		"gLimAlphaMapLock",
		"锁定透明地图",
		"选择将锁定透明地图,使其无法移动",
		AlphaMapConfig.lock,
		function()
			AlphaMap_Main_ChatCommandHandler("lock");
		end,
		"gLimAlphaMap"
	);
--[[
	gLim_RegisterConfigCheckBox(
		"gLimAlphaMapSlider",
		"开启透明度控制条",
		"选择将在透明地图上显示透明度控制条.",
		AlphaMapConfig.slider,
		ToggleSlider,
		"gLimAlphaMap"
	);
]]
	gLim_RegisterConfigSlider(
		"gLimAlphaMapAlpha",
		"设置透明地图的透明度",
		"设置背景透明地图的透明度",
		"透明度(0.0-1.0)",
		"",
		0.05,
		0,
		1,
		AlphaMapConfig.alpha,
		ChangeAlphaMapAlpha,
		"gLimAlphaMap"
	);

	gLim_RegisterConfigSlider(
		"gLimAlphaMapScale",
		"缩放透明地图的大小",
		"设置背景透明地图的大小.",
		"尺寸(0.05-1.0)",
		"",
		0.05,
		0.05,
		1,
		AlphaMapConfig.scale,
		ChangeAlphaMapScale,
		"gLimAlphaMap"
	);
--[[
	gLim_RegisterConfigCheckBox(
		"gLimAlphaMapPtips",
		"显示队伍标记",
		"选择将在透明地图上显示队伍标记.",
		AlphaMapConfig.ptips,
		function()
			AlphaMap_Main_ChatCommandHandler("ptips");
		end,
		"gLimAlphaMap"
	);

	gLim_RegisterConfigCheckBox(
		"gLimAlphaMapRaid",
		"显示Raid标记",
		"选择将在透明地图上显示Raid标记.",
		AlphaMapConfig.raid,
		function()
			AlphaMap_Main_ChatCommandHandler("raid");
		end,
		"gLimAlphaMap"
	);

	gLim_RegisterConfigCheckBox(
		"gLimAlphaMapGtips",
		"显示 Gatherer (原料采集) 标记",
		"选择将在透明地图上显示原料采集的标记.",
		AlphaMapConfig.gatherer,
		function()
			AlphaMap_Main_ChatCommandHandler("gatherer");
		end,
		"gLimAlphaMap"
	);

	gLim_RegisterConfigCheckBox(
		"gLimAlphaMapMntips",
		"显示 MapNotes (地图标记) 标记",
		"选择将在透明地图上显示地图标记的标记.",
		AlphaMapConfig.mapnotes,
		function()
			AlphaMap_Main_ChatCommandHandler("mapnotes");
		end,
		"gLimAlphaMap"
	);
	---------------------
	gLim_RegisterConfigCheckBox(
		"gLimAlphaMapMngtips",
		"显示 MapNotes Gathering 标记",
		"选择将在透明地图上显示MapNotes Gathering的标记.",
		AlphaMapConfig.gathering,
		function()
			AlphaMap_Main_ChatCommandHandler("gathering");
		end,
		"gLimAlphaMap"
	);
	---------------------
	gLim_RegisterConfigCheckBox(
		"gLimAlphaMapCombat",
		"战斗自动隐藏",
		"进入战斗状态战斗自动隐藏透明地图.",
		AlphaMapConfig.combat,
		function()
			AlphaMap_Main_ChatCommandHandler("combat");
		end,
		"gLimAlphaMap"
	);

	gLim_RegisterConfigCheckBox(
		"gLimAlphaMapWmClose",
		"地图关闭时自动关闭",
		"当关闭世界地图时自动关闭透明地图.",
		AlphaMapConfig.wmclose,
		function()
			AlphaMap_Main_ChatCommandHandler("wmclose");
		end,
		"gLimAlphaMap"
	);
	]]
	gLim_RegisterConfigButton(
		"gLim_AlphaMap_bind",
		"设置透明地图快捷键",
		"设置透明背景地图",
		"快捷键设置",
		function()
			gLimKeyBinding("HEADER_ALPHAMAP");
			gLimConfigSubFrame:Hide();
		end,
		"gLimAlphaMap"
	);
end

AlphaMap_LoadCount = 0;

function AlphaMap_Alpha_Set(checked, alpha)
	AlphaMapConfig.slider = (checked==1);
	if ( AlphaMapConfig.slider ) then
		AlphaMapSliderFrame:Show();
	else
		AlphaMapSliderFrame:Hide();
	end

	if (AlphaMapConfig.alpha == alpha) then return; end
	
	AlphaMapConfig.alpha = alpha;

	if( not AlphaMapConfig.alpha or AlphaMapConfig.alpha < 0 ) then
		AlphaMapConfig.alpha = 0.0;
	end
	
	if( AlphaMapConfig.alpha > 1.0 ) then
		AlphaMapConfig.alpha = 1.0;
	end
	
	AlphaMapDetailFrame:SetAlpha( AlphaMapConfig.alpha );
	AlphaMapSliderFrame:SetValue( 1 - AlphaMapConfig.alpha );	 

	-- If there is 1 alpha, then hide the markers
	if( AlphaMapConfig.alpha == 0.0 ) then
		AlphaMapUnits:Hide();
	else
		AlphaMapUnits:Show();
	end

	if (Khaos) then
		Khaos.setSetKeyParameter("AlphaMap", "AlphaMapAlpha", "checked", AlphaMapConfig.slider);
		Khaos.setSetKeyParameter("AlphaMap", "AlphaMapAlpha", "slider", AlphaMapConfig.alpha);
	end
	if ( Cosmos_RegisterConfiguration ) then
		Cosmos_UpdateValue("COS_ALPHAMAP_ALPHA",CSM_SLIDERVALUE,AlphaMapConfig.alpha);
	end
	if ( Cosmos_SetCVar ) then
		Cosmos_SetCVar("COS_ALPHAMAP_ALPHA", AlphaMapConfig.alpha);
	end
end

function AlphaMap_SCale_Set(checked, scale)
	AlphaMapConfig.scale = scale;
	
	if( not AlphaMapConfig.scale or AlphaMapConfig.scale < 0.0 ) then 
		AlphaMapConfig.scale = 1.0; 
	end
	
	AlphaMapFrame:SetScale( AlphaMapConfig.scale );
end

function ToggleAlphaMapMoveslider(toggle)
	if (toggle) then
		AlphaMapConfig.sliderlock = (toggle==1);
	else
		AlphaMapConfig.sliderlock = not AlphaMapConfig.sliderlock;
	end
end

function ToggleAlphaMapLock(toggle)
	if (toggle) then
		AlphaMapConfig.lock = (toggle==1);
	else
		AlphaMapConfig.lock = not AlphaMapConfig.lock;
	end
end

function ToggleAlphaMapCombat(toggle)
	if (toggle) then
		AlphaMapConfig.combat = (toggle==1);
	else
		AlphaMapConfig.combat = not AlphaMapConfig.combat;
	end
end

function ToggleAlphaMapRaid(toggle)
	if (toggle) then
		AlphaMapConfig.raid = (toggle==1);
	else
		AlphaMapConfig.raid = not AlphaMapConfig.raid;
	end
end

function ToggleAlphaMapPtips(toggle)
	if (toggle) then
		AlphaMapConfig.ptips = (toggle==1);
	else
		AlphaMapConfig.ptips = not AlphaMapConfig.ptips;
	end
end

function ToggleAlphaMapWmclose(toggle)
	if (toggle) then
		AlphaMapConfig.wmclose = (toggle==1);
	else
		AlphaMapConfig.wmclose = not AlphaMapConfig.wmclose;
	end
end

function ToggleAlphaMapMapnotes(toggle)
	if (toggle) then
		AlphaMapConfig.mapnotes = (toggle==1);
	else
		AlphaMapConfig.mapnotes = not AlphaMapConfig.mapnotes;
	end
end

function ToggleAlphaMapMntips(toggle)
	if (toggle) then
		AlphaMapConfig.mntips = (toggle==1);
	else
		AlphaMapConfig.mntips = not AlphaMapConfig.mntips;
	end
end

function ToggleAlphaMapGathering(toggle)
	if (toggle) then
		AlphaMapConfig.gathering = (toggle==1);
	else
		AlphaMapConfig.gathering = not AlphaMapConfig.gathering;
	end
end

function ToggleAlphaMapMngtips(toggle)
	if (toggle) then
		AlphaMapConfig.mngtips = (toggle==1);
	else
		AlphaMapConfig.mngtips = not AlphaMapConfig.mngtips;
	end
end

function ToggleAlphaMapGatherer(toggle)
	if (toggle) then
		AlphaMapConfig.gatherer = (toggle==1);
	else
		AlphaMapConfig.gatherer = not AlphaMapConfig.gatherer;
	end
end

function ToggleAlphaMapGtips(toggle)
	if (toggle) then
		AlphaMapConfig.gtips = (toggle==1);
	else
		AlphaMapConfig.gtips = not AlphaMapConfig.gtips;
	end
end

function AlphaMap_RegisterCosmos()
	if (Khaos) then
		local optionSet={
			id = "AlphaMap";
			text = ALPHAMAP_CONFIG_HEADER;
			helptext = ALPHAMAP_CONFIG_HEADER_INFO;
			difficulty = 1;
			default = false;
			options = {
				{
					id="AlphaMapHeader";
					type=K_HEADER;
					text=ALPHAMAP_CONFIG_HEADER;
					helptext=ALPHAMAP_CONFIG_HEADER_INFO;
					difficulty = 1;
				},
				{
					id="AlphaMapEnabled";
					type=K_TEXT;
					text=ALPHAMAP_ENABLED;
					helptext=ALPHAMAP_ENABLED_INFO;
					difficulty = 1;
					callback=function(state) if (state.checked) then ToggleAlphaMap(1); else ToggleAlphaMap(0); end end;
					feedback=function(state) if (state.checked) then return ALPHAMAP_TEXT_ENABLE; else return ALPHAMAP_TEXT_DISABLE; end end;
					check=true;
					default={checked=true};
					disabled={checked=false};
				},
				{
					id="AlphaMapLock";
					type=K_TEXT;
					text=ALPHAMAP_LOCK;
					helptext=ALPHAMAP_LOCK_INFO;
					difficulty = 1;
					callback=function(state) AlphaMapConfig.lock = state.checked end;
					feedback=function(state) if (state.checked) then return ALPHAMAP_UILOCKED; else return ALPHAMAP_UIUNLOCKED; end end;
					check=true;
					default={checked=false};
					disabled={checked=false};
				},
				{
					id="AlphaMapAlpha";
					type=K_SLIDER;
					text=ALPHAMAP_ALPHA;
					helptext=ALPHAMAP_ALPHA_INFO;
					difficulty = 1;
					check=true;
					setup = {
						sliderMin = 0;
						sliderMax = 1;
						sliderStep = .05;
						sliderText = ALPHAMAP_ALPHA_SUB;
						sliderDisplayFunc = function(value) return (math.floor(value*100)).."%"; end;
					};
					callback=function(state) if (state.checked) then AlphaMap_Alpha_Set(1,state.slider); else AlphaMap_Alpha_Set(0,state.slider); end end;
					feedback=function(state) if (state.checked) then return nil; else return nil; end end;
					default={checked=false;slider=0.5;};
					disabled={checked=false;slider=0;};
				},
				{
					id="AlphaMapMoveSlider";
					type=K_TEXT;
					text=ALPHAMAP_MOVESLIDER;
					helptext=ALPHAMAP_MOVESLIDER_INFO;
					difficulty = 1;
					callback=function(state) AlphaMapConfig.sliderlock = state.checked end;
					feedback=function(state) return nil; end;
					check=true;
					default={checked=true};
					disabled={checked=true};
				},
				{
					id="AlphaMapScale";
					type=K_SLIDER;
					text=ALPHAMAP_SCALE;
					helptext=ALPHAMAP_SCALE_INFO;
					difficulty = 1;
					setup = {
						sliderMin = 0;
						sliderMax = 1;
						sliderStep = .05;
						sliderText = "";
						sliderDisplayFunc = function(value) return (math.floor(value*100)).."%"; end;
					};
					callback=function(state) AlphaMap_SCale_Set(nil,state.slider); end;
					feedback=function(state) return nil; end;
					default={slider=0.8;};
					disabled={slider=0.8;};
				},
				{
					id="AlphaMapCombat";
					type=K_TEXT;
					text=ALPHAMAP_COMBAT;
					helptext=ALPHAMAP_COMBAT_INFO;
					difficulty = 1;
					check=true;
					callback=function(state) AlphaMapConfig.combat = state.checked end;
					feedback=function(state) return nil; end;
					default={checked=true};
					disabled={checked=true};
				},
				{
					id="AlphaMapRaid";
					type=K_TEXT;
					text=ALPHAMAP_RAID;
					helptext=ALPHAMAP_RAID_INFO;
					difficulty = 1;
					check=true;
					callback=function(state) AlphaMapConfig.raid = state.checked end;
					feedback=function(state) return nil; end;
					default={checked=true};
					disabled={checked=true};
				},
				{
					id="AlphaMapPTips";
					type=K_TEXT;
					text=ALPHAMAP_PTIPS;
					helptext=ALPHAMAP_PTIPS_INFO;
					difficulty = 1;
					check=true;
					callback=function(state) AlphaMapConfig.ptips = state.checked end;
					feedback=function(state) return nil; end;
					default={checked=true};
					disabled={checked=true};
				},
			}
		}
		if (MapNotes_Options) then
			local option={
				id="AlphaMapMapNoteHeader";
				type=K_HEADER;
				text=ALPHAMAP_MAPNOTE_HEADER;
				helptext=ALPHAMAP_MAPNOTE_HEADER_INFO;
				difficulty = 1;
			};
			table.insert(optionSet.options,option);
			local option={
				id="AlphaMapMapNotes";
				type=K_TEXT;
				text=ALPHAMAP_MAPNOTES;
				helptext=ALPHAMAP_MAPNOTES_INFO;
				difficulty = 1;
				check=true;
				callback=function(state) AlphaMapConfig.mapnotes = state.checked end;
				feedback=function(state) return nil; end;
				default={checked=false};
				disabled={checked=false};
			};
			table.insert(optionSet.options,option);
			local option={
				id="AlphaMapMNTips";
				type=K_TEXT;
				text=ALPHAMAP_MNTIPS;
				helptext=ALPHAMAP_MNTIPS_INFO;
				difficulty = 1;
				check=true;
				callback=function(state) AlphaMapConfig.mntips = state.checked end;
				feedback=function(state) return nil; end;
				default={checked=false};
				disabled={checked=false};
			};
			table.insert(optionSet.options,option);
		end
		if (MapNotesGathering_Data) then
			local option={
				id="AlphaMapGatheringHeader";
				type=K_HEADER;
				text=ALPHAMAP_GATHERING_HEADER;
				helptext=ALPHAMAP_GATHERING_HEADER_INFO;
				difficulty = 1;
			};
			table.insert(optionSet.options,option);
			local option={
				id="AlphaMapGathering";
				type=K_TEXT;
				text=ALPHAMAP_GATHERING;
				helptext=ALPHAMAP_GATHERING_INFO;
				difficulty = 1;
				check=true;
				callback=function(state) AlphaMapConfig.gathering = state.checked end;
				feedback=function(state) return nil; end;
				default={checked=false};
				disabled={checked=false};
			};
			table.insert(optionSet.options,option);
			local option={
				id="AlphaMapMNGTips";
				type=K_TEXT;
				text=ALPHAMAP_MNGTIPS;
				helptext=ALPHAMAP_MNGTIPS_INFO;
				difficulty = 1;
				check=true;
				callback=function(state) AlphaMapConfig.mngtips = state.checked end;
				feedback=function(state) return nil; end;
				default={checked=false};
				disabled={checked=false};
			};
			table.insert(optionSet.options,option);
		end
		if (GatherConfig) then
			local option={
				id="AlphaMapGathererHeader";
				type=K_HEADER;
				text=ALPHAMAP_GATHERER_HEADER;
				helptext=ALPHAMAP_GATHERER_HEADER_INFO;
				difficulty = 1;
			};
			table.insert(optionSet.options,option);
			local option={
				id="AlphaMapGatherer";
				type=K_TEXT;
				text=ALPHAMAP_GATHERER;
				helptext=ALPHAMAP_GATHERER_INFO;
				difficulty = 1;
				check=true;
				callback=function(state) AlphaMapConfig.gatherer = state.checked end;
				feedback=function(state) return nil; end;
				default={checked=false};
				disabled={checked=false};
			};
			table.insert(optionSet.options,option);
			local option={
				id="AlphaMapGTips";
				type=K_TEXT;
				text=ALPHAMAP_GTIPS;
				helptext=ALPHAMAP_GTIPS_INFO;
				difficulty = 1;
				check=true;
				callback=function(state) AlphaMapConfig.gtips = state.checked end;
				feedback=function(state) return nil; end;
				default={checked=false};
				disabled={checked=false};
			};
			table.insert(optionSet.options,option);
		end
		Khaos.registerOptionSet( "maps", optionSet );
	elseif ( Cosmos_RegisterConfiguration ) then
		Cosmos_RegisterConfiguration(
			"COS_ALPHAMAP",
			"SECTION",
			ALPHAMAP_CONFIG_HEADER,
			ALPHAMAP_CONFIG_HEADER_INFO
		);
		Cosmos_RegisterConfiguration(
			"COS_ALPHAMAP_HEADER",
			"SEPARATOR",
			ALPHAMAP_CONFIG_HEADER,
			ALPHAMAP_CONFIG_HEADER_INFO
		);
		local defaultstate=0;
		if (AlphaMapConfig.enabled) then
			defaultstate=1;
		end
		Cosmos_RegisterConfiguration(
			"COS_ALPHAMAP_ENABLED",
			"CHECKBOX",
			ALPHAMAP_ENABLED,
			ALPHAMAP_ENABLED_INFO,
			ToggleAlphaMap,
			defaultstate
		);
		Cosmos_RegisterConfiguration(
			"COS_ALPHAMAP_LOCK",
			"CHECKBOX",
			ALPHAMAP_LOCK,
			ALPHAMAP_LOCK_INFO,
			ToggleAlphaMapLock,
			AlphaMapConfig.lock
		);
		local slider = 0;
		if (AlphaMapConfig.slider) then
			slider = 1;
		end
		Cosmos_RegisterConfiguration(
			"COS_ALPHAMAP_ALPHA",
			"BOTH",
			ALPHAMAP_ALPHA,
			ALPHAMAP_ALPHA_INFO,
			AlphaMap_Alpha_Set,
			slider,
			AlphaMapConfig.alpha,
			0.0,
			1.0,
			ALPHAMAP_ALPHA_SUB,
			0.05,
			1,
			"%",
			100
		);
		Cosmos_RegisterConfiguration(
			"COS_ALPHAMAP_SCALE",
			"SLIDER",
			ALPHAMAP_SCALE,
			ALPHAMAP_SCALE_INFO,
			AlphaMap_SCale_Set,
			0,
			AlphaMapConfig.scale,
			0.0,
			1.0,
			"",
			0.05,
			1,
			"%",
			100
		);
		Cosmos_RegisterConfiguration(
			"COS_ALPHAMAP_MOVESLIDER",
			"CHECKBOX",
			ALPHAMAP_MOVESLIDER,
			ALPHAMAP_MOVESLIDER_INFO,
			ToggleAlphaMapMoveslider,
			AlphaMapConfig.sliderlock
		);
		Cosmos_RegisterConfiguration(
			"COS_ALPHAMAP_COMBAT",
			"CHECKBOX",
			ALPHAMAP_COMBAT,
			ALPHAMAP_COMBAT_INFO,
			ToggleAlphaMapCombat,
			AlphaMapConfig.combat
		);
		Cosmos_RegisterConfiguration(
			"COS_ALPHAMAP_RAID",
			"CHECKBOX",
			ALPHAMAP_RAID,
			ALPHAMAP_RAID_INFO,
			ToggleAlphaMapRaid,
			AlphaMapConfig.raid
		);
		Cosmos_RegisterConfiguration(
			"COS_ALPHAMAP_PTIPS",
			"CHECKBOX",
			ALPHAMAP_PTIPS,
			ALPHAMAP_PTIPS_INFO,
			ToggleAlphaMapPtips,
			AlphaMapConfig.ptips
		);
--		Cosmos_RegisterConfiguration(
--			"COS_ALPHAMAP_WMCLOSE",
--			"CHECKBOX",
--			ALPHAMAP_WMCLOSE,
--			ALPHAMAP_WMCLOSE_INFO,
--			ToggleAlphaMapWmclose,
--			AlphaMapConfig.wmclose
--		);
		if (MapNotes_Options) then
			Cosmos_RegisterConfiguration(
				"COS_ALPHAMAP_MAPNOTE_HEADER",
				"SEPARATOR",
				ALPHAMAP_MAPNOTE_HEADER,
				ALPHAMAP_MAPNOTE_HEADER_INFO
			);
			Cosmos_RegisterConfiguration(
				"COS_ALPHAMAP_MAPNOTES",
				"CHECKBOX",
				ALPHAMAP_MAPNOTES,
				ALPHAMAP_MAPNOTES_INFO,
				ToggleAlphaMapMapnotes,
				AlphaMapConfig.mapnotes
			);
			Cosmos_RegisterConfiguration(
				"COS_ALPHAMAP_MNTIPS",
				"CHECKBOX",
				ALPHAMAP_MNTIPS,
				ALPHAMAP_MNTIPS_INFO,
				ToggleAlphaMapMntips,
				AlphaMapConfig.mntips
			);
		end
		if (MapNotesGathering_Data) then
			Cosmos_RegisterConfiguration(
				"COS_ALPHAMAP_GATHERING_HEADER",
				"SEPARATOR",
				ALPHAMAP_GATHERING_HEADER,
				ALPHAMAP_GATHERING_HEADER_INFO
			);
			Cosmos_RegisterConfiguration(
				"COS_ALPHAMAP_GATHERING",
				"CHECKBOX",
				ALPHAMAP_GATHERING,
				ALPHAMAP_GATHERING_INFO,
				ToggleAlphaMapGathering,
				AlphaMapConfig.gathering
			);
			Cosmos_RegisterConfiguration(
				"COS_ALPHAMAP_MNGTIPS",
				"CHECKBOX",
				ALPHAMAP_MNGTIPS,
				ALPHAMAP_MNGTIPS_INFO,
				ToggleAlphaMapMngtips,
				AlphaMapConfig.mngtips
			);
		end
		if (GatherConfig) then
			Cosmos_RegisterConfiguration(
				"COS_ALPHAMAP_GATHERER_HEADER",
				"SEPARATOR",
				ALPHAMAP_GATHERER_HEADER,
				ALPHAMAP_GATHERER_HEADER_INFO
			);
			Cosmos_RegisterConfiguration(
				"COS_ALPHAMAP_GATHERER",
				"CHECKBOX",
				ALPHAMAP_GATHERER,
				ALPHAMAP_GATHERER_INFO,
				ToggleAlphaMapGatherer,
				AlphaMapConfig.gatherer
			);
			Cosmos_RegisterConfiguration(
				"COS_ALPHAMAP_GTIPS",
				"CHECKBOX",
				ALPHAMAP_GTIPS,
				ALPHAMAP_GTIPS_INFO,
				ToggleAlphaMapGtips,
				AlphaMapConfig.gtips
			);
		end
	end
end

-- Called whenever AlphaMap is sent an event notification
function AlphaMapFrame_OnEvent()
	if ( event == "WORLD_MAP_UPDATE" ) then
		AlphaMapFrame_Update();
	
	elseif( event == "ZONE_CHANGED_NEW_AREA" ) then
		SetMapToCurrentZone();
	
	elseif ( event == "PLAYER_REGEN_DISABLED" and AlphaMapConfig.combat == true ) then
		this:Hide();
	
	elseif ( event == "PLAYER_REGEN_ENABLED" and AlphaMapConfig.enabled == true ) then
		this:Show();
	
	elseif( event == "VARIABLES_LOADED") then
	
		AlphaMap_LoadCount = AlphaMap_LoadCount + 1;
		
--		DEFAULT_CHAT_FRAME:AddMessage( "AlphaMap: Variables Loaded!" );
	
		if( AlphaMapConfig.enabled==nil ) then
			AlphaMapConfig.enabled = false;
		end
		
		if( not AlphaMapConfig.alpha ) then
			AlphaMapConfig.alpha = 0.5;
		end
		
		if( not AlphaMapConfig.scale ) then
			AlphaMapConfig.scale = 0.8;
		end
		
		if( AlphaMapConfig.lock == nil ) then
			AlphaMapConfig.lock = false;
		end
		
		if( AlphaMapConfig.combat  == nil ) then
			AlphaMapConfig.combat = true;
		end
		
		if( AlphaMapConfig.ptips  == nil ) then
			AlphaMapConfig.ptips = true;
		end
		
		if( AlphaMapConfig.gtips  == nil ) then
			AlphaMapConfig.gtips = false;
		end
		
		if( AlphaMapConfig.mntips  == nil ) then
			AlphaMapConfig.mntips = false;
		end
		
		if( AlphaMapConfig.mngtips  == nil ) then
			AlphaMapConfig.mngtips = false;
		end
		
		if( AlphaMapConfig.wmclose  == nil ) then
			AlphaMapConfig.wmclose = true;
		end
		
		if( AlphaMapConfig.gathering  == nil ) then
			AlphaMapConfig.gathering = false;
		end
		
		if( AlphaMapConfig.gatherer  == nil ) then
			AlphaMapConfig.gatherer = false;
		end
		
		if( AlphaMapConfig.mapnotes  == nil ) then
			AlphaMapConfig.mapnotes = false;
		end
		
		if( AlphaMapConfig.raid  == nil ) then
			AlphaMapConfig.raid = true;
		end
		
		if( AlphaMapConfig.sliderlock  == nil ) then
			AlphaMapConfig.sliderlock = true;
		end	
		
		if( AlphaMapConfig.slider == nil ) then
			AlphaMapConfig.slider = true;
		end
		
		if( AlphaMapConfig.slider == false ) then
			HideUIPanel( AlphaMapSliderFrame );
		end
		
		AlphaMapDetailFrame:SetAlpha( AlphaMapConfig.alpha );
		AlphaMapSliderFrame:SetValue( 1 - AlphaMapConfig.alpha );

		-- If there is 1 alpha, then hide the markers
		if( AlphaMapConfig.alpha == 0.0 ) then
			AlphaMapUnits:Hide();
		else
			AlphaMapUnits:Show();
		end
		AlphaMap_Register();
		--AlphaMap_RegisterCosmos();
	end
end


-- Helper function to compute UV coords to draw pins
function AlphaMap_GetPOITextureCoords( index )
	local alphaMapIconDimension = AlphaMapPOI1Texture:GetWidth();
	local xCoord1, xCoord2, yCoord1, yCoord2; 
	local coordIncrement = alphaMapIconDimension / ALPHAMAP_POI_TEXTURE_WIDTH;
	
	xCoord1 = mod(index , NUM_ALPHAMAP_POI_COLUMNS) * coordIncrement;
	xCoord2 = xCoord1 + coordIncrement;
	yCoord1 = floor(index / NUM_ALPHAMAP_POI_COLUMNS) * coordIncrement;
	yCoord2 = yCoord1 + coordIncrement;
	
	return xCoord1, xCoord2, yCoord1, yCoord2;
end


-- Called every frame to update the AlphaMap
function AlphaMapFrame_Update()
	local mapFileName, textureHeight = GetMapInfo();
	
	if ( not mapFileName ) then
		mapFileName = "World";
	end
	
	for i=1, NUM_ALPHAMAP_DETAIL_TILES, 1 do
		getglobal("AlphaMapDetailTile"..i):SetTexture("Interface\\WorldMap\\"..mapFileName.."\\"..mapFileName..i);
	end		
	
	-- Setup the POI's
	-- This should be moved out of here
	local numPOIs = GetNumMapLandmarks();
	local name, textureIndex, x, y;
	local alphaMapPOI;
	local x1, x2, y1, y2;
	
	-- Iterate through each of the Points of interest
	for i=1, NUM_ALPHAMAP_POIS, 1 do
	
		-- Get the current point of interest
		alphaMapPOI = getglobal( "AlphaMapPOI"..i );
		
		-- Check if the current POI is a valid POI
		if ( i <= numPOIs ) then
			name, description, textureIndex, x, y = GetMapLandmarkInfo( i );
			x1, x2, y1, y2 = AlphaMap_GetPOITextureCoords( textureIndex );
			
			-- Set the texture coordinates
			getglobal( alphaMapPOI:GetName().."Texture" ):SetTexCoord( x1, x2, y1, y2 );
			x =  x * AlphaMapUnits:GetWidth();
			y = -y * AlphaMapUnits:GetHeight();
			
			alphaMapPOI:SetPoint( "CENTER", "AlphaMapUnits", "TOPLEFT", x, y );
			alphaMapPOI.name = name;
			alphaMapPOI:Show();
		else
			alphaMapPOI:Hide();
		end
	end
	
	-- Overlay stuff
	local numOverlays = GetNumMapOverlays();
	local textureName, textureWidth, textureHeight, offsetX, offsetY, mapPointX, mapPointY;
	local textureCount = 1;
	local texture;
	local texturePixelWidth, textureFileWidth, texturePixelHeight, textureFileHeight;
	local numTexturesWide, numTexturesTall;
	
	for i=1, numOverlays do
		textureName, textureWidth, textureHeight, offsetX, offsetY, mapPointX, mapPointY = GetMapOverlayInfo(i);
		numTexturesWide = ceil(textureWidth/256);
		numTexturesTall = ceil(textureHeight/256);
		
		for j=1, numTexturesTall do
			if ( j < numTexturesTall ) then
				texturePixelHeight = 256;
				textureFileHeight = 256;
			else
				texturePixelHeight = mod(textureHeight, 256);
				if ( texturePixelHeight == 0 ) then
					texturePixelHeight = 256;
				end
				textureFileHeight = 16;
				while(textureFileHeight < texturePixelHeight) do
					textureFileHeight = textureFileHeight * 2;
				end
			end
			for k=1, numTexturesWide do
				if ( textureCount > NUM_ALPHAMAP_OVERLAYS ) then
					message(ALPHAMAP_TOOMANYMAPOVERLAY);
					return;
				end
				texture = getglobal("AlphaMapOverlay"..textureCount);
				if ( k < numTexturesWide ) then
					texturePixelWidth = 256;
					textureFileWidth = 256;
				else
					texturePixelWidth = mod(textureWidth, 256);
					if ( texturePixelWidth == 0 ) then
						texturePixelWidth = 256;
					end
					textureFileWidth = 16;
					while(textureFileWidth < texturePixelWidth) do
						textureFileWidth = textureFileWidth * 2;
					end
				end
				texture:SetWidth(texturePixelWidth);
				texture:SetHeight(texturePixelHeight);
				texture:SetTexCoord(0, texturePixelWidth/textureFileWidth, 0, texturePixelHeight/textureFileHeight);
				texture:ClearAllPoints();
				texture:SetPoint("TOPLEFT", "AlphaMapDetailFrame", "TOPLEFT", offsetX + (256 * (k-1)), -(offsetY + (256 * (j - 1))));
				texture:SetTexture(textureName..(((j - 1) * numTexturesWide) + k));
				texture:Show();
				textureCount = textureCount +1;
			end
		end
	end
	for i=textureCount, NUM_ALPHAMAP_OVERLAYS do
		getglobal("AlphaMapOverlay"..i):Hide();
	end
	
	if( AlphaMapConfig.scale ) then 
		AlphaMapFrame:SetScale( AlphaMapConfig.scale ); 
	end
end


-- Called to toggle visibility of the AlphaMap
function ToggleAlphaMap(toggle)
	if (not toggle) then
		AlphaMapConfig.enabled = not AlphaMapFrame:IsVisible();
		if (AlphaMapConfig.enabled) then
			toggle = 1;
		else
			toggle = 0;
		end
	else
		AlphaMapConfig.enabled = ( toggle==1 );
	end

	if ( not AlphaMapConfig.enabled ) then
		AlphaMapFrame.UserHidden = true;
		AlphaMapFrame:Hide();
	else
		SetupWorldMapScale(WorldMapFrame);
		AlphaMapFrame:Show();
	end
	
	if (Khaos) then
		--Khaos.setSetKeyParameter("AlphaMap", "AlphaMapEnabled", "checked", AlphaMapConfig.enabled);
	end
	if ( Cosmos_RegisterConfiguration ) then
		Cosmos_UpdateValue("COS_ALPHAMAP_ENABLED",CSM_CHECKONOFF,toggle);
	end
	if ( Cosmos_SetCVar ) then
		Cosmos_SetCVar("COS_ALPHAMAP_ENABLED_X", toggle);
	end
end

function ToggleSlider()
	if ( AlphaMapSliderFrame:IsVisible() ) then
		AlphaMapSliderFrame:Hide();
		AlphaMapConfig.slider = false;
	else
		AlphaMapSliderFrame:Show();
		AlphaMapConfig.slider = true;
	end
end

-- Helper function to increment the opacity by .10
function IncrementAlphaMap()

	-- Determine the transparency from the alpha slider
	local alpha = 1.0 - AlphaMapSliderFrame:GetValue();

	-- Increment the opacity
	alpha = alpha + ALPHAMAP_INCREMENT;

	local slider = 0;
	if (AlphaMapConfig.slider) then
		slider = 1;
	end
	AlphaMap_Alpha_Set(slider,alpha);
end


-- Helper function to decrement the opacity by .10
function DecrementAlphaMap()
	
	-- Determine the transparency from the alpha slider
	local alpha = 1.0 - AlphaMapSliderFrame:GetValue();

	-- Increment the opacity
	alpha = alpha - ALPHAMAP_INCREMENT;

	local slider = 0;
	if (AlphaMapConfig.slider) then
		slider = 1;
	end
	AlphaMap_Alpha_Set(slider,alpha);
end


-- Called every frame to update the pin overlays on the AlphaMap
function AlphaMapUnits_OnUpdate()
		
	-- Get Zone/Continent Info
	local zone		= GetCurrentMapZone();
	local continent = GetCurrentMapContinent();
	
	--Position player
	local playerX, playerY = GetPlayerMapPosition("player");
	if ( playerX == 0 and playerY == 0 ) then
		AlphaMapMinimap:Hide();
	else
		playerX = playerX *  AlphaMapDetailFrame:GetWidth();
		playerY = -playerY * AlphaMapDetailFrame:GetHeight();
		
		AlphaMapMinimap:SetPoint("CENTER", "AlphaMapDetailFrame", "TOPLEFT", playerX, playerY);
		AlphaMapMinimap:Show();
	end
	
	-- Update Position info
	playerX, playerY = GetPlayerMapPosition("player");
	AlphaMapLocationText:SetText( format( "%d, %d", playerX * 100.0, playerY * 100.0) );
	
	--Position groupmates
	local partyX, partyY, partyMemberFrame;
	if( GetNumRaidMembers() > 0 and AlphaMapConfig.raid == true ) then
		for i=1, MAX_PARTY_MEMBERS do
			partyMemberFrame = getglobal("AlphaMapParty"..i);
			partyMemberFrame:Hide();
		end
		for i=1, MAX_RAID_MEMBERS do
			partyX, partyY = GetPlayerMapPosition( "raid"..i );
			partyMemberFrame = getglobal( "AlphaMapRaid"..i );
			if ( partyX == 0 and partyY == 0 or UnitIsUnit( "raid"..i, "player" ) ) then
				partyMemberFrame:Hide();
			else
				partyX =  partyX * AlphaMapDetailFrame:GetWidth();
				partyY = -partyY * AlphaMapDetailFrame:GetHeight();
				partyMemberFrame:SetPoint( "CENTER", "AlphaMapDetailFrame", "TOPLEFT", partyX, partyY);
				partyMemberFrame:Show();
			end
		end
	else
		for i=1, MAX_PARTY_MEMBERS do
			partyX, partyY = GetPlayerMapPosition("party"..i);
			partyMemberFrame = getglobal("AlphaMapParty"..i);
			if ( partyX == 0 and partyY == 0 ) then
				partyMemberFrame:Hide();
			else
				partyX = partyX * AlphaMapDetailFrame:GetWidth();
				partyY = -partyY * AlphaMapDetailFrame:GetHeight();
				partyMemberFrame:SetPoint("CENTER", "AlphaMapDetailFrame", "TOPLEFT", partyX, partyY);
				partyMemberFrame:Show();
			end
		end
		for i=1, MAX_RAID_MEMBERS do
			partyMemberFrame = getglobal("AlphaMapRaid"..i);
			partyMemberFrame:Hide();
		end
	end
	
	--Position corpse
	local corpseX, corpseY = GetCorpseMapPosition();
	if ( corpseX == 0 and corpseY == 0 ) then
		AlphaMapCorpse:Hide();
	else
		corpseX = corpseX * AlphaMapDetailFrame:GetWidth();
		corpseY = -corpseY * AlphaMapDetailFrame:GetHeight();
		
		AlphaMapCorpse:SetPoint("CENTER", "AlphaMapDetailFrame", "TOPLEFT", corpseX, corpseY);
		AlphaMapCorpse:Show();
	end
	
	-- /////////////////////////////////////////////////////////////////
	-- MapNotes 0.5.3 Pins
	-- ////////////////////////////////////////////////////////////////
	
	-- Check if we're in a valid zone and MapNotes is active
	if( zone ~= 0 and MapNotes_Options and AlphaMapConfig.mapnotes == true ) then
		local n = 1;
		
		-- Iterate through the saved MapNotes
		for i, value in MapNotes_Data[continent][zone] do
			
			local temp = getglobal( "AlphaMapNotesPOI"..i );
			temp:SetPoint("CENTER", "AlphaMapDetailFrame", "TOPLEFT", ( MapNotes_Data[continent][zone][i].xPos)*AlphaMapDetailFrame:GetWidth(), -(MapNotes_Data[continent][zone][i].yPos)*AlphaMapDetailFrame:GetHeight() );
		
			local myTexture = getglobal( "AlphaMapNotesPOI"..i.."Texture" );
			myTexture:SetTexture( "Interface\\AddOns\\MapNotes\\POIIcons\\Icon"..MapNotes_Data[continent][zone][i].icon );
				
			if( MapNotes_Options[ MapNotes_Data[continent][zone][i].icon ] ~= "off" and ((MapNotes_Options[10] ~= "off" and MapNotes_Data[continent][zone][i].creator == UnitName("player")) or (MapNotes_Options[11] ~= "off" and MapNotes_Data[continent][zone][i].creator ~= UnitName("player")))) then
				temp:Show();
			else
				temp:Hide();
			end
			n = n + 1;
		end
		
		-- Hide all the others
		for i=n, NUM_ALPHAMAP_MAPNOTE_POIS, 1 do
			getglobal( "AlphaMapNotesPOI"..i ):Hide();
			end
	else
		for i=1, NUM_ALPHAMAP_MAPNOTE_POIS, 1 do
			getglobal("AlphaMapNotesPOI"..i):Hide();
		end
	end
		
	-- ////////////////////////////////////////////////////////////////
	-- MapNotes Gathering 0.5.6 Pins
	-- ////////////////////////////////////////////////////////////////
	
	if( zone ~= 0 and MapNotesGathering_Data and AlphaMapConfig.gathering == true ) then
		for i=1, getn( MapNotesGathering_Data[continent][zone] ), 1 do
			
			local temp = getglobal( "AlphaMapGatheringPOI"..i );
			local icon = MapNotesGathering_Data[continent][zone][i].icon;
		
			if (icon ~= nil and icon ~= 0) then --workaround for the bug in the first version...
				if ((MapNotes_Options.showherbs and icon > 9 and icon <= 38 and 
				    MapNotes_Options["Gathering"][icon] ~= "off") or 
				    (MapNotes_Options.showveins and icon <= 9 and 
				    MapNotes_Options["Gathering"][icon] ~= "off") or 
				    (MapNotes_Options.showchests and icon >= 39)) then
					temp:SetPoint("CENTER", "AlphaMapDetailFrame", "TOPLEFT", (MapNotesGathering_Data[continent][zone][i].xPos)*AlphaMapDetailFrame:GetWidth(), -(MapNotesGathering_Data[continent][zone][i].yPos)*AlphaMapDetailFrame:GetHeight());
					getglobal("AlphaMapGatheringPOI"..i.."Texture"):SetTexture("Interface\\AddOns\\MapNotesGathering\\POIIcons\\Icon"..icon);
					temp:Show();
				else
					temp:Hide();
				end
			else
				temp:Hide();
			end
		end
		for i=(getn( MapNotesGathering_Data[continent][zone])+1 ), NUM_ALPHAMAP_GATHERNOTE_POIS, 1 do
			getglobal("AlphaMapGatheringPOI"..i):Hide();
		end
	else
		for i=1, NUM_ALPHAMAP_GATHERNOTE_POIS, 1 do
			getglobal("AlphaMapGatheringPOI"..i):Hide();
		end
	end
	
	-- ////////////////////////////////////////////////////////////////
	-- Gatherer 1.9.12 Pins
	-- ////////////////////////////////////////////////////////////////
	
	DrawAlphaMapGatherer();
	
end


-- Helper function to set the opacity of the AlphaMap
function SetAlphaMapOpacity()

	-- Determine the transparency from the alpha slider
	local alpha = 1.0 - this:GetValue();	
	local slider = 0;
	if (AlphaMapConfig.slider) then
		slider = 1;
	end
	AlphaMap_Alpha_Set(slider,alpha);
end

-- Function to extract the next param from the command line
function AlphaMap_Extract_NextParameter(msg)
	local params = msg;
	local command = params;
	local index = strfind(command, " ");
	if ( index ) then
		command = strsub(command, 1, index-1);
		params = strsub(params, index+1);
	else
		params = "";
	end
	return command, params;
end

-- Function to handle slash commands
function AlphaMap_Main_ChatCommandHandler(msg)
	local commandName, params = AlphaMap_Extract_NextParameter(msg);
	if ((commandName) and (strlen(commandName) > 0)) then
		commandName = string.lower(commandName);
	else
		commandName = "";
	end
	
	-- Check if we should toggle on/off the AlphaMap
	if( strfind( commandName, "tog" ) ) then
		ToggleAlphaMap();
		
	-- Check if we should lock the UI
	elseif( strfind( commandName, "lock" ) ) then
	
		AlphaMapConfig.lock = not AlphaMapConfig.lock;
		
		 if( AlphaMapConfig.lock == true ) then
			DEFAULT_CHAT_FRAME:AddMessage( ALPHAMAP_UILOCKED );
		 else
			DEFAULT_CHAT_FRAME:AddMessage( ALPHAMAP_UIUNLOCKED );
		 end
		
	-- Check if we should scale the window
	elseif( strfind( commandName, "scale" ) ) then
		AlphaMapConfig.scale = tonumber(params);
		
		if( not AlphaMapConfig.scale or AlphaMapConfig.scale < 0.0 ) then 
			AlphaMapConfig.scale = 1.0; 
		end
		
		AlphaMapFrame:SetScale( AlphaMapConfig.scale );
		
	-- Check if we should allow movement of the slider
	-- NOTE: This must be checked BEFORE "slider"
	elseif( strfind(commandName, "moveslider" ) ) then
		AlphaMapConfig.sliderlock = not AlphaMapConfig.sliderlock;
		
		if( AlphaMapConfig.sliderlock == false ) then
			DEFAULT_CHAT_FRAME:AddMessage( ALPHAMAP_SLIDERUNLOCKED );
		else
			DEFAULT_CHAT_FRAME:AddMessage( ALPHAMAP_SLIDERLOCKED );
		end	
		
	-- Check if we should Toggle on/off display of the slider
	elseif (strfind(commandName, "slider")) then
		 ToggleSlider();
	
	--  Check if we should autoclose AM on combat
	elseif (strfind(commandName, "combat")) then
		 AlphaMapConfig.combat = not AlphaMapConfig.combat;
		 
		 if( AlphaMapConfig.combat == true ) then
			DEFAULT_CHAT_FRAME:AddMessage( ALPHAMAP_COMBATCLOSEENABLE );
		 else
			DEFAULT_CHAT_FRAME:AddMessage( ALPHAMAP_COMBATCLOSEDISABLE );
		 end
		 
	--  Check if we should show raid pins
	elseif (strfind(commandName, "raid")) then
		 AlphaMapConfig.raid = not AlphaMapConfig.raid;
		 
		 if( AlphaMapConfig.raid == true ) then
			DEFAULT_CHAT_FRAME:AddMessage( ALPHAMAP_RAIDPINENABLE );
		 else
			DEFAULT_CHAT_FRAME:AddMessage( ALPHAMAP_RAIDPINDISABLE );
		 end
		 
	-- check if we should display party/raid tooltips
	elseif (strfind(commandName, "ptips")) then
		AlphaMapConfig.ptips = not AlphaMapConfig.ptips;
		
		if( AlphaMapConfig.ptips == true ) then
			DEFAULT_CHAT_FRAME:AddMessage( ALPHAMAP_PARTYTIPENABLE );
		else
			DEFAULT_CHAT_FRAME:AddMessage( ALPHAMAP_PARTYTIPDISABLE );
		end
		
	-- check if we should display Gatherer tooltips
	elseif( strfind( commandName, "mntips" ) ) then
		AlphaMapConfig.mntips = not AlphaMapConfig.mntips;
		
		if( AlphaMapConfig.mntips == true ) then
			DEFAULT_CHAT_FRAME:AddMessage( ALPHAMAP_MAPNOTETIPENABLE );
		else
			DEFAULT_CHAT_FRAME:AddMessage( ALPHAMAP_MAPNOTETIPDISABLE );
		end
		
	-- check if we should display Gatherer tooltips
	elseif( strfind( commandName, "mngtips" ) ) then
		AlphaMapConfig.mngtips = not AlphaMapConfig.mngtips;
		
		if( AlphaMapConfig.mngtips == true ) then
			DEFAULT_CHAT_FRAME:AddMessage( ALPHAMAP_MNGTIPSENABLE );
		else
			DEFAULT_CHAT_FRAME:AddMessage( ALPHAMAP_MNGTIPSDISABLE );
		end
		
	-- check if we should display Gatherer tooltips
	elseif (strfind(commandName, "gtips")) then
		AlphaMapConfig.gtips = not AlphaMapConfig.gtips;
		
		if( AlphaMapConfig.gtips == true ) then
			DEFAULT_CHAT_FRAME:AddMessage( ALPHAMAP_GTIPSENABLE );
		else
			DEFAULT_CHAT_FRAME:AddMessage( ALPHAMAP_GTIPSDISABLE );
		end
		 
	-- Check if we should set the alpha
	elseif (strfind(commandName, "alpha")) then
		AlphaMapConfig.alpha = tonumber(params);

		local slider = 0;
		if (AlphaMapConfig.slider) then
			slider = 1;
		end
		AlphaMap_Alpha_Set(slider,alpha);
	
	-- Check if we should close AlphaMap when the World Map Closes
	elseif (strfind(commandName, "wmclose")) then
		AlphaMapConfig.wmclose = not AlphaMapConfig.wmclose;
		
		if( AlphaMapConfig.wmclose == true ) then
			DEFAULT_CHAT_FRAME:AddMessage( ALPHAMAP_WMCLOSEENABLE );
		else
			DEFAULT_CHAT_FRAME:AddMessage( ALPHAMAP_WMCLOSEDISABLE );
		end
		
	-- Check if we should show MapNotes Gathering Pins
	elseif (strfind(commandName, "gathering")) then
		AlphaMapConfig.gathering = not AlphaMapConfig.gathering;
		
		if( AlphaMapConfig.gathering == true ) then
			DEFAULT_CHAT_FRAME:AddMessage( ALPHAMAP_GATHERINGENABLE );
		else
			DEFAULT_CHAT_FRAME:AddMessage( ALPHAMAP_GATHERINGDISABLE );
		end
		
	-- Check if we should show Gatherer Pins
	elseif (strfind(commandName, "gatherer")) then
		AlphaMapConfig.gatherer = not AlphaMapConfig.gatherer;
		
		if( AlphaMapConfig.gatherer == true ) then
			DEFAULT_CHAT_FRAME:AddMessage( ALPHAMAP_GATHERERENABLE );
		else
			DEFAULT_CHAT_FRAME:AddMessage( ALPHAMAP_GATHERERDISABLE );
		end
		
	-- Check if we should show MapNotes Pins
	elseif (strfind(commandName, "mapnotes")) then
		AlphaMapConfig.mapnotes = not AlphaMapConfig.mapnotes;
		
		if( AlphaMapConfig.mapnotes == true ) then
			DEFAULT_CHAT_FRAME:AddMessage( ALPHAMAP_MAPNOTESENABLE );
		else
			DEFAULT_CHAT_FRAME:AddMessage( ALPHAMAP_MAPNOTESDISABLE );
		end
				
	else
		-- If all else fails, output the help info
		--DEFAULT_CHAT_FRAME:AddMessage( "AlphaMap: /am [tog/lock/scale/slider/alpha/combat/ptips/wmclose/gatherer/gathering/mapnotes]" );
		
		DEFAULT_CHAT_FRAME:AddMessage( ALPHAMAP_USAGE1 );
		DEFAULT_CHAT_FRAME:AddMessage( ALPHAMAP_USAGE2 );
		DEFAULT_CHAT_FRAME:AddMessage( ALPHAMAP_USAGE3 );
		DEFAULT_CHAT_FRAME:AddMessage( ALPHAMAP_USAGE4 );
		DEFAULT_CHAT_FRAME:AddMessage( ALPHAMAP_USAGE5 );
		DEFAULT_CHAT_FRAME:AddMessage( ALPHAMAP_USAGE6 );
		DEFAULT_CHAT_FRAME:AddMessage( ALPHAMAP_USAGE7 );
		DEFAULT_CHAT_FRAME:AddMessage( ALPHAMAP_USAGE8 );
		DEFAULT_CHAT_FRAME:AddMessage( ALPHAMAP_USAGE9 );
		DEFAULT_CHAT_FRAME:AddMessage( ALPHAMAP_USAGE10 );
		DEFAULT_CHAT_FRAME:AddMessage( ALPHAMAP_USAGE11 );
		DEFAULT_CHAT_FRAME:AddMessage( ALPHAMAP_USAGE12 );
		DEFAULT_CHAT_FRAME:AddMessage( ALPHAMAP_USAGE13 );
		DEFAULT_CHAT_FRAME:AddMessage( ALPHAMAP_USAGE14 );
		DEFAULT_CHAT_FRAME:AddMessage( ALPHAMAP_USAGE15 );
		DEFAULT_CHAT_FRAME:AddMessage( ALPHAMAP_USAGE16 );
		DEFAULT_CHAT_FRAME:AddMessage( ALPHAMAP_USAGE17 );
	end
end


function DrawAlphaMapGatherer()

	local maxNotes = 500;
	local i = 1;
	
	if( GatherConfig and GatherConfig.useMainmap and AlphaMapConfig.gatherer == true ) then
	
		-- Get Current Conteninent and Zone
		local mapContinent  = GetCurrentMapContinent();
		local mapZone		= GetCurrentMapZone();
		
		if ((mapContinent ~= 0) and (mapZone ~= 0) and ( GatherItems[mapContinent] ) and 
				( GatherItems[mapContinent][mapZone] )) then
				
			-- Iterate through all the pins in the current zone
			for gatherName, gatherData in GatherItems[mapContinent][mapZone] do
				
				local gatherType   = "Default";
				local specificType = "";
				local allowed      = true;

				-- Check for specific types
				specificType = Gatherer_FindOreType(gatherName);
				if (specificType) then
					gatherType = "Ore";
					allowed = Gatherer_GetFilter("mining");
				else
					specificType = Gatherer_FindTreasureType(gatherName);
					if (specificType) then
						gatherType = "Treasure";
						allowed = Gatherer_GetFilter("treasure");
					else
						specificType = gatherName;
						gatherType = "Herb"; 
						allowed = Gatherer_GetFilter("herbs");
					end
				end
				
				if( not specificType ) then
					specificType = "default";
				end

				if( allowed ) then
					for hPos, gatherInfo in gatherData do
						if ((gatherInfo.x)   and (gatherInfo.y) and (gatherInfo.x>0) and 
						    (gatherInfo.y>0) and ( i <= maxNotes)) then
							
							-- Get the frame
							local mainNote = getglobal( "AlphaMapGathererPOI"..i );

							-- Determine coordinates for note
							local mnX,mnY;
							mnX =  gatherInfo.x / 100 * AlphaMapDetailFrame:GetWidth();
							mnY = -gatherInfo.y / 100 * AlphaMapDetailFrame:GetHeight();
							
							-- Set note properties
							--mainNote:SetAlpha(0.8);							
							mainNote:SetPoint( "CENTER", "AlphaMapDetailFrame", "TOPLEFT", mnX, mnY );
							mainNote:SetFrameLevel( this:GetFrameLevel() + 1 );
							mainNote.toolTip = Gatherer_TitleCase(specificType);

							if( not Gather_IconSet["iconic"][gatherType] ) then 
								gatherType = "Default"; 
							end
							
							local texture = Gather_IconSet["iconic"][gatherType][specificType];
							if( not texture ) then
								texture = Gather_IconSet["iconic"][gatherType]["default"];
							end

							local gathererTexture = getglobal( "AlphaMapGathererPOI"..i.."Texture" );
							gathererTexture:SetTexture( texture );
														
							mainNote:Show();
							
							i = i + 1;
						end
					end
				end
			end
		end
	end
	for j=i, maxNotes, 1 do
		local mainNote = getglobal( "AlphaMapGathererPOI"..j );
		mainNote:Hide();
	end
end



function AlphaMapNotes_OnEnter( id )

	if( MapNotes_Options and AlphaMapConfig.mntips == true ) then

		local x, y = this:GetCenter();
		local parentX, parentY = this:GetParent():GetCenter();
		
		if( x > parentX ) then
			AlphaMapTooltip:SetOwner( this, "ANCHOR_LEFT" );
		else
			AlphaMapTooltip:SetOwner( this, "ANCHOR_RIGHT" );
		end
			
		local zone		= MapNotes_ZoneShift[GetCurrentMapContinent()][GetCurrentMapZone()];
		local continent = GetCurrentMapContinent();
		local cNr		= MapNotes_Data[continent][zone][id].ncol;
		
		AlphaMapTooltip:SetText( MapNotes_Data[continent][zone][id].name, MapNotes_Colors[cNr].r, MapNotes_Colors[cNr].g, MapNotes_Colors[cNr].b);
		
		if ((MapNotes_Data[continent][zone][id].inf1 ~= nil) and (MapNotes_Data[continent][zone][id].inf1 ~= "")) then
			cNr = MapNotes_Data[continent][zone][id].in1c;
			AlphaMapTooltip:AddLine(MapNotes_Data[continent][zone][id].inf1, MapNotes_Colors[cNr].r, MapNotes_Colors[cNr].g, MapNotes_Colors[cNr].b);
		end
		if ((MapNotes_Data[continent][zone][id].inf2 ~= nil) and (MapNotes_Data[continent][zone][id].inf2 ~= "")) then
			cNr = MapNotes_Data[continent][zone][id].in2c;
			AlphaMapTooltip:AddLine(MapNotes_Data[continent][zone][id].inf2, MapNotes_Colors[cNr].r, MapNotes_Colors[cNr].g, MapNotes_Colors[cNr].b);
		end
		
		AlphaMapTooltip:AddDoubleLine( MAPNOTES_CREATEDBY, MapNotes_Data[continent][zone][id].creator, 0.49, 0.39, 0.0, 0.49, 0.39, 0.0 );
		AlphaMapTooltip:Show();
	end
end

function AlphaMapNotes_OnLeave( id )
	AlphaMapTooltip:Hide();
end



function AlphaNotesGathering_OnEnter(id)

	if( MapNotesGathering_Data and AlphaMapConfig.gathering == true ) then
	
		local x, y = this:GetCenter();
		local parentX, parentY = this:GetParent():GetCenter();
		
		if( x > parentX ) then
			AlphaMapTooltip:SetOwner( this, "ANCHOR_LEFT" );
		else
			AlphaMapTooltip:SetOwner( this, "ANCHOR_RIGHT" );
		end
		
		local zone		= GetCurrentMapZone();
		local continent = GetCurrentMapContinent();
		
		AlphaMapTooltip:SetText(MapNotesGathering_Names[MapNotesGathering_Data[continent][zone][id].icon][MapNotesGathering_Data[continent][zone][id].subname], MapNotes_Colors[0].r, MapNotes_Colors[0].g, MapNotes_Colors[0].b);
		
		local xPos = MapNotesGathering_Data[continent][zone][id].xPos;
		local yPos = MapNotesGathering_Data[continent][zone][id].yPos;
		
		for i=1, getn(MapNotesGathering_Data[continent][zone]), 1 do
			if (i ~= id and abs(MapNotesGathering_Data[continent][zone][i].xPos - xPos) <= 0.0009765625 * MapNotes_MinDiff and abs(MapNotesGathering_Data[continent][zone][i].yPos - yPos) <= 0.0013020833 * MapNotes_MinDiff) then
				local icon = MapNotesGathering_Data[continent][zone][i].icon;
				
				if ((MapNotes_Options.showherbs and icon > 9 and icon <= 38 and MapNotes_Options["Gathering"][icon] ~= "off") or (MapNotes_Options.showveins and icon <= 9 and MapNotes_Options["Gathering"][icon] ~= "off") or (MapNotes_Options.showchests and icon == 39)) then
					AlphaMapTooltip:AddLine(MapNotesGathering_Names[icon][MapNotesGathering_Data[continent][zone][i].subname], MapNotes_Colors[0].r, MapNotes_Colors[0].g, MapNotes_Colors[0].b);
				end
			end
		end
		AlphaMapTooltip:Show();
	end
end

function AlphaNotesGathering_OnLeave(id)
	AlphaMapTooltip:Hide();
end






