InformantLocalizations = {
	enUS = {
		CmdClearAll	= "all";
		CmdDefault	= "default";
		CmdDisable	= "disable";
		CmdEmbed	= "embed";
		CmdHelp	= "help";
		CmdLocale	= "locale";
		CmdOff	= "off";
		CmdOn	= "on";
		CmdToggle	= "toggle";
		OptLocale	= "<locale>";
		ShowIcon	= "show-icon";
		ShowQuest	= "show-quest";
		ShowID		= "show-id";
		ShowStack	= "show-stack";
		ShowUsage	= "show-usage";
		ShowVendor	= "show-vendor";
		ShowVendorSell	= "show-vendor-sell";


		-- Section: Generic Messages
		MesgNotLoaded	= "Informant is not loaded. Type /informant for more info.";
		StatOff	= "Not displaying any item informations";
		StatOn	= "Displaying configured item informations";
		Welcome	= "|c40ff50ffWelcome to Informant|r\n\nSince this is the first time you are using Informant, this message appears to let you know that you must set a key to show this window from within the |cffffffffKeybindings|r section of the |cffffffffGame Menu|r.\n\nFrom then on to view advanced information about items in your inventory, simply move your mouse over the item you want to see information about and press the key that you bound, and this window will popup, filled with information about that item.\n\nAt that point, simply press the key again, or click the close button on this frame.\n\nClick the close button now to continue.";


		-- Section: Help Text
		GuiDefaultAll	= "Reset All Informant Options";
		GuiDefaultAllButton	= "Reset All";
		GuiDefaultAllHelp	= "Click here to set all Informant options to their default values.\nWARNING: This action is NOT undoable.";
		GuiDefaultOption	= "Reset this setting";
		GuiEmbed	= "Embed info in in-game tooltip";
		GuiEmbedHeader	= "Embed";
		GuiInfoHeader	= "Additional information";
		GuiInfoHelp	= "Controls what additional information is shown in tooltips";
		GuiInfoIcon	= "Show inventory icon";
		GuiInfoQuest	= "Show quest information";
		GuiInfoStack	= "Show stack sizes";
		GuiInfoUsage	= "Show usage information";
		GuiLocale	= "Set locale to";
		GuiMainEnable	= "Enable Informant";
		GuiMainHelp	= "Contains settings for Informant \nan AddOn that displays detailed item information";
		GuiOtherHeader	= "Other Options";
		GuiOtherHelp	= "Miscellaneous Informant Options";
		GuiReloadui	= "Reload User Interface";
		GuiReloaduiButton	= "ReloadUI";
		GuiReloaduiFeedback	= "Now Reloading the WoW UI";
		GuiReloaduiHelp	= "Click here to reload the WoW User Interface after changing the locale so that the language in this configuration screen matches the one you selected.\nNote: This operation may take a few minutes.";
		GuiVendor	= "Show Vendor Prices";
		GuiVendorBuy	= "Show Vendor Buy Prices";
		GuiVendorHeader	= "Vendor Prices";
		GuiVendorHelp	= "Options related to NPC buy/sell prices.";
		GuiVendorSell	= "Show Vendor Sell Prices";
		HelpDefault	= "Set an informant option to it's default value. You may also specify the special keyword \"all\" to set all informant options to their default values.";
		HelpDisable	= "Stops Informant from automatically loading next time you log in";
		HelpEmbed	= "Embed the text in the original game tooltip (note: certain features are disabled when this is selected)";
		HelpIcon	= "Select whether to show the item's inventory icon";
		HelpLocale	= "Change the locale that is used to display informant messages";
		HelpOnoff	= "Turns the information data display on and off";
		GuiInfoID		= " ";
		HelpID		= "Show ItemID";
		HelpStack	= "Select whether to show the item's stackable size";
		HelpUsage	= "Select whether to show tradeskill items' usage";
		HelpVendor	= "Select whether to show item's vendor pricing";
		HelpVendorBuy	= "Select whether to show item's vendor buy pricing (req show-vendor=on)";
		HelpVendorSell	= "Select whether to show item's vendor sell pricing (req show-vendor=on)";


		-- Section: Keybinding Text
		BindingHeader	= "Informant";
		BindingTitle	= "Toggle Information Window";


		-- Section: Tooltip Messages
		FrameTitle	= "Informant Item Information";
		FrmtActDefault	= "Informant's %s option has been reset to its default setting";
		FrmtActDefaultall	= "All informant options have been reset to default settings.";
		FrmtActDisable	= "Not displaying item's %s data";
		FrmtActEnable	= "Displaying item's %s data";
		FrmtActEnabledOn	= "Displaying item's %s on %s";
		FrmtActSet	= "Set %s to '%s'";
		FrmtActUnknown	= "Unknown command keyword: '%s'";
		FrmtInfoClass	= "Class: %s";
		FrmtInfoID		= "ItemID: %d";
		FrmtInfoQuest	= "Quest item in %d quests";
		FrmtInfoSell	= "Sell to vendor";
		FrmtInfoSellmult	= "Sell %d (%s each)";
		FrmtInfoStx	= "Stacks in lots of %d";
		FrmtInfoUse	= "Used for: %s";
		FrmtUnknownLocale	= "The locale you specified ('%s') is unknown. Valid locales are:";
		FrmtWelcome	= "Informant v%s loaded /inf";
		InfoHeader	= "Information on |cff%s%s|r";
		InfoNoItem	= "You must first move over an item, then press the activation key";
		InfoPlayerMade	= "Made by level %d %s";
		InfoQuestHeader	= "Used in %d quests:";
		InfoQuestName	= "  %d for \"%s\" (level %d)";
		InfoQuestSource	= "Quest data supplied by";
		InfoVendorHeader	= "Available from %d merchants:";
		InfoVendorName	= "  %s";


		-- Section: Type Messages
		AdditAlcohol	= "Alcohol";
		AdditBuff	= "Buff";
		AdditDrink	= "Drink";
		AdditFirework	= "Firework";
		AdditFood	= "Food";
		AdditGiftwrap	= "Giftwrap";
		AdditLure	= "Lure";
		AdditPoison	= "Poison";
		AdditPotion	= "Potion";
		AdditRestorative	= "Restorative";
		AdditScroll	= "Scroll";
		SkillAlchemy	= "Alchemy";
		SkillBlacksmithing	= "Smithing";
		SkillCooking	= "Cooking";
		SkillDruid	= "Druid spells";
		SkillEnchanting	= "Enchanting";
		SkillEngineering	= "Engineering";
		SkillFirstAid	= "First Aid";
		SkillLeatherworking	= "Leatherworking";
		SkillMage	= "Mage spells";
		SkillMining	= "Mining";
		SkillPaladin	= "Paladin spells";
		SkillPriest	= "Priest spells";
		SkillRogue	= "Rogue skills";
		SkillShaman	= "Shaman spells";
		SkillTailoring	= "Tailoring";
		SkillWarlock	= "Warlock spells";

	};

	zhCN = {
		-- 命令
		CmdClearAll	= "all\229\133\168\233\131\168";
		CmdDefault	= "default启用默认设置";
		CmdDisable	= "disable\231\166\129\231\148\168";
		CmdEmbed	= "embed\229\181\140\229\133\165";
		CmdHelp	= "help显示帮助";
		CmdLocale	= "locale\229\156\176\229\159\159\228\187\163\231\160\129";
		CmdOff	= "off关";
		CmdOn	= "on开";
		CmdToggle	= "toggle开/关";
		OptLocale	= "<\229\156\176\229\159\159\228\187\163\231\160\129>";
		ShowIcon	= "show-icon显示图标";
		ShowStack	= "show-stack显示堆叠";
		ShowUsage	= "show-usage选择是否显示物品类型";
		ShowVendor	= "show-vendor显示商贩价格";
		ShowVendorSell	= "show-vendor-sell显示卖出价";


		-- Section: Generic Messages
		MesgNotLoaded	= "Informant\230\156\170\229\138\160\232\189\189\227\128\130\233\148\174\229\133\165/informant\230\156\137\230\155\180\229\164\154\228\191\161\230\129\175\227\128\130";
		StatOff	= "\228\184\141\230\152\190\231\164\186\228\187\187\228\189\149\231\137\169\229\147\129\228\191\161\230\129\175\227\128\130";
		StatOn	= "\230\152\190\231\164\186\232\174\190\229\174\154\231\154\132\231\137\169\229\147\129\228\191\161\230\129\175\227\128\130";


		-- Section: Help Text
		GuiDefaultAll	= "\233\135\141\231\189\174\229\133\168\233\131\168Informant\233\128\137\233\161\185\227\128\130";
		GuiDefaultAllButton	= "\233\135\141\231\189\174\229\133\168\233\131\168";
		GuiDefaultAllHelp	= "\231\130\185\230\173\164\233\135\141\231\189\174\229\133\168\233\131\168Informant\233\128\137\233\161\185\229\136\176\229\133\182\233\187\152\232\174\164\229\128\188\227\128\130\232\173\166\229\145\138\239\188\154\230\173\164\230\147\141\228\189\156\228\184\141\229\143\175\230\129\162\229\164\141\227\128\130";
		GuiDefaultOption	= "\233\135\141\231\189\174\230\173\164\232\174\190\231\189\174\227\128\130";
		GuiEmbed	= "\229\181\140\229\133\165\228\191\161\230\129\175\229\136\176\230\184\184\230\136\143\229\134\133\230\143\144\231\164\186\228\184\173\227\128\130";
		GuiEmbedHeader	= "\229\181\140\229\133\165";
		GuiInfoHeader	= "\232\161\165\229\133\133\228\191\161\230\129\175";
		GuiInfoHelp	= "\230\142\167\229\136\182\228\189\149\231\167\141\232\161\165\229\133\133\228\191\161\230\129\175\230\152\190\231\164\186\229\156\168\230\143\144\231\164\186\228\184\173\227\128\130";
		GuiInfoIcon	= "\230\152\190\231\164\186\232\180\162\231\155\174\229\155\190\230\160\135\227\128\130";
		GuiInfoQuest	= "\230\152\190\231\164\186\228\187\187\229\138\161\228\191\161\230\129\175\227\128\130";
		GuiInfoStack	= "\230\152\190\231\164\186\229\160\134\229\143\160\230\149\176\233\135\143\227\128\130";
		GuiInfoUsage	= "\230\152\190\231\164\186\231\148\168\233\128\148\228\191\161\230\129\175\227\128\130";
		GuiLocale	= "\232\174\190\231\189\174\229\156\176\229\159\159\228\187\163\231\160\129\228\184\186";
		GuiMainEnable	= "\229\144\175\231\148\168Informant\227\128\130";
		GuiMainHelp	= "\229\140\133\229\144\171\230\143\146\228\187\182 - Informant\231\154\132\232\174\190\231\189\174\227\128\130\229\174\131\231\148\168\228\186\142\230\152\190\231\164\186\232\175\166\231\187\134\231\137\169\229\147\129\228\191\161\230\129\175\227\128\130";
		GuiOtherHeader	= "\229\133\182\228\187\150\233\128\137\233\161\185";
		GuiOtherHelp	= "Informant\230\157\130\233\161\185";
		GuiReloadui	= "\233\135\141\230\150\176\229\138\160\232\189\189\231\148\168\230\136\183\231\149\140\233\157\162\227\128\130";
		GuiReloaduiButton	= "\233\135\141\232\189\189UI";
		GuiReloaduiFeedback	= "\231\142\176\229\156\168\230\173\163\233\135\141\230\150\176\229\138\160\232\189\189\233\173\148\229\133\189\231\148\168\230\136\183\231\149\140\233\157\162\227\128\130";
		GuiReloaduiHelp	= "\229\156\168\230\148\185\229\143\152\229\156\176\229\159\159\228\187\163\231\160\129\229\144\142\231\130\185\230\173\164\233\135\141\230\150\176\229\138\160\232\189\189\233\173\148\229\133\189\231\148\168\230\136\183\231\149\140\233\157\162\228\189\191\230\173\164\233\133\141\231\189\174\229\177\143\229\185\149\228\184\173\231\154\132\232\175\173\232\168\128\229\140\185\233\133\141\233\128\137\230\139\169\227\128\130\230\179\168\230\132\143\239\188\154\230\173\164\230\147\141\228\189\156\229\143\175\232\131\189\232\128\151\230\151\182\229\135\160\229\136\134\233\146\159\227\128\130";
		GuiVendor	= "\230\152\190\231\164\186\229\149\134\232\180\169\228\187\183\230\160\188\227\128\130";
		GuiVendorBuy	= "\230\152\190\231\164\186\229\149\134\232\180\169\230\148\182\232\180\173\228\187\183\227\128\130";
		GuiVendorHeader	= "\229\149\134\232\180\169\228\187\183\230\160\188\227\128\130";
		GuiVendorHelp	= "\229\133\179\228\186\142\233\157\158\231\142\169\229\174\182\232\167\146\232\137\178\228\185\176\229\141\150\228\187\183\230\160\188\231\154\132\233\128\137\233\161\185\227\128\130";
		GuiVendorSell	= "\230\152\190\231\164\186\229\149\134\232\180\169\229\135\186\229\148\174\228\187\183\227\128\130";
		HelpDefault	= "\233\135\141\231\189\174\228\184\128\228\184\170Informant\233\128\137\233\161\185\228\184\186\229\133\182\233\187\152\232\174\164\229\128\188\239\188\140\228\189\160\228\185\159\229\143\175\228\187\165\228\189\191\231\148\168\"all\"\230\157\165\233\135\141\231\189\174\230\137\128\230\156\137\233\128\137\233\161\185\228\184\186\229\133\182\233\187\152\232\174\164\229\128\188\227\128\130";
		HelpDisable	= "\233\152\187\230\173\162Informant\229\156\168\228\184\139\230\172\161\231\153\187\229\189\149\230\151\182\232\135\170\229\138\168\229\138\160\232\189\189\227\128\130";
		HelpEmbed	= "\229\181\140\229\133\165\230\150\135\229\173\151\232\135\179\229\142\159\229\167\139\230\184\184\230\136\143\230\143\144\231\164\186(\230\179\168\230\132\143\239\188\154\230\173\164\233\161\185\233\128\137\230\139\169\230\151\182\230\159\144\228\186\155\229\138\159\232\131\189\232\162\171\231\166\129\231\148\168)\227\128\130";
		HelpIcon	= "\233\128\137\230\139\169\230\152\175\229\144\166\230\152\190\231\164\186\231\137\169\229\147\129\231\154\132\232\180\162\231\155\174\229\155\190\230\160\135\227\128\130";
		HelpLocale	= "\230\148\185\229\143\152\231\148\168\228\186\142\230\152\190\231\164\186Informant\232\174\175\230\129\175\231\154\132\229\156\176\229\159\159\228\187\163\231\160\129\227\128\130";
		HelpOnoff	= "\230\137\147\229\188\128/\229\133\179\233\151\173\228\191\161\230\129\175\230\149\176\230\141\174\230\152\190\231\164\186\227\128\130";
		HelpStack	= "\233\128\137\230\139\169\230\152\175\229\144\166\230\152\190\231\164\186\229\143\175\229\160\134\229\143\160\230\149\176\233\135\143\227\128\130";
		HelpUsage	= "选择是否显示物品类型";
		HelpVendor	= "\233\128\137\230\139\169\230\152\175\229\144\166\230\152\190\231\164\186\229\149\134\232\180\169\228\187\183\230\160\188\227\128\130";
		HelpVendorBuy	= "\233\128\137\230\139\169\230\152\175\229\144\166\230\152\190\231\164\186\229\149\134\232\180\169\230\148\182\232\180\173\228\187\183\230\160\188(\233\156\128\232\166\129show-vendor=on)\227\128\130";
		HelpVendorSell	= "\233\128\137\230\139\169\230\152\175\229\144\166\230\152\190\231\164\186\229\149\134\232\180\169\233\148\128\229\148\174\228\187\183\230\160\188(\233\156\128\232\166\129show-vendor=on)\227\128\130";


		-- Section: Keybinding Text
		BindingHeader	= "Informant";
		BindingTitle	= "\229\188\128\229\133\179\232\189\172\230\141\162\228\191\161\230\129\175\231\170\151\229\143\163";


		-- Section: Tooltip Messages
		FrameTitle	= "Informant\231\137\169\229\147\129\228\191\161\230\129\175";
		FrmtActDefault	= "Informant\231\154\132%s\233\128\137\233\161\185\232\162\171\233\135\141\231\189\174\228\184\186\229\133\182\233\187\152\232\174\164\229\128\188\227\128\130";
		FrmtActDefaultall	= "\230\137\128\230\156\137Informant\233\128\137\233\161\185\232\162\171\233\135\141\231\189\174\228\184\186\233\187\152\232\174\164\229\128\188\227\128\130";
		FrmtActDisable	= "\228\184\141\230\152\190\231\164\186\231\137\169\229\147\129\231\154\132%s\230\149\176\230\141\174\227\128\130";
		FrmtActEnable	= "\230\152\190\231\164\186\231\137\169\229\147\129\231\154\132%s\230\149\176\230\141\174\227\128\130";
		FrmtActEnabledOn	= "\230\152\190\231\164\186\231\137\169\229\147\129\231\154\132%s\228\186\142%s\227\128\130";
		FrmtActSet	= "\232\174\190\231\189\174%s\228\184\186'%s'\227\128\130";
		FrmtActUnknown	= "\230\156\170\231\159\165\229\145\189\228\187\164\239\188\154'%s'\227\128\130";
		FrmtInfoClass	= "类型 %s";
		FrmtInfoID		= "物品ID %d";
		FrmtInfoQuest	= "%d\228\184\170\228\187\187\229\138\161\228\189\191\231\148\168\231\154\132\228\187\187\229\138\161\231\137\169\229\147\129";
		FrmtInfoSell	= "\229\148\174\228\186\142\229\149\134\232\180\169";
		FrmtInfoSellmult	= "单价 %s";
		FrmtInfoStx	= "每组堆叠 %d";
		FrmtInfoUse	= "\231\148\168\233\128\148:%s";
		FrmtUnknownLocale	= "\230\140\135\229\174\154\229\156\176\229\159\159\228\187\163\231\160\129('%s')\230\156\170\231\159\165\227\128\130\230\156\137\230\149\136\231\154\132\229\156\176\229\159\159\228\187\163\231\160\129\228\184\186\239\188\154";
		FrmtWelcome	= "Informant v%s \229\183\178\229\138\160\232\189\189\239\188\129";
		InfoHeader	= "|cff%s%s|r\231\154\132\228\191\161\230\129\175";
		InfoNoItem	= "\229\191\133\233\161\187\229\133\136\231\167\187\229\136\176\228\184\128\228\184\170\231\137\169\229\147\129\228\184\138\239\188\140\231\132\182\229\144\142\230\140\137\230\191\128\230\180\187\233\148\174\227\128\130";
		InfoPlayerMade	= "\231\148\177\231\173\137\231\186\167%d\231\154\132%s\229\136\182\228\189\156\227\128\130";
		InfoQuestHeader	= "\229\156\168%d\228\184\170\228\187\187\229\138\161\228\184\173\228\189\191\231\148\168\239\188\154";
		InfoQuestName	= "%d\228\184\186\"%s\"(\231\173\137\231\186\167%d)";
		InfoQuestSource	= "\228\187\187\229\138\161\230\149\176\230\141\174\230\143\144\228\190\155\232\128\133\230\152\175";
		InfoVendorHeader	= "%d\228\184\170\232\180\167\229\149\134\229\135\186\229\148\174\239\188\154";
		InfoVendorName	= "%s";


		-- Section: Type Messages
		AdditAlcohol	= "\233\133\146\231\178\190\233\165\174\230\150\153";
		AdditBuff	= "\229\162\158\231\155\138";
		AdditDrink	= "\233\165\174\230\150\153";
		AdditFirework	= "\231\132\176\231\129\171";
		AdditFood	= "\233\163\159\231\137\169";
		AdditGiftwrap	= "\231\164\188\229\147\129\229\140\133\232\163\133\231\186\184";
		AdditLure	= "\232\175\177\233\165\181";
		AdditPoison	= "\230\175\146\232\141\175";
		AdditPotion	= "\232\141\175\230\176\180";
		AdditRestorative	= "\230\187\139\232\161\165\229\137\130";
		AdditScroll	= "\229\141\183\232\189\180";
		SkillAlchemy	= "\231\130\188\233\135\145\230\156\175";
		SkillBlacksmithing	= "\233\148\187\233\128\160";
		SkillCooking	= "\231\131\185\233\165\170";
		SkillDruid	= "\229\190\183\233\178\129\228\188\138\233\173\148\230\179\149";
		SkillEnchanting	= "\233\153\132\233\173\148";
		SkillEngineering	= "\229\183\165\231\168\139\229\173\166";
		SkillFirstAid	= "\230\128\165\230\149\145";
		SkillLeatherworking	= "\229\136\182\231\154\174";
		SkillMage	= "\230\179\149\229\184\136\233\173\148\230\179\149";
		SkillMining	= "\233\135\135\231\159\191";
		SkillPaladin	= "\229\156\163\233\170\145\229\163\171\233\173\148\230\179\149";
		SkillPriest	= "\231\137\167\229\184\136\233\173\148\230\179\149";
		SkillRogue	= "\231\155\151\232\180\188\230\138\128\232\131\189";
		SkillShaman	= "\232\144\168\230\187\161\231\165\173\229\143\184\233\173\148\230\179\149";
		SkillTailoring	= "\232\163\129\231\188\157";
		SkillWarlock	= "\230\156\175\229\163\171\233\173\148\230\179\149";

	};
}