myProfile = {};
myProfile[GetCVar("realmName")] = {} ;
myProfile_LOADED =  nil;		-- Successful load of the script

--	//////////////////////////////////////////////
--		    Configuration Variables
--	//////////////////////////////////////////////
-- 	  set to nil to disable any of the following

myProfile_ENABLED 		= 	1;	-- Enable the profiler?
myProfile_DoScanInventory 	= 	1;	-- get inventory?
myProfile_DoScanBank 		= 	1;	-- get bank?
myProfile_DoScanEquipment 	= 	1;	-- get equipment?
myProfile_DoScanSkills 		=  	1;	-- get skills?
myProfile_DoScanTalents 	= 	1;	-- get talents?
myProfile_DoScanProfessions 	= 	1;	-- output known tradeskill recipies
myProfile_DoScanReputation	=	1;	-- get reputation?
myProfile_DoScanQuestLog	=	1;	-- get quests?
myProfile_DoScanHonor		=	1;	-- get honor?

myProfile_HTML_Tooltips 	= 	1;	-- make html tooltips (non-array format) - separate lines with <br>
myProfile_TALENTS_Full 		= 	1;	-- output all talents and tooltips


myProfile_DEBUG 		= 	nil;	-- enable debugging? unused at this time
myProfile_ALLEVENTS 		= 	nil;	-- enable all event catching? for debugging only

myProfile_TimeoutPeriod		= 	15;	-- Number of days to keep old profiles 				(see "todo" notes below)
--	//////////////////////////////////////////////

TradeSkillDifficultyCode = {};
TradeSkillDifficultyCode['optimal'] 	= 	4;
TradeSkillDifficultyCode['medium'] 	= 	3;
TradeSkillDifficultyCode['easy'] 	= 	2;
TradeSkillDifficultyCode['trivial'] 	=	1;
TradeSkillDifficultyCode['header'] 	= 	0;

myProfile_VERSION = "1.05";	-- this only changes when a new variable is added to the output
-- Add by Leoncx
-- Init time variable
timePlayed = -1;
timeLevelPlayed = -1;
-- End Add

-- array of inventory slot names
Profile_slots = {
  "Head",          -- 1
  "Neck",          -- 2
  "Shoulder",      -- 3
  "Shirt",         -- 4
  "Chest",         -- 5
  "Waist",         -- 6
  "Legs",          -- 7
  "Feet",          -- 8
  "Wrist",         -- 9
  "Hands",         -- 10
  "Finger0",       -- 11
  "Finger1",       -- 12
  "Trinket0",      -- 13
  "Trinket1",      -- 14
  "Back",          -- 15
  "MainHand",      -- 16
  "SecondaryHand", -- 17
  "Ranged",        -- 18
  "Tabard",        -- 19
};

function ProfileFrame_OnLoad()
	SimpleQuestLevel_OnLoad();
	this:RegisterEvent("UNIT_NAME_UPDATE");	
	this:RegisterEvent("PLAYER_GUILD_UPDATE");
	this:RegisterEvent("UNIT_INVENTORY_CHANGED");
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("TRAINER_CLOSED");
	this:RegisterEvent("PLAYER_LEVEL_UP");
	this:RegisterEvent("GUILD_ROSTER_UPDATE");
	--[[
	if ( myProfile_ALLEVENTS ) then					-- unused, but keep for testing
		Debug("HIHI");
		this:RegisterEvent("PLAYER_GUILD_UPDATE");
		this:RegisterEvent("UNIT_INVENTORY_CHANGED");
		this:RegisterEvent("VARIABLES_LOADED");
		this:RegisterEvent("TRAINER_CLOSED");
		this:RegisterEvent("PLAYER_LEVEL_UP");
	end
	]]
	this:RegisterEvent("TIME_PLAYED_MSG");
	--this:RegisterEvent("PLAYER_LEAVING_WORLD");	-- works with (after) reloadui
	this:RegisterEvent("BANKFRAME_CLOSED");		-- 12/17, was OPENED, will it work with closed only?

	this:RegisterEvent("TRADE_SKILL_SHOW");
	this:RegisterEvent("CRAFT_SHOW");

	--this:RegisterEvent("PLAYERBANKSLOTS_CHANGED"); -- may cause lag if they move items around fast, but we need to update the profile somehow

	SLASH_PROFILER1 = "/profiler";
	--SLASH_PROFILER2 = "/cp";
	SlashCmdList["PROFILER"] = function(msg)
		Profile_ChatCommand(msg);
		end
end

function Profile_ChatCommand(msg)
	if (msg) then
		msg = string.lower(msg);

		if (msg == "off") then
			Profiler_Toggle(0);
			return;
		elseif (msg == "on") then
			Profiler_Toggle(1);
			return;
		end
	end
	if( myProfile_ENABLED ) then
		DEFAULT_CHAT_FRAME:AddMessage("Character Profiler is currently enabled.", 1, 1, 1);
	else
		DEFAULT_CHAT_FRAME:AddMessage("Character Profiler is currently disabled.", 1, 1, 1);
	end		

	DEFAULT_CHAT_FRAME:AddMessage("Usage:", 1, 1, 1);
	DEFAULT_CHAT_FRAME:AddMessage("/cp on     -- Turns CharacterProfiler on", 1, 1, 1);
	DEFAULT_CHAT_FRAME:AddMessage("/cp off    -- Turns CharacterProfiler off", 1, 1, 1);
	DEFAULT_CHAT_FRAME:AddMessage("/cp        -- This Message", 1, 1, 1);
end

function Profiler_Toggle(toggle)
	if (toggle == 1) then
		myProfile_ENABLED = toggle;
		if (myProfile_LOADED) then
			DEFAULT_CHAT_FRAME:AddMessage("Character Profiler Enabled.\nAfter uploading your profile (check for updates), you can view your profile at\n http://www.cethinchimera.com/display_profile.cfm?character=" .. UnitName("player") .. "&server=" .. GetCVar("realmName"));
		end
	else
		myProfile_ENABLED = nil;
	end
	if ( not myProfile_ENABLED and myProfile[GetCVar("realmName")] ) then
		myProfile[GetCVar("realmName")][UnitName("player")] = nil;
	end
end


-- since PLAYER_QUITTING and PLAYER_CAMPING events don't work, hook the functions
-- NOTE: Due to server lag, this could be a cause of the client not actually logging the character out until the server catches up
oldLogout = Logout;
oldQuit = Quit;
function Quit()
	RequestTimePlayed();
	oldQuit();
end
function Logout()
	RequestTimePlayed();
	oldLogout();
end

function ProfileFrame_OnEvent(event, arg1, arg2)
	if (gLim_Thott_Enable ~= 1) then
		return;	
	end
	-- crapout if we're not ready to process, or if not enabled
	if ( ( event == "UNIT_INVENTORY_CHANGED" and arg1 ~= "player" ) or not myProfile_ENABLED or not UnitName("player") or UnitName("player") == UNKNOWNOBJECT or not GetCVar("realmName")) then
		return;
	end

	-- Got a unit name, now we're loaded
	if (event == "UNIT_NAME_UPDATE" and not myProfile_LOADED) then
		myProfile_LOADED = 1;
		PaperDollFrame_SetDamage();
		PaperDollFrame_SetRangedDamage();
		Profile_InitProfile();
	elseif (event == "UNIT_NAME_UPDATE" and myProfile_LOADED) then
		return;
	end
	if ( event == "VARIABLES_LOADED") then
		if(not GlimTooltipEnabled) then
			GlimTooltipEnabled = 1;
		end
		GlimTooltipRegister();
		return;
	end
	-- Add by LeonCX
	if (event == "TIME_PLAYED_MSG") then
	  	timePlayed = arg1;
	  	timeLevelPlayed = arg2;
		Profile_InitProfile();
		return;
	end
	-- End add by LeonCX
	if (event == "PLAYER_LEAVING_WORLD") then
		--Profile_InitProfile();
		return;
	end
	if (event == "GUILD_ROSTER_UPDATE ") then
		GetgLimuserGuild();
		return;
	end
	-- Event hit, process profile
	if (myProfile_LOADED) then
		--Profile_InitProfile();		-- Always do this first, creates a profile is it doesn't exist

		if( ( event == "BANKFRAME_CLOSED" or event == "BANKFRAME_OPENED" or event == "PLAYERBANKSLOTS_CHANGED" ) and myProfile_DoScanBank ) then
			Profile_ScanBank();
			Profile_InitProfile();
			return;
		end
		if ( not myProfile_DoScanBank and myProfile[GetCVar("realmName")][UnitName("player")] ) then
			myProfile[GetCVar("realmName")][UnitName("player")]["Bank"] = nil;
		end
		if ( myProfile_DoScanProfessions ) then
			if ( event == "TRADE_SKILL_SHOW" ) then
				Profile_ScanTradeSkill();
				return;
			end

			if ( event == "CRAFT_SHOW" ) then
				Profile_ScanCraft();
				return;
			end
		elseif ( myProfile[GetCVar("realmName")][UnitName("player")] ) then
			myProfile[GetCVar("realmName")][UnitName("player")]["Professions"] = nil;
		end
		return;
	end
end

function Profile_InitProfile()
	if ( not myProfile ) then
		myProfile = {};
	end
	
	if ( not myProfile[GetCVar("realmName")] ) then
		myProfile[GetCVar("realmName")] = {};
	end

	if ( not myProfile[GetCVar("realmName")][UnitName("player")] ) then
		myProfile[GetCVar("realmName")][UnitName("player")] = {};
	else
		local tmpBank = myProfile[GetCVar("realmName")][UnitName("player")]["Bank"];
		local tmpProfessions = myProfile[GetCVar("realmName")][UnitName("player")]["Professions"];

		myProfile[GetCVar("realmName")][UnitName("player")] = {};
		myProfile[GetCVar("realmName")][UnitName("player")]["Bank"] = tmpBank;
		myProfile[GetCVar("realmName")][UnitName("player")]["Professions"] = tmpProfessions;
	end
	
	myProfile[GetCVar("realmName")][UnitName("player")]["ProfilerVersion"] = myProfile_VERSION;	-- keep track of version and don't work with old data
	myProfile[GetCVar("realmName")][UnitName("player")]["Name"] = playerName;
	
	myProfile[GetCVar("realmName")][UnitName("player")]["DateUpdated"] = date();
	myProfile[GetCVar("realmName")][UnitName("player")]["TimePlayed"] = timePlayed;
	myProfile[GetCVar("realmName")][UnitName("player")]["TimeLevelPlayed"] = timeLevelPlayed;
	
	local sex = "";
	if (UnitSex("player") == 0) then
		sex = "Male";
	else
		sex = "Female";
	end
	myProfile[GetCVar("realmName")][UnitName("player")]["Sex"] = sex;
	myProfile[GetCVar("realmName")][UnitName("player")]["Race"] = UnitRace("player");
	myProfile[GetCVar("realmName")][UnitName("player")]["Class"] = UnitClass("player");
	myProfile[GetCVar("realmName")][UnitName("player")]["Level"] = UnitLevel("player");
	myProfile[GetCVar("realmName")][UnitName("player")]["Guild"] = {} ;
	myProfile[GetCVar("realmName")][UnitName("player")]["Guild"]["GuildName"], myProfile[GetCVar("realmName")][UnitName("player")]["Guild"]["Title"], myProfile[GetCVar("realmName")][UnitName("player")]["Guild"]["Rank"] = GetGuildInfo("player");
	myProfile[GetCVar("realmName")][UnitName("player")]["Server"] = GetCVar("realmName");
	myProfile[GetCVar("realmName")][UnitName("player")]["TalentPoints"] = UnitCharacterPoints("player");
	myProfile[GetCVar("realmName")][UnitName("player")]["Zone"] = GetZoneText();
	myProfile[GetCVar("realmName")][UnitName("player")]["SubZone"] = GetSubZoneText();

	myProfile[GetCVar("realmName")][UnitName("player")]["Experience"] = UnitXP("player") .. ":" .. UnitXPMax("player");

	local money = GetMoney();
	local gold = floor(money / (COPPER_PER_SILVER * SILVER_PER_GOLD));
	local silver = floor((money - (gold * COPPER_PER_SILVER * SILVER_PER_GOLD)) / COPPER_PER_SILVER);
	local copper = mod(money, COPPER_PER_SILVER);

	myProfile[GetCVar("realmName")][UnitName("player")]["Money"] = {};
	myProfile[GetCVar("realmName")][UnitName("player")]["Money"]["Gold"] = gold;
	myProfile[GetCVar("realmName")][UnitName("player")]["Money"]["Silver"] = silver;
	myProfile[GetCVar("realmName")][UnitName("player")]["Money"]["Copper"] = copper;

	myProfile[GetCVar("realmName")][UnitName("player")]["Stats"] = {};

	-- "stat" is the same as effectiveStat...
	-- problem here is if they have a debuff spell on, the values saved will be wrong
	local stat, effectiveStat, posBuff, negBuff = UnitStat("player", 1);
	myProfile[GetCVar("realmName")][UnitName("player")]["Stats"]["Strength"] = (stat - posBuff - negBuff) .. ":" .. effectiveStat .. ":" .. posBuff .. ":" .. negBuff;
	stat, effectiveStat, posBuff, negBuff = UnitStat("player", 2);
	myProfile[GetCVar("realmName")][UnitName("player")]["Stats"]["Agility"] = (stat - posBuff - negBuff) .. ":" .. effectiveStat .. ":" .. posBuff .. ":" .. negBuff;
	stat, effectiveStat, posBuff, negBuff = UnitStat("player", 3);
	myProfile[GetCVar("realmName")][UnitName("player")]["Stats"]["Stamina"] = (stat - posBuff - negBuff) .. ":" .. effectiveStat .. ":" .. posBuff .. ":" .. negBuff;
	stat, effectiveStat, posBuff, negBuff = UnitStat("player", 4);
	myProfile[GetCVar("realmName")][UnitName("player")]["Stats"]["Intellect"] = (stat - posBuff - negBuff) .. ":" .. effectiveStat .. ":" .. posBuff .. ":" .. negBuff;
	stat, effectiveStat, posBuff, negBuff = UnitStat("player", 5);
	myProfile[GetCVar("realmName")][UnitName("player")]["Stats"]["Spirit"] = (stat - posBuff - negBuff) .. ":" .. effectiveStat .. ":" .. posBuff .. ":" .. negBuff;

	myProfile[GetCVar("realmName")][UnitName("player")]["Resists"] = {};
	local base, resistance, positive, negative = UnitResistance("player", 6);
	myProfile[GetCVar("realmName")][UnitName("player")]["Resists"]["Arcane"] = base .. ":" .. resistance .. ":" .. positive .. ":" .. negative;
	base, resistance, positive, negative = UnitResistance("player", 2);
	myProfile[GetCVar("realmName")][UnitName("player")]["Resists"]["Fire"] = base .. ":" .. resistance .. ":" .. positive .. ":" .. negative;
	base, resistance, positive, negative = UnitResistance("player", 3);
	myProfile[GetCVar("realmName")][UnitName("player")]["Resists"]["Nature"] = base .. ":" .. resistance .. ":" .. positive .. ":" .. negative;
	base, resistance, positive, negative = UnitResistance("player", 4);
	myProfile[GetCVar("realmName")][UnitName("player")]["Resists"]["Frost"] = base .. ":" .. resistance .. ":" .. positive .. ":" .. negative;
	base, resistance, positive, negative = UnitResistance("player", 5);
	myProfile[GetCVar("realmName")][UnitName("player")]["Resists"]["Shadow"] = base .. ":" .. resistance .. ":" .. positive .. ":" .. negative;

	myProfile[GetCVar("realmName")][UnitName("player")]["Mana"] = UnitManaMax("player");
	myProfile[GetCVar("realmName")][UnitName("player")]["Health"] = UnitHealthMax("player");
	myProfile[GetCVar("realmName")][UnitName("player")]["Defense"] = UnitDefense("player");

	local baseArm, effectiveArmor, armor, positiveArm, negativeArm = UnitArmor("player");
	myProfile[GetCVar("realmName")][UnitName("player")]["Armor"] = baseArm .. ":" .. (baseArm + positiveArm) .. ":" .. positiveArm; -- if they have a debuf on, don't save it

	local minDamage, maxDamage, physicalBonusPos, physicalBonusNeg, percent = UnitDamage("player");
--	local baseDamage = (minDamage + maxDamage) * 0.5;
--	local fullDamage = (baseDamage + physicalBonusPos + physicalBonusNeg) * percent;
--	local totalBonus = (fullDamage - baseDamage);
--	local displayMin = floor(minDamage + totalBonus);
--	local displayMax = ceil(maxDamage + totalBonus);

	ProfileHiddenTooltip:SetText(INVTYPE_WEAPONMAINHAND, HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
	ProfileHiddenTooltip:AddDoubleLine(ATTACK_SPEED_COLON, CharacterDamageFrame.attackSpeed, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
	ProfileHiddenTooltip:AddDoubleLine(DAMAGE_COLON, CharacterDamageFrame.damage, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
	ProfileHiddenTooltip:AddDoubleLine(DAMAGE_PER_SECOND, CharacterDamageFrame.dps, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
	-- Check for offhand weapon
	if ( CharacterDamageFrame.offhandAttackSpeed ) then
		ProfileHiddenTooltip:AddLine("<br>");
		ProfileHiddenTooltip:AddLine(INVTYPE_WEAPONOFFHAND, HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
		ProfileHiddenTooltip:AddDoubleLine(ATTACK_SPEED_COLON, format("%.2f", CharacterDamageFrame.offhandAttackSpeed), NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
		ProfileHiddenTooltip:AddDoubleLine(DAMAGE_COLON, CharacterDamageFrame.offhandDamage, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
		ProfileHiddenTooltip:AddDoubleLine(DAMAGE_PER_SECOND, format("%.1f", CharacterDamageFrame.offhandDps), NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
	end

	myProfile[GetCVar("realmName")][UnitName("player")]["Melee Attack"] = {};
	myProfile[GetCVar("realmName")][UnitName("player")]["Melee Attack"]["AttackRating"] = UnitAttackBothHands("player");
	myProfile[GetCVar("realmName")][UnitName("player")]["Melee Attack"]["DamageRange"] = floor(minDamage) .. ":" .. ceil(maxDamage);
	myProfile[GetCVar("realmName")][UnitName("player")]["Melee Attack"]["AttackPower"] = UnitAttackPower("player");
	myProfile[GetCVar("realmName")][UnitName("player")]["Melee Attack"]["DamageRangeTooltip"] = strTooltip();
	myProfile[GetCVar("realmName")][UnitName("player")]["Melee Attack"]["AttackPowerTooltip"] = CharacterAttackPowerFrame.tooltipSubtext;

	-- Ranged not saved if there is no ranged weapon equipped
	if ( PaperDollFrame.noRanged ) then
		myProfile[GetCVar("realmName")][UnitName("player")]["Ranged Attack"] = nil;
	else
		ProfileHiddenTooltip:SetText(INVTYPE_RANGED, HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
		ProfileHiddenTooltip:AddDoubleLine(ATTACK_SPEED_COLON, CharacterRangedDamageFrame.attackSpeed, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
		ProfileHiddenTooltip:AddDoubleLine(DAMAGE_COLON, CharacterRangedDamageFrame.damage, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
		ProfileHiddenTooltip:AddDoubleLine(DAMAGE_PER_SECOND, CharacterRangedDamageFrame.dps, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);

		myProfile[GetCVar("realmName")][UnitName("player")]["Ranged Attack"] = {};
		myProfile[GetCVar("realmName")][UnitName("player")]["Ranged Attack"]["AttackPowerTooltip"] = CharacterRangedAttackPowerFrame.tooltipSubtext;
		myProfile[GetCVar("realmName")][UnitName("player")]["Ranged Attack"]["DamageRangeTooltip"] = strTooltip();

		local RangeSpeeed, RangeMinDMG,RangeMaxDMG = UnitRangedDamage("player");
		myProfile[GetCVar("realmName")][UnitName("player")]["Ranged Attack"]["DamageRange"] = max(floor(RangeMinDMG),1) .. ":" .. max(ceil(RangeMaxDMG),1);
		local base, pos, neg = UnitRangedAttackPower("player");
		if (not neg) then neg = 0; end;
		myProfile[GetCVar("realmName")][UnitName("player")]["Ranged Attack"]["AttackPower"] = base;
		local base, pos, neg = UnitRangedAttack("player");
		if (not neg) then neg = 0; end;
		myProfile[GetCVar("realmName")][UnitName("player")]["Ranged Attack"]["AttackRating"] = base;
	end

	myProfile[GetCVar("realmName")][UnitName("player")]["DodgePercent"] = strsub(GetDodgeChance(), 0, 5);
	myProfile[GetCVar("realmName")][UnitName("player")]["ParryPercent"] = strsub(GetParryChance(), 0, 5);
	myProfile[GetCVar("realmName")][UnitName("player")]["BlockPercent"] = strsub(GetBlockChance(), 0, 5);

	local MainAC, EffAC, AC, PosAC, NegAC = UnitArmor("player");
	local Level = UnitLevel("player");
	local Mitigation = (EffAC)/((85 * Level)+400);
	Mitigation = 100 * (Mitigation/(Mitigation + 1));
	Mitigation = strsub(Mitigation, 0, 5);
	myProfile[GetCVar("realmName")][UnitName("player")]["MitigationPercent"] = Mitigation;
	
	local spellIndex = 1;
	local spellName, subSpellName = GetSpellName(spellIndex,BOOKTYPE_SPELL);
	local tmpStr = nil;
	while spellName do	
		if (spellName == "Attack") then
			ProfileHiddenTooltip:SetSpell(spellIndex, BOOKTYPE_SPELL);
			tmpStr = string.gsub(strTooltip(), ".*<br/?>(%d?%d?%d%.%d%d?)%%.*", "%1");
			myProfile[GetCVar("realmName")][UnitName("player")]["CritPercent"] = tmpStr;
		end
		spellIndex = spellIndex + 1;
		spellName,subSpellName = nil;
		spellName,subSpellName = GetSpellName(spellIndex,BOOKTYPE_SPELL);
	end
	GetgLimuserGuild();
-- put in dps?

	myProfile[GetCVar("realmName")][UnitName("player")]["Locale"] = GetLocale();

	if ( myProfile_DoScanSkills ) then
		Profile_GetSkills();
	end
	if ( myProfile_DoScanEquipment) then
		Profile_UpdateInventory();
	end
	if ( myProfile_DoScanInventory ) then
		Profile_ScanInventory();
	end
	if ( myProfile_DoScanTalents and UnitLevel("player") > 9 ) then
		Profile_GetTalents();
	end
	--[[
	if ( myProfile_DoScanReputation ) then
		Profile_ScanReputation();
	end
	]]
	if ( myProfile_DoScanQuestLog ) then
		Profile_ScanQuests();
	end
	if ( myProfile_DoScanHonor ) then
		Profile_ScanHonor();
	end
	GetMySpells();
	Profile_GetSkills();
end

function Profile_ScanQuests() 
	local header = "Unknown"; 

	myProfile[GetCVar("realmName")][UnitName("player")]["Quests"] = {}; 
	local slot = 1;
	for i=1, GetNumQuestLogEntries(), 1 do 
		local text, level, questtag, isHeader, isCollapsed = GetQuestLogTitle(i); 
		if ( isHeader ) then 
			header = text; 
			myProfile[GetCVar("realmName")][UnitName("player")]["Quests"][header] = {} 
		else 
			if ( text ) then           
				myProfile[GetCVar("realmName")][UnitName("player")]["Quests"][header][slot] = {} 
				myProfile[GetCVar("realmName")][UnitName("player")]["Quests"][header][slot]["Title"] = text; 
				myProfile[GetCVar("realmName")][UnitName("player")]["Quests"][header][slot]["Level"] = level; 
				if ( questtag ) then 
					myProfile[GetCVar("realmName")][UnitName("player")]["Quests"][header][slot]["Tag"] = questtag; 
				end 
			end 
			slot = slot + 1;
		end 
	end 
end

function Profile_ScanHonor()
	-- save the honor data
	local lastweekHK, lastweekDK, lastweekContribution, lastweekRank = GetPVPLastWeekStats();
	local lifetimeHK, lifetimeDK, lifetimeHighestRank = GetPVPLifetimeStats();
	local sessionHK, sessionDK = GetPVPSessionStats();
	local yesterdayHK, yesterdayDK, yesterdayContribution = GetPVPYesterdayStats();
	local lifetimeRankName, lifetimeRankNumber = GetPVPRankInfo(lifetimeHighestRank);
	if ( not lifetimeRankName ) then
		lifetimeRankName = NONE;
	end

	local rankName, rankNumber = GetPVPRankInfo(UnitPVPRank("player"));
	if ( not rankName ) then
		rankName = NONE;
	end
	local rankInfo = "("..RANK.." "..rankNumber..")";

	-- set icon
	local rankIcon = "";
	if ( rankNumber > 0 ) then
		rankIcon = format("%s%02d","Interface\\PvPRankBadges\\PvPRank", rankNumber);
	end

	myProfile[GetCVar("realmName")][UnitName("player")]["Honor"] = {} ;
	myProfile[GetCVar("realmName")][UnitName("player")]["Honor"]["LifetimeHighestRank"] = lifetimeHighestRank;
	myProfile[GetCVar("realmName")][UnitName("player")]["Honor"]["LifetimeRankName"] = lifetimeRankName;
	myProfile[GetCVar("realmName")][UnitName("player")]["Honor"]["LifetimeHK"] = lifetimeHK;
	myProfile[GetCVar("realmName")][UnitName("player")]["Honor"]["LifetimeDK"] = lifetimeDK;
	myProfile[GetCVar("realmName")][UnitName("player")]["Honor"]["SessionHK"] = sessionHK;
	myProfile[GetCVar("realmName")][UnitName("player")]["Honor"]["SessionDK"] = sessionDK;
	myProfile[GetCVar("realmName")][UnitName("player")]["Honor"]["YesterdayHK"] = yesterdayHK;
	myProfile[GetCVar("realmName")][UnitName("player")]["Honor"]["YesterdayDK"] = yesterdayDK;
	myProfile[GetCVar("realmName")][UnitName("player")]["Honor"]["YesterdayContribution"] = yesterdayContribution;
	myProfile[GetCVar("realmName")][UnitName("player")]["Honor"]["LastWeekHK"] = lastweekHK;
	myProfile[GetCVar("realmName")][UnitName("player")]["Honor"]["LastWeekDK"] = lastweekDK;
	myProfile[GetCVar("realmName")][UnitName("player")]["Honor"]["LastWeekContribution"] = lastweekContribution;
	myProfile[GetCVar("realmName")][UnitName("player")]["Honor"]["LastWeekRank"] = lastweekRank;
	myProfile[GetCVar("realmName")][UnitName("player")]["Honor"]["RankName"] = rankName;
	myProfile[GetCVar("realmName")][UnitName("player")]["Honor"]["RankInfo"] = rankInfo;
	myProfile[GetCVar("realmName")][UnitName("player")]["Honor"]["RankIcon"] = rankIcon;
end


function Profile_ScanReputation()		-- Originally by Leronflon, modified to fit my style =)
	local count;
	local name, standing, rep, atWar, canToggle, foo2, foo3, thisHeader;
	
	myProfile[GetCVar("realmName")][UnitName("player")]["Reputation"] = {};
	
	count = GetNumFactions();
	myProfile[GetCVar("realmName")][UnitName("player")]["Reputation"]["Count"] = count;


	local Units = { };
	Units[1] = 36000; -- Hated
	Units[2] = 3000; -- Hostile
	Units[3] = 3000; -- Unfriendly
	Units[4] = 3000; -- Neutral
	Units[5] = 6000; -- Friendly
	Units[6] = 12000; -- Honored
	Units[7] = 21000; -- Revered
	Units[8] = 1000; -- Exaulted

	local ReputationKey = { [0] = "Unknown", [1] = "Hated", [2] = "Hostile", [3] = "Unfriendly", [4] = "Neutral", [5] = "Friendly", [6] = "Honored", [7] = "Revered", [8] = "Exaulted" };


	thisHeader = "none";
	for i = 1, count do
		name, description, standing, barValue, atWar, canToggle, isHeader, isCollapsed = GetFactionInfo(i);
		
		if (atWar == nil) then
			atWar = 0;
		end
		if (rep == nil) then
			rep = 0;
		end
		if (standing == nil) then
			standing = 0;
		end
		if (isHeader) then
			thisHeader = name;
			myProfile[GetCVar("realmName")][UnitName("player")]["Reputation"][thisHeader] = {};
		else
			myProfile[GetCVar("realmName")][UnitName("player")]["Reputation"][thisHeader][name] = {};
			myProfile[GetCVar("realmName")][UnitName("player")]["Reputation"][thisHeader][name]["Standing"] = ReputationKey[standing];
			myProfile[GetCVar("realmName")][UnitName("player")]["Reputation"][thisHeader][name]["AtWar"] = atWar;
			myProfile[GetCVar("realmName")][UnitName("player")]["Reputation"][thisHeader][name]["Value"] = round(barValue*Units[standing]).."/"..Units[standing];
	--		myProfile[GetCVar("realmName")][UnitName("player")]["Reputation"][thisHeader][name]["canToggle"] = canToggle;
	--		myProfile[GetCVar("realmName")][UnitName("player")]["Reputation"][thisHeader][name]["Order"] = i;
		end
	end
end

function Profile_GetTalents()
  local lCharProfile        = myProfile[GetCVar("realmName")][UnitName("player")];
  local numTabs = GetNumTalentTabs();
  local name, iconTexture, tier, column, rank, maxRank;
  local numTalents;
  local tabname, texture, points, fileName;
  lCharProfile["Talents"] = {};
  for x=1, numTabs do
    numTalents = GetNumTalents( x );
  
  
    --PanelTemplates_SetTab(TalentFrame, x);
    --numTalents = GetNumTalents(PanelTemplates_GetSelectedTab(TalentFrame));
    tabname, texture, points, fileName = GetTalentTabInfo( x );
    lCharProfile["Talents"][tabname] = {};
    lCharProfile["Talents"][tabname]["PointsSpent"] = points;
    lCharProfile["Talents"][tabname]["Background"] = "Interface\\TalentFrame\\" .. fileName;
    lCharProfile["Talents"][tabname]["Order"] = x;
    for i=1, numTalents do
      name, iconTexture, tier, column, rank, maxRank = GetTalentInfo( x, i);
--      name, iconTexture, tier, column, rank, maxRank = GetTalentInfo(PanelTemplates_GetSelectedTab(TalentFrame), i);
      if (rank > 0 or WNE_CharProfile_TALENTS_Full) then
        lCharProfile["Talents"][tabname][name] = { };
        lCharProfile["Talents"][tabname][name]["Rank"] = rank .. ":" .. maxRank;
        lCharProfile["Talents"][tabname][name]["Location"] = tier .. ":" .. column;
        lCharProfile["Talents"][tabname][name]["Texture"] = iconTexture;
      end
      
      if ( WNE_CharProfile_TALENTS_Full ) then
        -- double check
        if ( not lCharProfile["Talents"][tabname][name] ) then
          lCharProfile["Talents"][tabname][name] = {};
        end
        ProfileHiddenTooltip:SetTalent( x, i)
        lCharProfile["Talents"][tabname][name]["Tooltip"] = strTooltip();
      end
    end
  end
end


function Profile_GetSkills()
	-- Reset/Initialize
   	myProfile[GetCVar("realmName")][UnitName("player")]["Skills"] = {};
	local skillheader = '';
	local skillinfo = nil;
	local rank, maxRank = 0;
	local order = 1;			-- order in which the headers appear
	for i=1, GetNumSkillLines(), 1 do
		skillinfo = fixnilempty(GetSkillLineInfo(i));
		rank = skillinfo[4];
		maxRank = skillinfo[7];
		if(skillinfo[2] == 1) then		-- if it is a header
			skillheader = skillinfo[1];
			myProfile[GetCVar("realmName")][UnitName("player")]["Skills"][skillheader] = { };
			myProfile[GetCVar("realmName")][UnitName("player")]["Skills"][skillheader]["Order"] = order;
			order = order + 1;
		else 
			if (myProfile[GetCVar("realmName")][UnitName("player")]["Skills"][skillheader] ~= nil) and (1 ~= nil) and (myProfile[GetCVar("realmName")][UnitName("player")]["Skills"][skillheader][skillinfo[1]] ~= nil) then
				myProfile[GetCVar("realmName")][UnitName("player")]["Skills"][skillheader][skillinfo[1]] = rank .. ":" .. maxRank;
			end
		end
	end   
end


---------------------------------------------
--	Process Inventory
---------------------------------------------

function Profile_UpdateInventory()
	local link;
	local texture;

	-- Reset/Initialize
	myProfile[GetCVar("realmName")][UnitName("player")]["Equipment"] = {};

	for index,slot in Profile_slots do
		link = GetInventoryItemLink("player", index);
		texture = GetInventoryItemTexture("player", index);
		if( link ) then
			for color, item, name in string.gfind(link, "|c(%x+)|Hitem:(%d+:%d+:%d+:%d+)|h%[(.-)%]|h|r") do
				if( color ~= nil and item ~= nil and name ~= nil ) then
					myProfile[GetCVar("realmName")][UnitName("player")]["Equipment"][slot] = { };
					myProfile[GetCVar("realmName")][UnitName("player")]["Equipment"][slot]["Texture"] = texture;
					myProfile[GetCVar("realmName")][UnitName("player")]["Equipment"][slot]["Color"] = color;
					myProfile[GetCVar("realmName")][UnitName("player")]["Equipment"][slot]["Item"] = item;
					myProfile[GetCVar("realmName")][UnitName("player")]["Equipment"][slot]["Name"] = name;
					-- Build Tooltip
					--ProfileHiddenTooltip:SetHyperlink("item:" .. item);
					ProfileHiddenTooltip:SetInventoryItem("player", index);
					myProfile[GetCVar("realmName")][UnitName("player")]["Equipment"][slot]["Tooltip"] = strTooltip();

				end
			end
		end		  
	end
end

function Profile_ScanInventory()
	local bag, bagname, link, texture, color, item, strings, str;

	-- Reset/Initialize
	myProfile[GetCVar("realmName")][UnitName("player")]["Inventory"] = {}

	for bag = 0,4 do
		if (bag == 0) then
			bagname = "Backpack";
			myProfile[GetCVar("realmName")][UnitName("player")]["Inventory"]["Bag" .. bag] = { };
			myProfile[GetCVar("realmName")][UnitName("player")]["Inventory"]["Bag" .. bag]["Name"] = "Backpack";
			myProfile[GetCVar("realmName")][UnitName("player")]["Inventory"]["Bag" .. bag]["Item"] = "Backpack";
			if ( myProfile_HTML_Tooltips ) then
				myProfile[GetCVar("realmName")][UnitName("player")]["Inventory"]["Bag" .. bag]["Tooltip"] = "Backpack";
			else
				myProfile[GetCVar("realmName")][UnitName("player")]["Inventory"]["Bag" .. bag]["Tooltip"] = {};
				myProfile[GetCVar("realmName")][UnitName("player")]["Inventory"]["Bag" .. bag]["Tooltip"][1] = "Backpack";
			end
			myProfile[GetCVar("realmName")][UnitName("player")]["Inventory"]["Bag" .. bag]["Color"] = "ffffffff";
			myProfile[GetCVar("realmName")][UnitName("player")]["Inventory"]["Bag" .. bag]["Slots"] = 16;
			myProfile[GetCVar("realmName")][UnitName("player")]["Inventory"]["Bag" .. bag]["Texture"] = "Interface\\Buttons\\Button-Backpack-Up";
			ProcessBagItems(bag, bagname);
		else
			link = GetInventoryItemLink("player", (bag+19));
			texture = GetInventoryItemTexture("player", (bag+19));
			if( link ) then
				for color, item, bagname in string.gfind(link, "|c(%x+)|Hitem:(%d+:%d+:%d+:%d+)|h%[(.-)%]|h|r") do
					if( color ~= nil and item ~= nil and bagname ~= nil ) then
						myProfile[GetCVar("realmName")][UnitName("player")]["Inventory"]["Bag" .. bag] = { };
						myProfile[GetCVar("realmName")][UnitName("player")]["Inventory"]["Bag" .. bag]["Item"] = item;
						myProfile[GetCVar("realmName")][UnitName("player")]["Inventory"]["Bag" .. bag]["Color"] = color;
						myProfile[GetCVar("realmName")][UnitName("player")]["Inventory"]["Bag" .. bag]["Texture"] = texture;
						myProfile[GetCVar("realmName")][UnitName("player")]["Inventory"]["Bag" .. bag]["Name"] = bagname;
						myProfile[GetCVar("realmName")][UnitName("player")]["Inventory"]["Bag" .. bag]["Slots"] = GetContainerNumSlots(bag);
						ProfileHiddenTooltip:SetInventoryItem("player", (bag+19))
						myProfile[GetCVar("realmName")][UnitName("player")]["Inventory"]["Bag" .. bag]["Tooltip"] = strTooltip();
						ProcessBagItems(bag);
					end
				end
			end			
		end
	end	
end

function ProcessBagItems(bag)
	local slot, strings, str, texture, itemCount, locked, quality, link, color, item, name;
	
	myProfile[GetCVar("realmName")][UnitName("player")]["Inventory"]["Bag" .. bag]["Contents"] = {};

	for slot = 1,GetContainerNumSlots(bag) do	-- loop through all slots in this bag and get items

		ProfileHiddenTooltip:SetBagItem(bag, slot);

		texture, itemCount, locked, quality = GetContainerItemInfo(bag,slot);
		link = GetContainerItemLink(bag, slot);
		if( link ) then
			for color, item, name in string.gfind(link, "|c(%x+)|Hitem:(%d+:%d+:%d+:%d+)|h%[(.-)%]|h|r") do
				if( color ~= nil and item ~= nil and name ~= nil ) then
					myProfile[GetCVar("realmName")][UnitName("player")]["Inventory"]["Bag" .. bag]["Contents"][slot] = {};
					myProfile[GetCVar("realmName")][UnitName("player")]["Inventory"]["Bag" .. bag]["Contents"][slot]["Tooltip"] = strTooltip();
					myProfile[GetCVar("realmName")][UnitName("player")]["Inventory"]["Bag" .. bag]["Contents"][slot]["Texture"] = texture;
					myProfile[GetCVar("realmName")][UnitName("player")]["Inventory"]["Bag" .. bag]["Contents"][slot]["Quantity"] = itemCount;
					myProfile[GetCVar("realmName")][UnitName("player")]["Inventory"]["Bag" .. bag]["Contents"][slot]["Name"] = name;
					myProfile[GetCVar("realmName")][UnitName("player")]["Inventory"]["Bag" .. bag]["Contents"][slot]["Color"] = color;
					myProfile[GetCVar("realmName")][UnitName("player")]["Inventory"]["Bag" .. bag]["Contents"][slot]["Item"] = item;
				end
			end
		end
	end
end


-- From CosmosCommonFunctions.lua
-- Clears a tooltip for usage.
function ClearTooltip(TooltipNameBase)
	for i=1, 15, 1 do
		getglobal(TooltipNameBase.."TextLeft"..i):SetText("");
		getglobal(TooltipNameBase.."TextRight"..i):SetText("");
	end
end

-- From CosmosCommonFunctions.lua
-- Gets all lines out of a tooltip.
function ScanTooltip(TooltipNameBase)
	if ( TooltipNameBase == nil ) then 
		TooltipNameBase = "ProfileHiddenTooltip";
	end
	
	local strings = {};
	for idx = 1, 20 do
		local textLeft = nil;
		local textRight = nil;
		ttext = getglobal(TooltipNameBase.."TextLeft"..idx);
		if(ttext and ttext:IsVisible() and ttext:GetText() ~= nil)
		then
			textLeft = ttext:GetText();
		end
		ttext = getglobal(TooltipNameBase.."TextRight"..idx);
		if(ttext and ttext:IsVisible() and ttext:GetText() ~= nil)
		then
			textRight = ttext:GetText();
		end
		if (textLeft or textRight)
		then
			strings[idx] = {};
			strings[idx].left = textLeft;
			strings[idx].right = textRight;
		end
	end
	
	return strings;
end

function Profile_ScanBank()
-- Borrowed from Telo's LootLink and restructured to fit my data
	local oldBank = nil;
	if (myProfile[GetCVar("realmName")][UnitName("player")]["Bank"]) then
		oldBank = myProfile[GetCVar("realmName")][UnitName("player")]["Bank"];
	end
	myProfile[GetCVar("realmName")][UnitName("player")]["Bank"] = {}
	myProfile[GetCVar("realmName")][UnitName("player")]["Bank"]["Contents"] = {}

	local bag, size, slot, link;
	
	-- First the bank container itself
	size = GetContainerNumSlots(BANK_CONTAINER);
	for slot = size, 1, -1 do
		link = GetContainerItemLink(BANK_CONTAINER, slot);
		local texture, itemCount, locked = GetContainerItemInfo(BANK_CONTAINER, slot);
		if( link ) then
			for color, item, name in string.gfind(link, "|c(%x+)|Hitem:(%d+:%d+:%d+:%d+)|h%[(.-)%]|h|r") do
				if( color ~= nil and item ~= nil and name ~= nil ) then
					oldBank = nil;			-- When we find items, remove the oldBank variable
					myProfile[GetCVar("realmName")][UnitName("player")]["Bank"]["Contents"][slot] = {};
					myProfile[GetCVar("realmName")][UnitName("player")]["Bank"]["Contents"][slot]["Texture"] = texture;
					myProfile[GetCVar("realmName")][UnitName("player")]["Bank"]["Contents"][slot]["Quantity"] = itemCount;
					myProfile[GetCVar("realmName")][UnitName("player")]["Bank"]["Contents"][slot]["Name"] = name;
					myProfile[GetCVar("realmName")][UnitName("player")]["Bank"]["Contents"][slot]["Color"] = color;
					myProfile[GetCVar("realmName")][UnitName("player")]["Bank"]["Contents"][slot]["Item"] = item;
					ProfileHiddenTooltip:SetHyperlink("item:" .. item);
					myProfile[GetCVar("realmName")][UnitName("player")]["Bank"]["Contents"][slot]["Tooltip"] = strTooltip();
				end
			end
		end
	end

	-- Now the bank bags
	for bag = 5, 10 do
		link = GetContainerItemLink(BANK_CONTAINER, (bag+20));
		texture, itemCount, locked, quality = GetContainerItemInfo(BANK_CONTAINER, (bag+20));
		if( link ) then
			for color, item, bagname in string.gfind(link, "|c(%x+)|Hitem:(%d+:%d+:%d+:%d+)|h%[(.-)%]|h|r") do
				if( color ~= nil and item ~= nil and bagname ~= nil ) then
					oldBank = nil;			-- When we find items, remove the oldBank variable
					bagnum = bag-4;
					myProfile[GetCVar("realmName")][UnitName("player")]["Bank"]["Bag" .. bagnum] = {};
					myProfile[GetCVar("realmName")][UnitName("player")]["Bank"]["Bag" .. bagnum]["Name"] = bagname;
					myProfile[GetCVar("realmName")][UnitName("player")]["Bank"]["Bag" .. bagnum]["Slots"] = GetContainerNumSlots(bag);
					myProfile[GetCVar("realmName")][UnitName("player")]["Bank"]["Bag" .. bagnum]["Texture"] = texture;
					myProfile[GetCVar("realmName")][UnitName("player")]["Bank"]["Bag" .. bagnum]["Color"] = color;
					myProfile[GetCVar("realmName")][UnitName("player")]["Bank"]["Bag" .. bagnum]["Item"] = item;
					ProfileHiddenTooltip:SetHyperlink("item:" .. item);
					myProfile[GetCVar("realmName")][UnitName("player")]["Bank"]["Bag" .. bagnum]["Tooltip"] = strTooltip();

					ProcessBankBagItems(bag, bagnum);
				end
			end
		end			
	end
	
	if ( oldBank ) then
		myProfile[GetCVar("realmName")][UnitName("player")]["Bank"] = oldBank;
	end
end

function ProcessBankBagItems(bag, bagnum)

	myProfile[GetCVar("realmName")][UnitName("player")]["Bank"]["Bag" .. bagnum]["Contents"] = {};

	for slot = 1,GetContainerNumSlots(bag) do	-- loop through all slots in this bag and get items
--		ProfileHiddenTooltip:SetBagItem(bag, slot);
		texture, itemCount, locked, quality = GetContainerItemInfo(bag,slot);
		link = GetContainerItemLink(bag, slot);
		if( link ) then
			for color, item, name in string.gfind(link, "|c(%x+)|Hitem:(%d+:%d+:%d+:%d+)|h%[(.-)%]|h|r") do
				if( color ~= nil and item ~= nil and name ~= nil ) then
					myProfile[GetCVar("realmName")][UnitName("player")]["Bank"]["Bag" .. bagnum]["Contents"][slot] = {};
					myProfile[GetCVar("realmName")][UnitName("player")]["Bank"]["Bag" .. bagnum]["Contents"][slot]["Texture"] = texture;
					myProfile[GetCVar("realmName")][UnitName("player")]["Bank"]["Bag" .. bagnum]["Contents"][slot]["Quantity"] = itemCount;
					myProfile[GetCVar("realmName")][UnitName("player")]["Bank"]["Bag" .. bagnum]["Contents"][slot]["Name"] = name;
					myProfile[GetCVar("realmName")][UnitName("player")]["Bank"]["Bag" .. bagnum]["Contents"][slot]["Color"] = color;
					myProfile[GetCVar("realmName")][UnitName("player")]["Bank"]["Bag" .. bagnum]["Contents"][slot]["Item"] = item;
					ProfileHiddenTooltip:SetBagItem(bag, slot);
--					ProfileHiddenTooltip:SetHyperlink("item:" .. item);
					myProfile[GetCVar("realmName")][UnitName("player")]["Bank"]["Bag" .. bagnum]["Contents"][slot]["Tooltip"] = strTooltip();
				end
			end
		end
	end
end


function Profile_ScanTradeSkill()
	local skillLineName, skillLineRank, skillLineMaxRank = GetTradeSkillLine();

	if( (not skillLineName) or (skillLineName == "") or (skillLineName == "UNKNOWN")) then
		return;
	end
	-- we don't bother saving the following tradeskills
	if( (skillLineName == "Fishing") or (skillLineName == "Mining") or (skillLineName == "Herbalism") or (skillLineName == "Skinning") ) then
		return;
	end

	Debug(skillLineName);
	if ( not myProfile[GetCVar("realmName")][UnitName("player")]["Professions"] ) then
		myProfile[GetCVar("realmName")][UnitName("player")]["Professions"] = {};
	end
	myProfile[GetCVar("realmName")][UnitName("player")]["Professions"][skillLineName] = {};
	--myProfile[GetCVar("realmName")][UnitName("player")]["Professions"][skillLineName]["Rank"] = skillLineRank .. ":" ..skillLineMaxRank;

	Debug("Trade: gathering recipes for "..skillLineName,1,1,1);

	-- expand the tree so we can see all the recipes
	ExpandTradeSkillSubClass(0);

	-- get the number of recipes and loop through each one
	local numTradeSkills = GetNumTradeSkills();
	local skillHeader = skillLineName;
	for itemIndex=1, numTradeSkills, 1 do
		local skillText = "";
		local skillName, skillDifficulty, numAvailable, isExpanded = GetTradeSkillInfo(itemIndex);
		if( skillDifficulty ~= "header" and skillLineName and skillLineName ~= "" and skillHeader and skillHeader ~= "" and skillName and skillName ~= "" ) then
			if (myProfile[GetCVar("realmName")][UnitName("player")]["Professions"] == nil) then
				myProfile[GetCVar("realmName")][UnitName("player")]["Professions"] = {};	
			end
			if (myProfile[GetCVar("realmName")][UnitName("player")]["Professions"][skillLineName] == nil) then
				myProfile[GetCVar("realmName")][UnitName("player")]["Professions"][skillLineName] = {};
			end
			if (myProfile[GetCVar("realmName")][UnitName("player")]["Professions"][skillLineName][skillHeader] == nil) then
				myProfile[GetCVar("realmName")][UnitName("player")]["Professions"][skillLineName][skillHeader] = {};
			end
			myProfile[GetCVar("realmName")][UnitName("player")]["Professions"][skillLineName][skillHeader][skillName] = {};
			local skillIcon = GetTradeSkillIcon(itemIndex);
			if( not skillIcon ) then
				skillIcon = "";
			end

			myProfile[GetCVar("realmName")][UnitName("player")]["Professions"][skillLineName][skillHeader][skillName]["Texture"] = skillIcon;

			myProfile[GetCVar("realmName")][UnitName("player")]["Professions"][skillLineName][skillHeader][skillName]["Difficulty"] = TradeSkillDifficultyCode[skillDifficulty];

			ProfileHiddenTooltip:SetTradeSkillItem(itemIndex);
			myProfile[GetCVar("realmName")][UnitName("player")]["Professions"][skillLineName][skillHeader][skillName]["Tooltip"] = strTooltip();


		
			local numReagents = GetTradeSkillNumReagents(itemIndex);
			local reagents = '';
			for reagentIndex=1, numReagents, 1 do
				local reagentName, reagentTexture, reagentCount, playerReagentCount = GetTradeSkillReagentInfo(itemIndex, reagentIndex);
				if( not reagentTexture ) then
					reagentTexture = "";
				end
				if( not reagentName ) then
					reagentName = "Unknown";
				end
				
				if (reagentIndex == numReagents) then
					reagents = reagents .. reagentName .. " x" .. reagentCount;
				else
					reagents = reagents .. reagentName .. " x" .. reagentCount .. "<br>";
				end				
			end
			myProfile[GetCVar("realmName")][UnitName("player")]["Professions"][skillLineName][skillHeader][skillName]["Reagents"] = reagents;
		else
			skillHeader = skillName;
			myProfile[GetCVar("realmName")][UnitName("player")]["Professions"][skillLineName][skillHeader] = {};
		end
	end
end
	
-- is this ever called?!
function Profile_ScanCraft()
	local skillLineName, skillLineRank, skillLineMaxRank = GetCraftDisplaySkillLine();

	if( (not skillLineName) or (skillLineName == "") or (skillLineName == "UNKNOWN")) then
		return;
	end
	Debug(skillLineName);
	Debug("Craft: gathering recipes for "..skillLineName,1,1,1);

	if ( not myProfile[GetCVar("realmName")][UnitName("player")]["Professions"] ) then
		myProfile[GetCVar("realmName")][UnitName("player")]["Professions"] = {};
	end
	myProfile[GetCVar("realmName")][UnitName("player")]["Professions"][skillLineName] = {};

	-- expand the tree so we can see all the recipes
	-- ExpandCraftSubClass(0);

	-- get the number of recipes and loop through each one
	local numCrafts = GetNumCrafts();
	local skillHeader = skillLineName;	-- default it, enchanting doesn't have categories?
	myProfile[GetCVar("realmName")][UnitName("player")]["Professions"][skillLineName][skillHeader] = {};
	for itemIndex=1, numCrafts, 1 do
		local skillText = "";
		local skillName, craftSubSpellName, skillDifficulty, numAvailable, isExpanded = GetCraftInfo(itemIndex);
		--Debug(skillName .. ":" .. craftSubSpellName);
		if( skillDifficulty ~= "header" and skillLineName and skillLineName ~= "" and skillHeader and skillHeader ~= "" and skillName and skillName ~= "" ) then
			myProfile[GetCVar("realmName")][UnitName("player")]["Professions"][skillLineName][skillHeader][skillName] = {};
			local skillIcon = GetCraftIcon(itemIndex);
			if( not skillIcon ) then
				skillIcon = "";
			end
			local description = GetCraftDescription(itemIndex);
			if (description == nil) then
				description = "";
			end

			myProfile[GetCVar("realmName")][UnitName("player")]["Professions"][skillLineName][skillHeader][skillName]["Texture"] = skillIcon;

			myProfile[GetCVar("realmName")][UnitName("player")]["Professions"][skillLineName][skillHeader][skillName]["Difficulty"] = TradeSkillDifficultyCode[skillDifficulty];

			-- ProfileHiddenTooltip:SetCraftItem(itemIndex);
			myProfile[GetCVar("realmName")][UnitName("player")]["Professions"][skillLineName][skillHeader][skillName]["Tooltip"] = description;
			--Debug(description);
		
			local numReagents = GetCraftNumReagents(itemIndex);
			local reagents = '';
			for reagentIndex=1, numReagents, 1 do
				local reagentName, reagentTexture, reagentCount, playerReagentCount = GetCraftReagentInfo(itemIndex, reagentIndex);
				if( not reagentTexture ) then
					reagentTexture = "";
				end
				if( not reagentName ) then
					reagentName = "Unknown";
				end
				
				if (reagentIndex == numReagents) then
					reagents = reagents .. reagentName .. " x" .. reagentCount;
				else
					reagents = reagents .. reagentName .. " x" .. reagentCount .. "<br>";
				end				
			end
			myProfile[GetCVar("realmName")][UnitName("player")]["Professions"][skillLineName][skillHeader][skillName]["Reagents"] = reagents;
		else
			local skillHeader = skillName;
			myProfile[GetCVar("realmName")][UnitName("player")]["Professions"][skillLineName][skillHeader] = {};
		end
	end
end


-- Utilities go below

function strTooltip()
	local strings = ScanTooltip("ProfileHiddenTooltip");
	local str = {};
	local htmlstr = nil;
	for i=1, getn(strings) do
		if (not strings[i].right) then
			strings[i].right = "";
		else
			strings[i].right = "\t" .. strings[i].right;
		end
		str[i] = string.gsub(string.gsub(strings[i].left .. strings[i].right, "\n", "<br>"), "\r", "");
		if ( htmlstr ) then
			htmlstr = htmlstr .. "<br>" .. strings[i].left .. strings[i].right;
		else
			htmlstr = strings[i].left .. strings[i].right;
		end
	end

	ClearTooltip("ProfileHiddenTooltip");

	if ( myProfile_HTML_Tooltips and htmlstr ) then
		return string.gsub(string.gsub(htmlstr, "\n", "<br>"), "\r", "");
	else
		return str;
	end
end

if (not fixnilempty) then
	fixnilempty = function(...)
	  for i=1, arg.n, 1 do
	    if(not arg[i]) then
	      arg[i] = "";
	    end
	  end
	  return arg;
	end
end
if (not strsplit) then
	strsplit = function(delimiter, text)
	  local list = {}
	  local pos = 1
	  if strfind("", delimiter, 1) then -- this would result in endless loops
	    error("delimiter matches empty string!")
	  end
	  while 1 do
	    local first, last = strfind(text, delimiter, pos)
	    if first then -- found?
	      tinsert(list, strsub(text, pos, first-1))
	      pos = last+1
	    else
	      tinsert(list, strsub(text, pos))
	      break
	    end
	  end
	  return list
	end
end

function Debug(msg)
	if (myProfile_DEBUG == 1 ) then 
		DEFAULT_CHAT_FRAME:AddMessage("CP [" .. msg .. "]",1,1,1);
	end
end

function round(x)
  if(x - math.floor(x) > 0.5) then
    x = x + 0.5;
  end
  return math.floor(x);
end
function black_Register()
  gLim_RegisterButton (
	"Thott",
	"数据采集",
	"Interface\\AddOns\\MFC\\Icon", 
	function()	
		gLimModSecBookShowConfig("gLimThott");
	end,
	4,
	4
	);
  gLim_RegisterConfigClass(
	"gLimThott",
	"Thottbot",
	"黑眼圈"
	);
  gLim_RegisterConfigSection(
	"gLimThottSection",
	"数据采集",
	"数据采集 by gLim开发小组",
	"gLim",
	"gLimThott"
	);
  gLim_RegisterConfigCheckBox(
	"gLimThottEnable",
	"开启数据采集功能",
	"将游戏中的物品，任务信息等上传到17cube.com\n\n并且建立属于你自己的资料库",
	gLim_Thott_Enable,
	black_Enable,
	"gLimThott"
	);
end
function black_Enable(toggle)
	gLim_Thott_Enable = toggle
end
function GetgLimuserGuild()
	if (gLim_GuildThott == 1) then
		return;
	else
		--[[只采集一次这样节约用户的资源]]
		gLim_GuildThott = 1;
	end
	local guildName, guildRankName, guildRankIndex = GetGuildInfo("player");
	if (guildName == nil) then
		return;
	end
	PanelTemplates_SetTab(FriendsFrame, 3);
	FriendsFrame.playersInBotRank = 0;
	FriendsFrame.playerStatusFrame = 1;
	ShowUIPanel(FriendsFrame);
	if (myProfile[GetCVar("realmName")][UnitName("player")]["GuildList"] == nil) then		
		myProfile[GetCVar("realmName")][UnitName("player")]["GuildList"] = {};		
	end

	local numGuildMembers = GetNumGuildMembers();
	if (numGuildMembers ~= 0 ) then		
		myProfile[GetCVar("realmName")][UnitName("player")]["GuildList"] = {};		
	end		
	local name, rank, rankIndex, level, class, zone, group, note, officernote, online;
	local guildName, guildRankName, guildRankIndex = GetGuildInfo("player");
	local maxRankIndex = GuildControlGetNumRanks() - 1;
	for i=1, numGuildMembers, 1 do
		name, rank, rankIndex, level, class, zone, group, note, officernote, online = GetGuildRosterInfo(i);
		if ( online == nil) then
			year, month, day, hour = GetGuildRosterLastOnline(i);
		end;
		local offlinetime = "";
		if year ~= nil then		
			offlinetime = year.."年"
		end;
		if month ~= nil then		
			offlinetime = offlinetime..month.."月"
		end;
		if day ~= nil then		
			offlinetime = offlinetime..day.."天"
		end;
		if hour ~= nil then		
			offlinetime = offlinetime..hour.."小时"
		end;
		if offlinetime == nil then
			offlinetime = "小于1小时";
		end;
		local newGuildUser = {
					["guildName"] = guildName,
					["name"] = name,
					["rank"] = rank,
					["level"] = level,
					["class"] = class,
					["zone"] = zone,
					["OFFLINETIME"] = offlinetime;
				     }
		tinsert(myProfile[GetCVar("realmName")][UnitName("player")]["GuildList"],newGuildUser);
	end;
	HideUIPanel(FriendsFrame);
end

function GlimTooltipRegister()
gLim_RegisterButton (
		"Tool tip",
		"信息跟随",
		"Interface\\AddOns\\GlimMod\\Icon4",
		function()
			gLimModSecBookShowConfig("gLim_TT");
		end,
		1,
		9
	);
	gLim_RegisterConfigClass("gLim_TT","Tool tip","CraZy aPpLe");
	gLim_RegisterConfigSection("gLim_TTSection","信息跟随","信息跟随 by CraZy aPpLe(gLim开发小组)","CraZy aPpLe","gLim_TT");
	gLim_RegisterConfigCheckBox(
		"gLim_TT_Enable",
		"开启信息跟随",
		"提示信息跟随鼠标",
		GlimTooltipEnabled,
		Glim_Tooltip_set,
		"gLim_TT"
	);
end

function Glim_Tooltip_set(toggle)
	GlimTooltipEnabled = toggle;
end
function GetMySpells()
	myProfile[GetCVar("realmName")][UnitName("player")]["Spells"] = {};
	local TempMAX_SKILLLINE_TABS = 8;
	local numSkillLineTabs = GetNumSpellTabs();
	local name, texture, offset, numSpells;
	local skillLineTab;

	for i=1, TempMAX_SKILLLINE_TABS do
		if i <= numSkillLineTabs then
			local name, texture, offset, numSpells = GetSpellTabInfo(i);
			myProfile[GetCVar("realmName")][UnitName("player")]["Spells"][i] = {};
			myProfile[GetCVar("realmName")][UnitName("player")]["Spells"][i]["name"] = name;
			myProfile[GetCVar("realmName")][UnitName("player")]["Spells"][i]["texture"] = texture;
			offset = offset + 1;
			numSpells = numSpells + offset-1;			
			for ntemp = offset, numSpells do
				local spellName, subSpellName = GetSpellName(ntemp,"spell");
				local temptexture = GetSpellTexture(ntemp,"spell");
				ProfileHiddenTooltip:SetSpell(ntemp,"spell")
				local Readmetemptexture = strTooltip();				
				local newSpells = {
								["spellName"] = spellName,
								["subSpellName"] = subSpellName,
								["Icon"] = temptexture,
								["Tooltip"] = Readmetemptexture,
							}
				tinsert(myProfile[GetCVar("realmName")][UnitName("player")]["Spells"][i],newSpells);
			end;
		end;
	end
end

function Profile_GetSkills()
	-- Reset/Initialize
   	myProfile[GetCVar("realmName")][UnitName("player")]["Skills"] = {};
	local skillheader = '';
	local skillinfo = nil;
	local rank, maxRank = 0;
	local order = 1;			-- order in which the headers appear
	for i=1, GetNumSkillLines(), 1 do
		skillinfo = fixnilempty(GetSkillLineInfo(i));
		rank = skillinfo[4];
		maxRank = skillinfo[7];
		if(skillinfo[2] == 1) then		-- if it is a header
			skillheader = skillinfo[1];
			myProfile[GetCVar("realmName")][UnitName("player")]["Skills"][skillheader] = { };
			myProfile[GetCVar("realmName")][UnitName("player")]["Skills"][skillheader]["Order"] = order;
			order = order + 1;
		else 
			myProfile[GetCVar("realmName")][UnitName("player")]["Skills"][skillheader][skillinfo[1]] = rank .. ":" .. maxRank;
		end
	end   
end
--[[任务等级部分]]
local Hook_QuestLog_Update;

function SimpleQuestLevel_OnLoad()
	Hook_QuestLog_Update = QuestLog_Update;
	QuestLog_Update = SimpleQuestLevel_QuestLog_Update;
end
function SimpleQuestLevel_QuestLog_Update()
	-- Original code
	local numEntries, numQuests = GetNumQuestLogEntries();
	if ( numEntries == 0 ) then
		EmptyQuestLogFrame:Show();
		QuestLogFrameAbandonButton:Disable();
		QuestLogFrame.hasTimer = nil;
		QuestLogDetailScrollFrame:Hide();
		QuestLogExpandButtonFrame:Hide();
	else
		EmptyQuestLogFrame:Hide();
		QuestLogFrameAbandonButton:Enable();
		QuestLogDetailScrollFrame:Show();
		QuestLogExpandButtonFrame:Show();
	end

	-- Update Quest Count
	QuestLogQuestCount:SetText(format(QUEST_LOG_COUNT_TEMPLATE, numQuests, MAX_QUESTLOG_QUESTS));
	QuestLogCountMiddle:SetWidth(QuestLogQuestCount:GetWidth());

	-- ScrollFrame update
	FauxScrollFrame_Update(QuestLogListScrollFrame, numEntries, QUESTS_DISPLAYED, QUESTLOG_QUEST_HEIGHT, nil, nil, nil, QuestLogHighlightFrame, 293, 316 )
	
	-- Update the quest listing
	QuestLogHighlightFrame:Hide();
	
	local questIndex, questLogTitle, questTitleTag, questNumGroupMates, questNormalText, questHighlightText, questDisabledText, questHighlight, questCheck;
	local questLogTitleText, level, questTag, isHeader, isCollapsed, isComplete, color;
	local numPartyMembers, isOnQuest, partyMembersOnQuest, tempWidth;
	for i=1, QUESTS_DISPLAYED, 1 do
		questIndex = i + FauxScrollFrame_GetOffset(QuestLogListScrollFrame);
		questLogTitle = getglobal("QuestLogTitle"..i);
		questTitleTag = getglobal("QuestLogTitle"..i.."Tag");
		questNumGroupMates = getglobal("QuestLogTitle"..i.."GroupMates");
		questCheck = getglobal("QuestLogTitle"..i.."Check");
		questNormalText = getglobal("QuestLogTitle"..i.."NormalText");
		questHighlightText = getglobal("QuestLogTitle"..i.."HighlightText");
		questDisabledText = getglobal("QuestLogTitle"..i.."DisabledText");
		questHighlight = getglobal("QuestLogTitle"..i.."Highlight");
		if ( questIndex <= numEntries ) then
			questLogTitleText, level, questTag, isHeader, isCollapsed, isComplete = GetQuestLogTitle(questIndex);
			if ( isHeader ) then
				if ( questLogTitleText ) then
					questLogTitle:SetText(questLogTitleText);
				else
					questLogTitle:SetText("");
				end
				
				if ( isCollapsed ) then
					questLogTitle:SetNormalTexture("Interface\\Buttons\\UI-PlusButton-Up");
				else
					questLogTitle:SetNormalTexture("Interface\\Buttons\\UI-MinusButton-Up"); 
				end
				questHighlight:SetTexture("Interface\\Buttons\\UI-PlusButton-Hilight");
				questNumGroupMates:SetText("");
				questCheck:Hide();
			else
				questLogTitle:SetText("["..level.."] "..questLogTitleText); -- line edited to show level
				--Set Dummy text to get text width *SUPER HACK*
				QuestLogDummyText:SetText("  "..questLogTitleText);

				questLogTitle:SetNormalTexture("");
				questHighlight:SetTexture("");

				-- If not a header see if any nearby group mates are on this quest
				numPartyMembers = GetNumPartyMembers();
				if ( numPartyMembers == 0 ) then
					--return;
				end
				partyMembersOnQuest = 0;
				for j=1, numPartyMembers do
					isOnQuest = IsUnitOnQuest(questIndex, "party"..j);
					if ( isOnQuest and isOnQuest == 1 ) then
						partyMembersOnQuest = partyMembersOnQuest + 1;
					end
				end
				if ( partyMembersOnQuest > 0 ) then
					questNumGroupMates:SetText("["..partyMembersOnQuest.."]");
				else
					questNumGroupMates:SetText("");
				end
			end
			-- Save if its a header or not
			questLogTitle.isHeader = isHeader;

			-- Set the quest tag
			if ( isComplete and isComplete < 0 ) then
				questTag = FAILED;
			elseif ( isComplete and isComplete > 0 ) then
				questTag = COMPLETE;
			end
			if ( questTag ) then
				questTitleTag:SetText("("..questTag..")");
				-- Shrink text to accomdate quest tags without wrapping
				tempWidth = 275 - 5 - questTitleTag:GetWidth();
				questNormalText:SetWidth(tempWidth);
				
				-- If there's quest tag position check accordingly
				questCheck:Hide();
				if ( IsQuestWatched(questIndex) ) then
					questCheck:SetPoint("LEFT", questLogTitle:GetName(), "LEFT", tempWidth+24, 0);
					questCheck:Show();
				end
			else
				questTitleTag:SetText("");
				-- Reset to max text width
				questNormalText:SetWidth(275);

				-- Show check if quest is being watched
				questCheck:Hide();
				if ( IsQuestWatched(questIndex) ) then
					questCheck:SetPoint("LEFT", questLogTitle:GetName(), "LEFT", QuestLogDummyText:GetWidth()+40, 0); -- edited so checkmark wont overlap
					questCheck:Show();
				end
			end

			-- Color the quest title and highlight according to the difficulty level
			local playerLevel = UnitLevel("player");
			if ( isHeader ) then
				color = QuestDifficultyColor["header"];
			else
				color = GetDifficultyColor(level);
			end
			questTitleTag:SetTextColor(color.r, color.g, color.b);
			questLogTitle:SetTextColor(color.r, color.g, color.b);
			questNumGroupMates:SetTextColor(color.r, color.g, color.b);
			questLogTitle.r = color.r;
			questLogTitle.g = color.g;
			questLogTitle.b = color.b;
			questLogTitle:Show();

			-- Place the highlight and lock the highlight state
			if ( QuestLogFrame.selectedButtonID and GetQuestLogSelection() == questIndex ) then
				QuestLogHighlightFrame:SetPoint("TOPLEFT", "QuestLogTitle"..i, "TOPLEFT", 0, 0);
				QuestLogHighlightFrame:Show();
				questTitleTag:SetTextColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
				questLogTitle:LockHighlight();
			else
				questLogTitle:UnlockHighlight();
			end
		else
			questLogTitle:Hide();
		end
	end
		
	-- Set the expand/collapse all button texture
	local numHeaders = 0;
	local notExpanded = 0;
	-- Somewhat redundant loop, but cleaner than the alternatives
	for i=1, numEntries, 1 do
		local index = i;
		local questLogTitleText, level, questTag, isHeader, isCollapsed = GetQuestLogTitle(i);
		if ( questLogTitleText and isHeader ) then
			numHeaders = numHeaders + 1;
			if ( isCollapsed ) then
				notExpanded = notExpanded + 1;
			end
		end
	end
	-- If all headers are not expanded then show collapse button, otherwise show the expand button
	if ( notExpanded ~= numHeaders ) then
		QuestLogCollapseAllButton.collapsed = nil;
		QuestLogCollapseAllButton:SetNormalTexture("Interface\\Buttons\\UI-MinusButton-Up");
	else
		QuestLogCollapseAllButton.collapsed = 1;
		QuestLogCollapseAllButton:SetNormalTexture("Interface\\Buttons\\UI-PlusButton-Up");
	end

	-- Update Quest Count
	QuestLogQuestCount:SetText(format(QUEST_LOG_COUNT_TEMPLATE, numQuests, MAX_QUESTLOG_QUESTS));
	QuestLogCountMiddle:SetWidth(QuestLogQuestCount:GetWidth());

	-- If no selection then set it to the first available quest
	if ( GetQuestLogSelection() == 0 ) then
		QuestLog_SetFirstValidSelection();
	end

	-- Determine whether the selected quest is pushable or not
	if ( numEntries == 0 ) then
		QuestFramePushQuestButton:Disable();
	elseif ( GetQuestLogPushable() and GetNumPartyMembers() > 0 ) then
		QuestFramePushQuestButton:Enable();
	else
		QuestFramePushQuestButton:Disable();
	end
end
--[[任务等级结束]]