
----------------------------------------------------------------------------------------------------
-- Local WWNExport Variables
----------------------------------------------------------------------------------------------------

-- Function hooks
local originalQuestDetailAcceptButton_OnClick;			-- Used to hook the clicking of the Accept Button in the QuestDetail Dialog
local originalQuestRewardCompleteButton_OnClick;        -- Used to hook the clicking of the Complete button in the QuestDetail Dialog

local lLastAcceptedQuestInfo;
local lLastCompletedQuestInfo;
local lLastCompletedQuestStoredInfo;

local lShowDebugMessages;
local lShowInfoMessages;
local lScanQuestLog;

WNE_CurrentTargetName = "";
WNE_TargetHistory     = {};

WNE_NPCInfo={};
WNE_ItemInfo={};

--WNE_HERBING_STRING       = "You perform Herb Gathering on";
--WNE_MINING_STRING        = "You perform Mining on";
--WNE_OPENING_STRING       = "You perform Opening on";
--WNE_SKINNING_STRING      = "You perform Skinning on";
WNE_DISENCHANTING_STRING = "You perform Disenchanting on";


WNE_LootType           = 0;
WNE_WorldObject        = "";

--[[分解的所有的裝備得到的分解物的名字]]
ElementNames = {};
--之塵(灰盡類)
ElementNames["DustDream"] = "梦境之尘";
ElementNames["DustIllusion"] = "幻影之尘";
ElementNames["DustSoul"] = "灵魂之尘";
ElementNames["DustStrange"] = "奇异之尘";
ElementNames["DustVision"] = "幻象之尘";
--精华类
ElementNames["EssenceAstralLarge"] = "强效星界精华";
ElementNames["EssenceAstralSmall"] = "次级星界精华";
ElementNames["EssenceEternalLarge"] = "强效不灭精华";
ElementNames["EssenceEternalSmall"] = "次级不灭精华";
ElementNames["EssenceMagicLarge"] = "强效魔法精华";
ElementNames["EssenceMagicSmall"] = "次级魔法精华";
ElementNames["EssenceMysticLarge"] = "强效密法精华";
ElementNames["EssenceMysticSmall"] = "次级密法精华";
ElementNames["EssenceNetherLarge"] = "强效秘法精华";
ElementNames["EssenceNetherSmall"] = "次级虚空精华";
--碎片
ElementNames["ShardBrilliantLarge"] = "大块魔光碎片";
ElementNames["ShardBrilliantSmall"] = "小块魔光碎片";
ElementNames["ShardGlimmeringLarge"] = "大块微光碎片";
ElementNames["ShardGlimmeringSmall"] = "小块微光碎片";
ElementNames["ShardGlowingLarge"] = "大块激光碎片";
ElementNames["ShardGlowingSmall"] = "小块激光碎片";
ElementNames["ShardRadientLarge"] = "大块闪光碎片";
ElementNames["ShardRadientSmall"] = "小块闪光碎片";

--[[分解的所有的裝備得到的分解物的名字]]

function GetItemId(link)
 	for itemid in string.gfind(link, "|Hitem:(%d+)") do
	    return itemid;
 	end
end

----------------------------------------------------------------------------------------------------
-- WNE_OnLoad     This method is executed when the AddOn is loaded.
----------------------------------------------------------------------------------------------------

function WNE_OnLoad()
  lScanQuestLog = true;
  lShowDebugMessages = true;
  lShowDebugMessages = false;
  --用于输出调试信息
  lShowInfoMessages = true;
   
  -- Register the event that is triggered when our Quest Log gets updated.
  this:RegisterEvent( "QUEST_LOG_UPDATE" );
  -- Rigister the event thqt is triggered when the Players XP is Updated.
  this:RegisterEvent("PLAYER_XP_UPDATE");
  -- Register the event that is triggered when your Target's Health is updated
  this:RegisterEvent("UNIT_HEALTH");
  -- Register events that trigger you entering / leaving combat with a target
  this:RegisterEvent("PLAYER_ENTER_COMBAT");
  this:RegisterEvent("PLAYER_LEAVE_COMBAT");
  this:RegisterEvent("CHAT_MSG_SPELL_SELF_DAMAGE");  
  -- Register event that triggers you dieing
  this:RegisterEvent("PLAYER_DEAD");
  -- Register event that triggers when you change target
  this:RegisterEvent("PLAYER_TARGET_CHANGED");
  -- Register event that triggers when you Mine, Open or Collect Herbs
  this:RegisterEvent("CHAT_MSG_SPELL_SELF_BUFF");
  -- Register event that triggers the showing of the TradeSkillWindow
  this:RegisterEvent( "TRADE_SKILL_SHOW" );
  -- Register event that triggers the showing of the TrainerWindow
  this:RegisterEvent( "TRAINER_SHOW" );
  -- Register event that triggers the QUEST KEY WORD
  this:RegisterEvent("UI_INFO_MESSAGE");

 
  -- Hook the QuestDetailAcceptButton_OnClick function
  originalQuestDetailAcceptButton_OnClick = QuestDetailAcceptButton_OnClick;
  QuestDetailAcceptButton_OnClick = WNE_QuestDetailAcceptButton_OnClick;
  
  -- Hook the originalQuestRewardCompleteButton_OnClick function
  originalQuestRewardCompleteButton_OnClick = QuestRewardCompleteButton_OnClick;
  QuestRewardCompleteButton_OnClick = WNE_QuestRewardCompleteButton_OnClick;

  -- Register some Chat Messages
  this:RegisterEvent("MINIMAP_ZONE_CHANGED");
  this:RegisterEvent("LOOT_OPENED");
  this:RegisterEvent("MERCHANT_UPDATE");
  this:RegisterEvent("MERCHANT_SHOW");
  
  -- Initialise the ToolTip
  --local ttFrame=getglobal("WNE_ToolTip");
  --ttFrame:SetOwner(UIParent,"ANCHOR_NONE");

--注冊設置
this:RegisterEvent("SPELLCAST_FAILED");
this:RegisterEvent("SPELLCAST_INTERRUPTED");
this:RegisterEvent("SPELLCAST_START");
this:RegisterEvent("SPELLCAST_STOP");
this:RegisterEvent("ITEM_PUSH");
this:RegisterEvent("UNIT_INVENTORY_CHANGED");

  SLASH_WNE1 = "/wne";
  SlashCmdList["WNE"] = WNE_DoCommand;
end

----------------------------------------------------------------------------------------------------
-- WNE_DoCommand     This method is when our /wne slash command is triggered.
----------------------------------------------------------------------------------------------------

function WNE_DoCommand(msg)
	if(msg=="" or msg=="help") then
		DEFAULT_CHAT_FRAME:AddMessage("WoW.Net Data Exporter Commands");		
		DEFAULT_CHAT_FRAME:AddMessage("  /wne <command> <argument>");		
		DEFAULT_CHAT_FRAME:AddMessage("    /wne loc     -- Prints Location coordinates");				
		DEFAULT_CHAT_FRAME:AddMessage("    /wne help    -- This screen");	
		DEFAULT_CHAT_FRAME:AddMessage("    /wne hide    -- hides the output window");
		DEFAULT_CHAT_FRAME:AddMessage("    /wne show    -- shows the output window (For next two options)");			
		DEFAULT_CHAT_FRAME:AddMessage("    /wne npclist -- list of npcs encountered");		
		DEFAULT_CHAT_FRAME:AddMessage("    /wne npcdetail <name> -- info about the named npc");
	elseif(msg=="loc") then
		local px, py = GetPlayerMapPosition("player");
		px=math.floor(px*100);
		py=math.floor(py*100);
		DEFAULT_CHAT_FRAME:AddMessage("Location: " .. px .. ", " .. py);
	elseif(msg=="show") then
		WNEControlFrame:Show();	
	elseif(msg=="hide") then
		WNEControlFrame:Hide();
		WNEShowButton:Hide();
	elseif(msg=="npclist") then
		WNE_PrintNPCs();
  elseif( msg == "clearmobtitles" ) then
    if ( WNE_NPCInfo ) then
      for lNPCIndex, lNPCInfo in WNE_NPCInfo do
        lNPCInfo[ "Title" ] = nil;
      end
    end		
	elseif(msg=="clearquestinfo") then
  if ( WNE_QuestInfo ) then
    for lQuestIndex, lQuestInfo in WNE_QuestInfo do
      lQuestInfo[ "QuestFaction" ] = nil;
    end
--		WNE_QuestInfo = {};
  end
	else 
		if(string.sub(msg,0,9) == "npcdetail") then
			WNE_PrintNPCDetail(string.sub(msg,10));
		end		
	end
end	
	
function WNE_PrintNPCs() 
	local index=0;
	local levelrange;
	for name in WNE_NPCInfo do
		index = index+1;
		levelrange=WNE_NPCInfo[name]["levelmin"] .. " - " ..WNE_NPCInfo[name]["levelmax"];
		TextDisplay:AddMessage("  ("..index..") " .. name .. " [lvl " .. levelrange .. "]",0,1,0);	
	end
end

function WNE_PrintNPCDetail(name)
	if(WNE_NPCInfo[name]) then
		TextDisplay:AddMessage("NPC Info: " .. name,0,1,0);
		TextDisplay:AddMessage("  Level: " .. WNE_NPCInfo[name]["minlevel"] .. "-" ..WNE_NPCInfo[name]["maxlevel"],0,1,0);
		
		if(WNE_NPCInfo[name]["locations"]) then 
			for index in WNE_NPCInfo[name]["locations"] do
				TextDisplay:AddMessage("  Coord: "..WNE_NPCInfo[name]["locations"]["x"] .. ", "..WNE_NPCInfo[name]["locations"]["x"],0,1,0);
				TextDisplay:AddMessage("  Zone:  "..WNE_NPCInfo[name]["locations"]["zone"] .. ", Cont:  "..WNE_NPCInfo[name]["locations"]["zone"],0,1,0);
			end
		end
	end	
end


function WNE_Event() 
  --WNE_Print_DebugMsg( event .. "Received" );
  
	if(event=="MINIMAP_ZONE_CHANGED") then
		TextDisplay:AddMessage("Entering:   "..GetMinimapZoneText(),0,1,0);
		return;
	end 

  
	
	if(event=="LOOT_OPENED") then
		WNE_AddLoot();	
		return;
	end
	if(event=="MERCHANT_UPDATE" or event=="MERCHANT_SHOW") then
		WNE_LogMerchantInfo();
		return;
	end

  if ( event == "UNIT_HEALTH" ) then
    WNE_CheckTargetDeath(UnitName( "target" ));
    return;
  end
  if( event == "PLAYER_ENTER_COMBAT" or event=="CHAT_MSG_SPELL_SELF_DAMAGE" ) then
    if(UnitExists("target") and (not UnitIsPlayer("target")) and (not UnitIsDeadOrGhost("target")) and (not UnitPlayerControlled("target"))) then
      WNE_CurrentTargetName = UnitName( "Target" );
    end;  
    WNE_CheckTargetDeath(UnitName( "target" ));
    return;
  end  
  if ( event == "PLAYER_TARGET_CHANGED" ) then
    if(UnitExists("target") and (not UnitIsPlayer("target")) and (not UnitIsDeadOrGhost("target")) and (not UnitPlayerControlled("target"))) then
      WNE_AddUpdateNPC();
      WNE_AddTargetToTargetHistory( );
    end
    return;
  end
  if ( event == "PLAYER_DEATH" ) then
    WNE_CurrentTargetName = "";
    WNE_ClearTargetHistory();
    return;
  end
  if ( event == "QUEST_LOG_UPDATE" ) then
    WNE_Quest_Log_Update( );
    return;
  end	
  if ( event == "PLAYER_XP_UPDATE" ) then
    WNE_Player_XP_Gained();
    return;
  end
  if ( event == "CHAT_MSG_SPELL_SELF_BUFF") then
    WNE_ParseSelfBuff( arg1 );
    return;
  elseif (event == "TRADE_SKILL_SHOW") then
    WNE_LogTradeSkillInfo();
    return;
  elseif ( event == "TRAINER_SHOW" ) then
    WNE_LogTrainerInfo();
    return;
  end
  if (event == "UI_INFO_MESSAGE") then
	gLim_QuestStatus(arg1);
	return;
  end
	if ((event == "SPELLCAST_START")and (arg1 == "分解")) then
		Enchantrix_Disenchanting = true;
		Enchantrix_WaitingPush = false;
		Enchantrix_StartInv = Enchantrix_TakeInventory();
		Enchantrix_DisenchantCount = 0;
		Enchantrix_DisenchantResult = {};		
		return;
	end;
	if ((event == "SPELLCAST_FAILED") or (event == "SPELLCAST_INTERRUPTED")) then
		Enchantrix_Disenchanting = false;
		Enchantrix_WaitingPush = false;
		return;
	end
	if ((event == "SPELLCAST_STOP") and (Enchantrix_Disenchanting)) then
		Enchantrix_Disenchanting = false;
		Enchantrix_WaitingPush = true;
		return;
	end
	if ((event == "ITEM_PUSH") and (Enchantrix_WaitingPush)) then
		local textureType = strsub(arg2, 1, 28);
		local receivedItem = strsub(arg2, 29);
		--讀取分解的內部變量名
		if (not receivedItem) then return; end
		if (textureType == "Interface\\Icons\\INV_Enchant_") then
			local receivedName = ElementNames[receivedItem];
			if (not receivedName) then return; end
			Enchantrix_DisenchantCount = Enchantrix_DisenchantCount + 1;
			Enchantrix_DisenchantResult[Enchantrix_DisenchantCount] = receivedName;
		end
		return;
	end
	if (Enchantrix_DisenchantCount ~= nil ) then
		if ((event == "UNIT_INVENTORY_CHANGED") and (arg1 == "player") and (Enchantrix_DisenchantCount > 0)) then
			local nowInv = Enchantrix_TakeInventory();
			--[[比較兩者的變化]]
			local disenchantedItem = Enchantrix_DiffInventory(Enchantrix_StartInv, nowInv);

			if (not disenchantedItem) then
				return;
			end
			if (not WWN_DIS)then
				WWN_DIS = {};
			end

			if (not WWN_DIS[disenchantedItem.name]) then
				WWN_DIS[disenchantedItem.name] = {};
			end
			if WWN_DIS[disenchantedItem.name]["n"] == nil then
				WWN_DIS[disenchantedItem.name]["n"] = 0;
			end
			WWN_DIS[disenchantedItem.name]["n"] = WWN_DIS[disenchantedItem.name]["n"] +1;


			local message = "從"..disenchantedItem.name.."分解出";
			for i=1, Enchantrix_DisenchantCount, 1 do
				local disenchantResult = Enchantrix_DisenchantResult[i];
				local prevCount = WWN_DIS[disenchantedItem.name][disenchantResult];
				if (not prevCount) then 
					prevCount = 0; 
				end
				WWN_DIS[disenchantedItem.name][disenchantResult] = prevCount + 1;

				if (i == 1) then
					message = message..disenchantResult;
				elseif (i == Enchantrix_DisenchantResult) then
					message = message.." and "..disenchantResult;
				else
					message = message..", "..disenchantResult;
				end
			end
			Enchantrix_DisenchantCount = 0;
			Enchantrix_DisenchantResult = {};
			Enchantrix_Disenchanting = false;
			Enchantrix_WaitingPush = false;
			return;
		end
	end;
end
function Enchantrix_TakeInventory()
	local bagid, slotid, size;
	local inventory = {};

	for bagid = 0, 4, 1 do
		inventory[bagid] = {};

		size = GetContainerNumSlots(bagid);
		if( size ) then
			for slotid = size, 1, -1 do
				inventory[bagid][slotid] = {};

				local link = GetContainerItemLink(bagid, slotid);
				if( link ) then
					local name = Enchantrix_NameFromLink(link);
					local texture, itemCount, locked, quality, readable = GetContainerItemInfo(bagid, slotid);
					if ((not itemCount) or (itemCount < 1)) then
						itemCount = 1;
					end
					if (name) then
						inventory[bagid][slotid].name = name;
						inventory[bagid][slotid].count = itemCount;
					end
				end
			end
		end
	end
	return inventory;
end
function Enchantrix_NameFromLink(link)
	local name;
	if( not link ) then
		return nil;
	end
	for name in string.gfind(link, "|c%x+|Hitem:%d+:%d+:%d+:%d+|h%[(.-)%]|h|r") do
		return name;
	end
	return nil;
end
function Enchantrix_DiffInventory(invA, invB)
	local bagid, slotid, size;
	for bagid = 0, 4, 1 do
		size = GetContainerNumSlots(bagid);
		if( size ) then
			for slotid = size, 1, -1 do
				if ((invA[bagid][slotid]) and (invA[bagid][slotid].name)) then
					if (invA[bagid][slotid].name ~= invB[bagid][slotid].name) then
						return invA[bagid][slotid];
					elseif (invA[bagid][slotid].count > invB[bagid][slotid].count) then
						return invA[bagid][slotid];
					end
				end
			end
		end
	end
	return nil;
end
function gLim_QuestStatus(arg1)
	local QuestSubText = getQuestTitle(arg1);

	if (QuestSubText == nil)or(QuestSubText == "") then
		return;	
	end
	local numEntries, numQuests = GetNumQuestLogEntries();
	for i=1,numEntries, 1 do
		numObjectives = GetNumQuestLeaderBoards(i);
		if ( numObjectives > 0 ) then
			for j=1, numObjectives do
				local text, type, finished = GetQuestLogLeaderBoard(j, i);
				local li, j, strItemName, iNumItems, iNumNeeded = string.find(text, "(.*)：%s*([-%d]+)%s*/%s*([-%d]+)%s*$");
				--local questtext = getQuestTitle(text);
				local questtext = strItemName;
				if (questtext == QuestSubText) then
					local questLogTitleText, level, questTag, isHeader, isCollapsed, isComplete = GetQuestLogTitle(i);
					for qindex = 1,getn(WNE_QuestInfo) , 1 do
						if (WNE_QuestInfo[qindex]["Level"]==level)and(WNE_QuestInfo[qindex]["Title"]==questLogTitleText) then
							if (WNE_QuestInfo[qindex]["QuestXP"]==nil) then
								if (WNE_QuestInfo[qindex]["Keyposition"]==nil) then
									WNE_QuestInfo[qindex]["Keyposition"] ={};
								end
								if (WNE_QuestInfo[qindex]["Keyposition"][questtext] == nil) then
									WNE_QuestInfo[qindex]["Keyposition"][questtext] = {};															
								end
								  SetMapToCurrentZone();
								  local px, py = GetPlayerMapPosition("player");
								  local cont = GetCurrentMapContinent();
								  local zone = GetCurrentMapZone();
								  local found =false;
								    
								  px=math.floor(px*100);
								  py=math.floor(py*100);
								  local newloc={ ["cont"]=cont, ["zone"]=zone, ["x"]=px, ["y"]=py };
								table.insert(WNE_QuestInfo[qindex]["Keyposition"][questtext],newloc);
							end
						end							
					end
				end
			end
		end;
	end
end
function getQuestTitle(myGetQuestLogText)
	--WNE_QuestInfo["QuestLogText"] = myGetQuestLogText;
	local i, j, strItemName, iNumItems, iNumNeeded = string.find(myGetQuestLogText, "(.*)：%s*([-%d]+)%s*/%s*([-%d]+)%s*$");
	local str;
	if (strItemName ~= nil) then 			
		 return strItemName;
	else		
		strindex = string.find(myGetQuestLogText, "（");
		if (strindex ~= nil) then			
			str = string.sub(myGetQuestLogText, 1, (string.find(myGetQuestLogText, "（")) - 1);			
		else
			str = "";
		end
	end
	return str;
end
function WNE_AddUpdateNPC() 
  -- Tooltip Related Strings
  local lMobTTName = getglobal( GameTooltip:GetName().."TextLeft1" ):GetText(); 
  local lMobTitle  = getglobal( GameTooltip:GetName().."TextLeft2" ):GetText(); 
  
  local lMobName  = UnitName( "target" );
  local lMobLevel = UnitLevel( "target" );
  
  SetMapToCurrentZone();
  local px, py = GetPlayerMapPosition("player");
  local cont = GetCurrentMapContinent();
  local zone = GetCurrentMapZone();
  local found =false;
    
  px=math.floor(px*100);
  py=math.floor(py*100);
  local newloc={ ["cont"]=cont, ["zone"]=zone, ["x"]=px, ["y"]=py };

  if ( UnitExists( "target" ) ) and
     ( lMobName ~= "Unknown Being" ) then  
    SetMapToCurrentZone();
	
    -- First check if there is an entry in WNE_NPCInfo for that mob, create
    -- an emptry one if necessary
    if ( not ( WNE_NPCInfo [ lMobName ] ) ) then
      WNE_NPCInfo[ lMobName ]= {};
      WNE_NPCInfo[ lMobName ][ "levelmin" ] = lMobLevel;
      WNE_NPCInfo[ lMobName ][ "levelmax" ] = lMobLevel;
    end
   
   --if ( lMobTTName ) then
   --  WNE_Print_DebugMsg( "Mob Tooltip Name" .. lMobTTName );
   --end
   
    -- Check if the MobName found on the ToolTip is the same as the UnitName of the target
    if ( lMobTTName ) and ( lMobTTName ~= lMobName ) then
      lMobTitle = '';
--      WNE_Print_WarningMsg( "MobName Doesn't match the MobName in the ToolTip" );
    end
      
    -- Get the NPCTitle and check if it isn't an indication for a Pet. 
    if ( lMobTitle ) and ( lMobTitle ~= "" ) then
      if ( string.find( lMobTitle, WNE_MINION ) or 
           string.find( lMobTitle, WNE_GUARDIAN ) or 
           string.find( lMobTitle, WNE_PET ) or 
           string.find( lMobTitle, WNE_CREATION ) ) then
        lMobTitle = '';   
      end
      if ( lMobTitle ~= "" ) then
        if ( string.find( lMobTitle, WNE_LEVEL ) ) then
          lMobTitle = "";
        end;
      end;
      if ( lMobTitle ~= "" ) then
        WNE_NPCInfo[ lMobName ][ "title" ] = lMobTitle;
        --WNE_Print_DebugMsg( "MobTitle " .. lMobTitle );
      end  
    end
    
    -- Fill in the Mob's Minimum Level if necessary		  
    if( WNE_NPCInfo[ lMobName ][ "levelmin" ] > lMobLevel ) then
      WNE_NPCInfo[ lMobName ]["levelmin"] = lMobLevel;
    end
    -- Fill in the Mob's Maximum Level if necessary		  
    if( WNE_NPCInfo[ lMobName ][ "levelmax" ] < lMobLevel ) then
      WNE_NPCInfo[ lMobName ]["levelmax"] = lMobLevel;
    end

	local NPCFactionGroup = UnitFactionGroup("target")
	local NPCUnitClass = UnitClass("target");
	local NPCClassification = UnitClassification("target");
	local NPCCreatureType =  UnitCreatureType("target");
	local CreatureFamily = UnitCreatureFamily("target");

	WNE_NPCInfo[lMobName]["FactionGroup"] = NPCFactionGroup;
	WNE_NPCInfo[lMobName]["Class"] = NPCUnitClass;
	WNE_NPCInfo[lMobName]["Classification"] = NPCClassification;
	WNE_NPCInfo[lMobName]["CreatureType"] = NPCCreatureType;
	WNE_NPCInfo[lMobName]["CreatureFamily"] = CreatureFamily;

    if(zone==0 or zone==1000 or zone==2000 or (px==0 and py==0)) then
      local insttxt = GetZoneText();
      if(not WNE_NPCInfo[lMobName]["instances"]) then
      	WNE_NPCInfo[lMobName]["instances"] = {};				
      	table.insert(WNE_NPCInfo[lMobName]["instances"],insttxt);
      end
      for index, inst in WNE_NPCInfo[lMobName]["instances"] do
      	if(inst==insttxt) then
      		found=true	
      	end
      end		
      if(not found) then 
      	table.insert(WNE_NPCInfo[lMobName]["instances"], insttxt);
      end
    elseif(WNE_NPCInfo[lMobName]["locations"]) then
      for index in WNE_NPCInfo[lMobName]["locations"] do
      	lz=WNE_NPCInfo[lMobName]["locations"][index]["zone"]
      	lc=WNE_NPCInfo[lMobName]["locations"][index]["cont"]
      	lx=WNE_NPCInfo[lMobName]["locations"][index]["x"]
      	ly=WNE_NPCInfo[lMobName]["locations"][index]["y"]					
      	if(lc==cont and lz==zone and lx==px and ly==py) then
      		found=true;
      	end
      end		
      if(not found) then		
      	table.insert(WNE_NPCInfo[lMobName]["locations"], newloc);
      end
    else 
      WNE_NPCInfo[lMobName]["locations"] = {};
      table.insert(WNE_NPCInfo[lMobName]["locations"], newloc);			
    end
  end
end

function WNE_AddLoot() 
  local aName;
  if ( IsFishingLoot () ) then 
    return; 
  end
        
  WNE_Print_DebugMsg( "LootType = " .. WNE_LootType );
  
    -- Make sure the NPC Info exists before adding loot.  Later on we should also check
    -- if loot was obtained by Skinning a mob.
  if ( WNE_LootType == 1 ) or ( WNE_LootType == 2 ) or ( WNE_LootType == 3 ) or ( WNE_LootType == 6 ) then 
    aName = WNE_WorldObject;
    WNE_Print_DebugMsg( "Gathering loot from " .. aName );
  else
    if ( UnitExists("target") and UnitIsDead( "target" ) ) and
       ( ( not UnitPlayerControlled("target") ) and ( not UnitIsPlayer( "target" ) ) ) then
--
--    if ( UnitExists( "target" ) and 
--         UnitIsDead( "target" ) and
--       ( not UnitIsPlayer("target") ) ) then
      aName = UnitName( "target" );
      if not ( WNE_NPCInfo[ aName ] ) then
        WNE_AddUpdateNPC( );
      end
    end  
  end
  
  local aNPCInfo = WNE_NPCInfo[ aName ];
  
  if ( aNPCInfo ) then
 	for i = 1, GetNumLootItems(), 1 do
      if ( LootSlotIsItem( i ) ) then
        iid = GetItemId( GetLootSlotLink( i ) );
        local lootIcon, lootName, lootQuantity, rarity = GetLootSlotInfo( i );
        local lootLink = GetLootSlotLink( i );
        iid = iid..":"..lootName;
        --WNE_Print_DebugMsg( 'lootLink' .. lootLink );



        
        WNE_AddBaseItemInfo( lootLink, lootIcon );

        -- Depending on the WNE_LootType the loot should be added to its propert Loot Array
        if ( WNE_LootType == 4 ) then
          if ( not aNPCINfo[ "skinning" ] ) then
            aNPCInfo[ "skinning" ] = {};
          end  
          aLootArray = aNPCInfo[ "skinning" ];
        end  
        if ( WNE_LootType == 5 ) then
          local lInInventory, lItemID, lItemName = WNE_IsItemInInventory( WNE_WorldObject );
          
          if ( lInInventory ) then
            local lItemInfo = WNE_GetBaseItemInfo( lItemID, lItemName );
            
            if ( lItemInfo ) then	      
              if ( lItemInfo[ "Disenchanted" ] ) then
                lItemInfo[ "Disenchanted" ] = lItemInfo[ "Disenchanted" ] + 1;
              else
                lItemInfo[ "Disenchanted" ] = 0;
              end
              
              if ( not lItemInfo[ "DisLoot" ] ) then
                lItemInfo[ "DisLoot" ] = {};
              end
              aLootArray = lItemInfo[ "DisLoot" ];
            end
          end
          -- The LootArray should be set to the Disenchanted item
          --return
        else
          if( not aNPCInfo["loot"] ) then
            aNPCInfo["loot"] = {};
          end
          aLootArray = aNPCInfo[ "loot" ];
        end
             
        if ( aLootArray ) then
          if ( not ( aLootArray[ iid ] ) ) then
            aLootArray[ iid ] = lootQuantity;
          else
			aLootArray[ iid ] = aLootArray[ iid ] + lootQuantity;
          end
          
          WNE_Print_DebugMsg ( lootQuantity .. " " .. lootName .. " added to " .. aName .. " loot ( loottype " .. WNE_LootType .. " ) " );
        end        
      end
    end	
  end  
  
  WNE_WorldObject = "";
  WNE_LootType = 0;
end

----------------------------------------------------------------------------------------------------
-- Functions Added / Checked by Annunaki
----------------------------------------------------------------------------------------------------

----------------------------------------------------------------------------------------------------
-- WNE_Player_XP_Gained                    This method will be triggered when the player gains XP.
----------------------------------------------------------------------------------------------------

function WNE_Player_XP_Gained()
  WNE_Print_Method_Trace( "e", "WNE_Player_XP_Gained" );
  
  if ( lLastCompletedQuestInfo ) then
    WNE_Print_DebugMsg( "lLastCompletedQuestInfo is Assigned" );
  end
  
  if ( lLastCompletedQuestStoredInfo ) then
    WNE_Print_DebugMsg( "lLastCompletedQuestStoredInfo is Assigned" );
  end
  
  if ( lLastCompletedQuestInfo ) and ( lLastCompletedQuestStoredInfo == nil ) then
    WNE_Print_DebugMsg( "lLastCompletedQuestInfo Assigned but lLastCompletedQuestStoredInfo not, trying to get StoredQuestInfo" );
    lLastCompletedQuestStoredInfo = WNE_GetStoredQuestInfoForLastCompletedQuest( lLastCompletedQuestInfo );
    if ( lLastCompletedQuestStoredInfo ) then
      WNE_Print_DebugMsg( "lLastCompletedQuestStoredInfo is Assigned" );
    end
--    WNE_Quest_Log_Update( );
  end
  
  
  -- We need to catch this event again and check for a LastCompletedQuest if we want to add the XP gained
  -- since the XP is only added sometimes after the CompleteQuest.  A little hack, but looks like it is working
  if ( lLastCompletedQuestStoredInfo ) and ( lLastCompletedQuestInfo ) then
    -- Get the Players current level and XP 
    local lPlayerLevelAfter = UnitLevel( "player" );
    local lPlayerXPAfter    = UnitXP   ( "player" );

    -- Store the EndNPC
    --lLastCompletedQuestStoredInfo[ "EndNPC" ]           = lLastCompletedQuestInfo[ "EndNPC" ];
    --lLastCompletedQuestStoredInfo[ "CompletedAtLevel" ] = lLastCompletedQuestInfo[ "LevelBefore" ];
    
    WNE_Print_DebugMsg ( "LastCompletedQuestInfo Title         " .. lLastCompletedQuestInfo[ "Title" ] );
    WNE_Print_DebugMsg ( "LastCompletedQuestInfo LevelBefore   " .. lLastCompletedQuestInfo[ "LevelBefore" ] );
    WNE_Print_DebugMsg ( "LastCompletedQuestInfo XP Before     " .. lLastCompletedQuestInfo[ "XPBefore" ] );
    WNE_Print_DebugMsg ( "LastCompletedQuestInfo Max XP Before " .. lLastCompletedQuestInfo[ "MaxXPBefore" ] );
    WNE_Print_DebugMsg ( "...................... Level Now     " .. lPlayerLevelAfter );
    WNE_Print_DebugMsg ( "...................... XP Now        " .. lPlayerXPAfter );
    
    
    -- Determine the XP gained from the quest and store it.
    if ( lLastCompletedQuestInfo[ "LevelBefore" ] == lPlayerLevelAfter ) then
      WNE_Print_DebugMsg( "Player didnt level from QuestXP" );
      lLastCompletedQuestStoredInfo[ "QuestXP" ] = lPlayerXPAfter - lLastCompletedQuestInfo[ "XPBefore"    ];
    else
      WNE_Print_DebugMsg( "Player leveled from QuestXP" );
      lLastCompletedQuestStoredInfo[ "QuestXP" ] = ( lLastCompletedQuestInfo[ "MaxXPBefore" ] - lLastCompletedQuestInfo[ "XPBefore"    ] ) + lPlayerXPAfter;
    end
    WNE_Print_DebugMsg( "Quest XPRewarded " .. lLastCompletedQuestStoredInfo[ "QuestXP" ] );

    lLastCompletedQuestStoredInfo[ "EndNPC"  ] = lLastCompletedQuestInfo[ "EndNPC" ];
    lLastCompletedQuestStoredInfo[ "EndItem" ] = lLastCompletedQuestInfo[ "EndItem" ];
    lLastCompletedQuestStoredInfo[ "EndCont" ] = lLastCompletedQuestInfo[ "EndCont" ]; 
    lLastCompletedQuestStoredInfo[ "EndZone" ] = lLastCompletedQuestInfo[ "EndZone" ];
    lLastCompletedQuestStoredInfo[ "EndXLoc" ] = lLastCompletedQuestInfo[ "EndXLoc" ];
    lLastCompletedQuestStoredInfo[ "EndYLoc" ] = lLastCompletedQuestInfo[ "EndYLoc" ]; 
    lLastCompletedQuestStoredInfo[ "CompletedAtLevel" ] = lLastCompletedQuestInfo[ "LevelBefore" ];

    -- If we received some XP, then we can clear all info concerning the LastCompletedQuest
    --if ( lPlayerXPAfter ~= lLastCompletedQuestInfo[ "XPBefore" ] ) then
      lLastCompletedQuestInfo = nil;
      lLastCompletedQuestStoredInfo = nil;
    --end
  end
  WNE_Print_Method_Trace( "x", "WNE_Player_XP_Gained" );
end

----------------------------------------------------------------------------------------------------
-- WNE_QuestRewardCompleteButton_OnClick  This method will be triggered when the user completes a 
--                                         quest.  It will be used to log all information concerning 
--                                         the Quest.
----------------------------------------------------------------------------------------------------

function WNE_QuestRewardCompleteButton_OnClick( )
  WNE_Print_Method_Trace( "e", "WNE_QuestRewardCompleteButton_OnClick" );

  -- In here we will store some Quest Completion stuff into our Quest Array.
  local lQuestTitle                         = GetTitleText();
  local lQuestReward                        = GetRewardText();
  
--  WNE_Print_DebugMsg( "Quest Title       : " .. lQuestTitle       );
--  WNE_Print_DebugMsg( "Quest Reward      : " .. lQuestReward      );
  
  lLastCompletedQuestInfo = {};
  lLastCompletedQuestInfo[ "Title"        ] = lQuestTitle;

  if ( lLastCompletedQuestInfo ) and ( lLastCompletedQuestStoredInfo == nil ) then
    WNE_Print_DebugMsg( "lLastCompletedQuestInfo Assigned but lLastCompletedQuestStoredInfo not, trying to get StoredQuestInfo" );
    lLastCompletedQuestStoredInfo = WNE_GetStoredQuestInfoForLastCompletedQuest( lLastCompletedQuestInfo );
    if ( lLastCompletedQuestStoredInfo ) then
      WNE_Print_DebugMsg( "lLastCompletedQuestStoredInfo is Assigned" );
    end
  end


  if ( not( UnitExists( "NPC" ) ) ) then
    if not ( WNE_IsItemInInventory( UnitName( "NPC" ) ) ) then
      -- We completed a quest at a World Object.
      SetMapToCurrentZone();
      local px, py = GetPlayerMapPosition("player");
      
      px = math.floor( px * 100 );
      py = math.floor( py * 100 );

      lLastCompletedQuestInfo[ "EndItem" ] = UnitName( "NPC" );
      lLastCompletedQuestInfo[ "EndCont" ] = GetCurrentMapContinent(); 
      lLastCompletedQuestInfo[ "EndZone" ] = GetCurrentMapZone();
      lLastCompletedQuestInfo[ "EndXLoc" ] = px;
      lLastCompletedQuestInfo[ "EndYLoc" ] = py; 
      WNE_Print_DebugMsg( "We completed quest at ITEM ( " .. UnitName( "NPC" ) .. " ) that was not in the inventory so it must be a WorldObject" );
    else
      -- We completed the quest from an Inventory Item.
      lLastCompletedQuestInfo[ "QuestType" ] = "ITEM";
      lLastCompletedQuestInfo[ "EndItem" ] = UnitName( "NPC" );
      WNE_Print_DebugMsg( "We completed quest at ITEM ( " .. UnitName( "NPC" ) .. " ) that was in the inventory" );
    end 
  else
    -- We completed the quest at an NPC.
    lLastCompletedQuestInfo[ "EndNPC" ] = UnitName( "NPC" );
    WNE_Print_DebugMsg( "We completed quest at NPC ( " .. UnitName( "NPC" ) .. " )" );
  end
    
  lLastCompletedQuestInfo[ "LevelBefore" ] = UnitLevel( "player" );
  lLastCompletedQuestInfo[ "XPBefore"    ] = UnitXP   ( "player" );
  lLastCompletedQuestInfo[ "MaxXPBefore" ] = UnitXPMax( "player" );
  WNE_Print_DebugMsg( "lLastCompletedQuestInfo Created" );

  -- Since we hooked into this function, it is very important that we call the original fuction !
  originalQuestRewardCompleteButton_OnClick();

  WNE_Print_Method_Trace( "x", "WNE_QuestRewardCompleteButton_OnClick" );
end

----------------------------------------------------------------------------------------------------
-- WNE_QuestDetailAcceptButton_OnClick     This method will be triggered when the user accepts a 
--                                         quest.  It will be used to log all information concerning 
--                                         the Quest.
----------------------------------------------------------------------------------------------------

function WNE_QuestDetailAcceptButton_OnClick( )
  WNE_Print_Method_Trace( "e", "WNE_QuestDetailAcceptButton_OnClick" );

  -- In here we should store the NPC Which gave us this quest and also the QuestDescription and
  -- the QuestObjectives.  This will then be used in another part of the Logging Process to
  -- correctly link this info to a Quest.
  
  local lQuestTitle                         = GetTitleText();
  local lQuestDescription                   = GetQuestText();
  local lQuestObjectives                    = GetObjectiveText();
  local lQuestStartNPC;
  
  lLastAcceptedQuestInfo                  = {};

--  WNE_Print_DebugMsg( "Quest Title       : " .. lQuestTitle       );
--  WNE_Print_DebugMsg( "Quest Description : " .. lQuestDescription );
--  WNE_Print_DebugMsg( "Quest Objectives  : " .. lQuestObjectives  );
  
  -- We Accepted a quest, so we will have to check if we received this quest from an NPC,
  -- an Inventory Item, a World Object or Another Player
  
  -- If the targetted is a Player then we should not log any starting NPC / Item since it is
  -- probably a shared quest.
  if ( UnitIsPlayer( "NPC" ) or UnitIsDeadOrGhost( "NPC" ) or UnitPlayerControlled( "NPC" ) ) then
    WNE_Print_Method_Trace( "x", "WNE_QuestDetailAcceptButton_OnClick" );

    -- Since we hooked into this function, it is very important that we call the original fuction !
    originalQuestDetailAcceptButton_OnClick();
    return;
  end;

  -- Check if the NPC doesn't exist.  Strange trick, but seems to work and we can use it to determine
  -- if we received a quest from an item.  
  if ( not( UnitExists( "NPC" ) ) ) then
    if not ( WNE_IsItemInInventory( UnitName( "NPC" ) ) ) then
      -- We received the quest from a World Object.
      SetMapToCurrentZone();
      local px, py = GetPlayerMapPosition("player");
      
      px = math.floor( px * 100 );
      py = math.floor( py * 100 );

      lLastAcceptedQuestInfo[ "QuestType" ] = "WORLDOBJECT";
      lLastAcceptedQuestInfo[ "StartItem" ] = UnitName( "NPC" );
      lLastAcceptedQuestInfo[ "StartCont" ] = GetCurrentMapContinent(); 
      lLastAcceptedQuestInfo[ "StartZone" ] = GetCurrentMapZone();
      lLastAcceptedQuestInfo[ "StartXLoc" ] = px;
      lLastAcceptedQuestInfo[ "StartYLoc" ] = py; 
      WNE_Print_DebugMsg( "We received the quest from an ITEM ( " .. UnitName( "NPC" ) .. " ) that was not in the inventory so it must be a WorldObject" );
    else
      -- We received the quest from an Inventory Item.
      lLastAcceptedQuestInfo[ "QuestType" ] = "ITEM";
      lLastAcceptedQuestInfo[ "StartItem" ] = UnitName( "NPC" );
      lLastAcceptedQuestInfo[ "StartItemID" ] = WNE_GetItemIDForInventoryItem( UnitName( "NPC" ) );
      
      WNE_Print_DebugMsg( "We received the quest from an ITEM ( " .. UnitName( "NPC" ) .. " ) that was in the inventory" );
    end 
  else
    -- If all previous checks failed, we can assume we got the quest from an NPC.  
    lLastAcceptedQuestInfo[ "QuestType" ] = "NPC";
    lLastAcceptedQuestInfo[ "StartNPC"    ] = UnitName( "NPC" );
    WNE_Print_DebugMsg( "We received the quest from an NPC" .. UnitName( "NPC" ) );  
  end
  
  lLastAcceptedQuestInfo[ "Title"       ] = lQuestTitle; 
  lLastAcceptedQuestInfo[ "Description" ] = lQuestDescription;
  lLastAcceptedQuestInfo[ "Objectives"  ] = lQuestObjectives;

  WNE_Print_Method_Trace( "x", "WNE_QuestDetailAcceptButton_OnClick" );

  -- Since we hooked into this function, it is very important that we call the original fuction !
  originalQuestDetailAcceptButton_OnClick();
end

----------------------------------------------------------------------------------------------------
-- WNE_Quest_Log_Update                    This method will be triggered when the users Quest Log
--                                         gets updated.  In here we will do the main logging of
--                                         quest Related Info.
----------------------------------------------------------------------------------------------------

function WNE_Quest_Log_Update()
  -- Only loop through the QuestLog if a new Quest is Accepted or an existing quest is completed / Finished
  if ( lLastAcceptedQuestInfo  == nil ) and
     ( lLastCompletedQuestInfo == nil ) and
     ( lScanQuestLog == false ) then
    return
  end
  
  WNE_Print_Method_Trace( "e", "WNE_Quest_Log_Update" );
  
  local lNumEntries, lNumQuests = GetNumQuestLogEntries();
  local lQuestHeader;

  for idxQuest = 1, lNumEntries do
    local  lQuestTitle, lQuestLevel, lQuestTag, lQuestIsHeader, lQuestIsCollapsed, lQuestIsComplete = GetQuestLogTitle( idxQuest );   
    
    if ( lQuestIsHeader ) then      
      lQuestHeader = lQuestTitle;
    else
      -- If it isn't a header we should log it  
      SelectQuestLogEntry( idxQuest );

      -- Get some Additional Info and get the stored info for the quest from the SavedVariables Array
      local lQuestDescription, lQuestObjectives = GetQuestLogQuestText();
      local lQuestStoredInfo = WNE_GetStoredQuestInfo( lQuestTitle, lQuestLevel, lQuestTag, lQuestDescription, lQuestObjectives, lQuestHeader );
      local lQuestCompletable = IsQuestCompletable();
      
      -- Title and Objectives should already be there now, so we can add some Additional Stuff
      
      -- Add All the Quest Information for the currently selected quest to the WNE_QUEST Array

      -- Check if we have reccently accepted a quest
      if ( lLastAcceptedQuestInfo ~= nil ) and 
         ( lLastAcceptedQuestInfo[ "Title" ] ~= nil ) and
         ( lLastAcceptedQuestInfo[ "Objectives"  ] ~= nil ) and
         ( lLastAcceptedQuestInfo[ "Title" ] ~= "" ) and
         ( lLastAcceptedQuestInfo[ "Objectives"  ] ~= "" ) then
--        WNE_Print_DebugMsg( "lLastAcceptedQuestInfo not empty" );
--        WNE_Print_DebugMsg( "Stored   Quest Title" .. lQuestStoredInfo      [ "Title"       ] );
--        WNE_Print_DebugMsg( "Accepted Quest Title" .. lLastAcceptedQuestInfo[ "Title"       ] );
--        WNE_Print_DebugMsg( "Stored   Quest Objectives" .. lQuestStoredInfo      [ "Objectives"       ] );
--        WNE_Print_DebugMsg( "Accepted Quest Objectives" .. lLastAcceptedQuestInfo[ "Objectives"       ] );
         
        -- Check if the current quest in the QuestLog matches the last accepted quest 
        if ( lLastAcceptedQuestInfo[ "Title"       ] == lQuestStoredInfo[ "Title"       ] ) and
           ( lLastAcceptedQuestInfo[ "Objectives"  ] == lQuestStoredInfo[ "Objectives"  ] ) and
         ( ( lQuestStoredInfo[ "QuestType" ] == "UNKNOWN" ) or ( lQuestStoredInfo[ "QuestType" ] == nil ) ) then
          lQuestStoredInfo[ "QuestType"   ] =  lLastAcceptedQuestInfo[ "QuestType"  ];
          lQuestStoredInfo[ "StartItem"   ] =  lLastAcceptedQuestInfo[ "StartItem"  ];
          lQuestStoredInfo[ "StartItemID" ] =  lLastAcceptedQuestInfo[ "StartItemID"];
          lQuestStoredInfo[ "StartNPC"    ] =  lLastAcceptedQuestInfo[ "StartNPC"   ];
          lQuestStoredInfo[ "StartCont"   ] =  lLastAcceptedQuestInfo[ "StartCont" ]; 
          lQuestStoredInfo[ "StartZone"   ] =  lLastAcceptedQuestInfo[ "StartZone" ];
          lQuestStoredInfo[ "StartXLoc"   ] =  lLastAcceptedQuestInfo[ "StartXLoc" ];
          lQuestStoredInfo[ "StartYLoc"   ] =  lLastAcceptedQuestInfo[ "StartYLoc" ]; 

          --**************************2006-4-18*********************************************
          lQuestStoredInfo[ "QuestDescription"   ] =lQuestDescription ; --GetQuestText()


          local money = GetRewardMoney();
	    if (money == nil) then
		money = 0;
	  end
          lQuestStoredInfo[ "RewardMoney"   ] =  money; 

          --**************************2006-4-18*********************************************

          WNE_Print_DebugMsg( "Checking quest log entry " .. idxQuest .. " : " .. lQuestTitle .. " Last Accepted Quest" );
          lLastAcceptedQuestInfo = Nil;
        end
      end  

      WNE_Print_DebugMsg( "Before adding Quest Rewards" );
      
      if ( lQuestStoredInfo ) then
        -- Add the Quest Rewards if there are any
        local lRewards = GetNumQuestLogRewards();
        local lChoices = GetNumQuestLogChoices();
        
        if ( lRewards ) then        
          for idxReward = 1, lRewards, 1 do
            WNE_Print_DebugMsg( "Processing Reward " .. idxReward );
            local lName, lTexture, lQuality, lIsUsable = GetQuestLogRewardInfo( idxReward );
            local lItemLink = GetQuestLogItemLink( "reward", idxReward );
                       
            if ( lItemLink ) and ( lTexture ) then
              local lItemInfo = WNE_AddBaseItemInfo( lItemLink, lTexture );
              
              if ( lItemInfo ) then
                if ( not ( lQuestStoredInfo[ "Rewards" ] ) ) then
                  lQuestStoredInfo[ "Rewards" ] = {};
                end
                lQuestStoredInfo[ "Rewards" ][ lItemInfo[ "Item" ] .. ":" .. lItemInfo[ "Name" ] ] = "R";
              end
            end
          end
        end
        
      
        -- Add the Optional Rewards if there are any
        if ( lChoices ) then        
          for idxReward = 1, lChoices, 1 do
            WNE_Print_DebugMsg( "Processing Optional Reward " .. idxReward );
            local lName, lTexture, lQuality, lIsUsable = GetQuestLogChoiceInfo( idxReward );
            local lItemLink = GetQuestLogItemLink( "choice", idxReward );
            
            
            if ( lItemLink ) and ( lTexture ) then
              local lItemInfo = WNE_AddBaseItemInfo( lItemLink, lTexture );
              
              if ( lItemInfo ) then
                if ( not ( lQuestStoredInfo[ "Rewards" ] ) ) then
                  lQuestStoredInfo[ "Rewards" ] = {};
                end
                lQuestStoredInfo[ "Rewards" ][ lItemInfo[ "Item" ] .. ":" .. lItemInfo[ "Name" ] ] = "C";
              end
            end
          end
        end
      end  
      
      if ( lLastCompletedQuestInfo ~= nil ) and 
         ( lLastCompletedQuestInfo[ "Title" ] == lQuestStoredInfo[ "Title" ] ) then
        WNE_Print_DebugMsg( "Found last completed quest in QuestLog" );
        if ( IsQuestCompletable() ) then
          WNE_Print_DebugMsg( "The last completed quest in QuestLog is Completable" );
          lLastCompletedQuestStoredInfo = lQuestStoredInfo;
          WNE_Print_DebugMsg( "Assigned something to the lLastCompletedQuestStoredInfo" );
        else
          WNE_Print_DebugMsg( "The last completed quest in QuestLog is Not Completable" );
        end
      end
      
    end
    lScanQuestLog = false;
 end
  
  WNE_Print_Method_Trace( "x", "WNE_Quest_Log_Update" );
end

function WNE_GetStoredQuestInfoForLastCompletedQuest( aLastCompletedQuestInfo )
  WNE_Print_Method_Trace( "e", "WNE_GetStoredQuestInfoForLastCompletedQuest" );
  
  local lNumEntries, lNumQuests = GetNumQuestLogEntries();
  local lQuestHeader;

  for idxQuest = 1, lNumEntries do
    local  lQuestTitle, lQuestLevel, lQuestTag, lQuestIsHeader, lQuestIsCollapsed, lQuestIsComplete = GetQuestLogTitle( idxQuest );   
       
    if ( lQuestIsHeader ) then      
      lQuestHeader = lQuestTitle;
      if ( lQuestIsCollapsed ) then
        -- If we found a collapsed header, make sure it gets expanded
        --ExpandQuestHeader( idxQuest );
      end
    else
      -- If it isn't a header we should log it  
      SelectQuestLogEntry( idxQuest );

      -- Get some Additional Info and get the stored info for the quest from the SavedVariables Array
      local lQuestDescription, lQuestObjectives = GetQuestLogQuestText();
      local lQuestStoredInfo = WNE_GetStoredQuestInfo( lQuestTitle, lQuestLevel, lQuestTag, lQuestDescription, lQuestObjectives, lQuestHeader );
      local lQuestCompletable = IsQuestCompletable();
      
      if ( aLastCompletedQuestInfo ~= nil ) and 
         ( aLastCompletedQuestInfo[ "Title" ] == lQuestStoredInfo[ "Title" ] ) then
        WNE_Print_DebugMsg( "Found last completed quest in QuestLog" );
        return lQuestStoredInfo;
      end  
    end
  end

  WNE_Print_Method_Trace( "x", "WNE_GetStoredQuestInfoForLastCompletedQuest" );

end

----------------------------------------------------------------------------------------------------
-- WNE_GetStoredQuestInfo                  This method will be used to get the information we have
--                                         stored for a quest with the given Title and Objectives.
----------------------------------------------------------------------------------------------------

function WNE_GetStoredQuestInfo( aQuestTitle, aQuestLevel, aQuestTag, aQuestDescription, aQuestObjectives, aQuestHeader )
  local lWNEQuestInfo = nil;
  local lAllianceHorde = UnitFactionGroup( "player" );
  local lClass = UnitClass("player" );
  local lRace = UnitRace("player" );
  
  if ( lAllianceHorde == "Alliance" ) then
    lAllianceHorde = "A";
  else
    lAllianceHorde = "H";  
  end
  
  --WNE_Print_DebugMsg( "UnitFactionGroup " .. UnitFactionGroup( "player" ) .. " .. " .. lAllianceHorde );
  
  -- Check if we already have the info for this quest stored in our Array
  if ( WNE_QuestInfo ) then
    for lQuestIndex, lQuestInfo in WNE_QuestInfo do
      if ( lQuestInfo[ "Title"      ] == aQuestTitle      ) and
         ( lQuestInfo[ "Objectives" ] == aQuestObjectives ) then
        lWNEQuestInfo = lQuestInfo; 
        break;
      end
    end
  end
  
  -- If lWNEQuestInfo is still empty, then we don't have any info for this Quest yet.
  if ( lWNEQuestInfo == nil ) then
    -- Create a QuestInfo item
    lWNEQuestInfo = {};
    lWNEQuestInfo[ "Title"      ] = aQuestTitle;
    lWNEQuestInfo[ "Objectives" ] = aQuestObjectives;
    lWNEQuestInfo[ "QuestType"  ] = "UNKNOWN";
    
    -- if our QuestInfo array in the SavedVariables is still empty, make sure it is created
    if ( WNE_QuestInfo == nil ) then
      WNE_QuestInfo = {};
    end
    
    -- Add the QuestInfo item to the WNE_QuestInfo array
    table.insert( WNE_QuestInfo, lWNEQuestInfo );
    WNE_Print_DebugMsg( "Stored Quest Info wasn't available so it was created" );
  end;
  
  -- Check if we need to add some other stuff to the QuestInfo
  if ( lWNEQuestInfo ~= nil ) then
    -- Check if we need to update the QuestLevel
    if ( lWNEQuestInfo[ "QuestType" ] == nil ) or ( lWNEQuestInfo[ "QuestType" ] == "" ) then
      lWNEQuestInfo[ "QuestType" ] = "UNKNOWN";
    end

    -- Check if we need to update the QuestLevel
    if ( lWNEQuestInfo[ "Level" ] ~= aQuestLevel ) and
       ( aQuestLevel ~= nil ) then
      lWNEQuestInfo[ "Level" ] = aQuestLevel;
      WNE_Print_DebugMsg( "Stored Quest : Quest Level Updated" );
    end

    -- Check if we need to update the QuestTag
    if ( lWNEQuestInfo[ "Tag" ] ~= aQuestTag ) and
       ( aQuestTag ~= nil ) then
      lWNEQuestInfo[ "Tag" ] = aQuestTag;
      WNE_Print_DebugMsg( "Stored Quest : Quest Tag Updated" );
    end

    -- Check if we need to update the QuestHeader / QuestGroup
    if ( lWNEQuestInfo[ "Header" ] ~= aQuestHeader ) and
       ( aQuestHeader ~= nil ) then
      lWNEQuestInfo[ "Header" ] = aQuestHeader;
      WNE_Print_DebugMsg( "Stored Quest : Quest Header Updated" );
    end
    
    --WNE_Print_DebugMsg( "lWNEQuestInfo[ QuestFaction ]" .. lWNEQuestInfo[ "QuestFaction" ] );
     
    if ( lAllianceHorde ) and ( lAllianceHorde ~= nil ) then
      if ( lWNEQuestInfo[ "QuestFaction" ] ~= lAllianceHorde ) then
        if ( lWNEQuestInfo[ "QuestFaction" ] == "A" ) or
           ( lWNEQuestInfo[ "QuestFaction" ] == "H" ) then          
          -- if we did have it and it's different than the Faction of the current player, then its a quest which can be done by both sides
          WNE_Print_DebugMsg( "Stored Quest : Quest Faction changed from ".. lWNEQuestInfo[ "QuestFaction" ] .. " to AH" );
          lWNEQuestInfo[ "QuestFaction" ] = "AH";
        else
          -- if we didn't have the QuestFaction yet, then add it.
          if ( lWNEQuestInfo[ "QuestFaction" ] ) then
            WNE_Print_DebugMsg( "Stored Quest : Quest Faction changed from ".. lWNEQuestInfo[ "QuestFaction" ] .. " to " ..  lAllianceHorde );
          else
            WNE_Print_DebugMsg( "Stored Quest : Quest Faction initialised to " ..  lAllianceHorde );
          end  
          lWNEQuestInfo[ "QuestFaction" ] = lAllianceHorde;
        end
      end
    else
      WNE_Print_DebugMsg( "Something was wrong with lAllianceHorde" );
    end
    lWNEQuestInfo[ "QuestClass" ] = lClass;
    lWNEQuestInfo[ "QuestRace" ] = lRace;
  end 
  
  return lWNEQuestInfo;
end

----------------------------------------------------------------------------------------------------
-- WNE_IsItemInInventory                   This method will be used to check if there is an item in
--                                         our inventory with the given name.
----------------------------------------------------------------------------------------------------

function WNE_IsItemInInventory( aItemName )
  local bag, slot, color, item, name, link;

  for bag = 0,4 do
    for slot = 1,GetContainerNumSlots(bag) do	-- loop through all slots in this bag and get items
      link = GetContainerItemLink(bag, slot);
      if( link ) then
        for color, item, name in string.gfind(link, "|c(%x+)|Hitem:(%d+:%d+:%d+:%d+)|h%[(.-)%]|h|r") do
          if ( name ~= nil ) and ( name == aItemName ) then
            return true, item, name;
          end
        end
      end
    end
  end
  return false;
end

----------------------------------------------------------------------------------------------------
-- WNE_GetItemIDForInventoryItem - This method will be used to get the ItemID for an item in our
--                                 inventory with the given name.
----------------------------------------------------------------------------------------------------

function WNE_GetItemIDForInventoryItem( aItemName )
  local bag, slot, color, item, name, link, itemid;

  WNE_Print_Method_Trace( "x", "WNE_GetItemIDForInventoryItem" );

  for bag = 0,4 do
    for slot = 1,GetContainerNumSlots(bag) do	-- loop through all slots in this bag and get items
      link = GetContainerItemLink(bag, slot);
      if( link ) then
        for color, item, name in string.gfind(link, "|c(%x+)|Hitem:(%d+:%d+:%d+:%d+)|h%[(.-)%]|h|r") do
          if ( name ~= nil ) and ( name == aItemName ) then
            itemid = string.gsub( item, "^(%d+):(%d+):(%d+):(%d+)$", "%1:0:%3:%4");
            WNE_Print_DebugMsg( "Item ".. aItemName .. " found in inventory, ItemID : " .. itemid );
            return itemid;
          end
        end
      end
    end
  end
  WNE_Print_DebugMsg( "Item ".. aItemName .. " not found in inventory" );
  WNE_Print_Method_Trace( "x", "WNE_GetItemIDForInventoryItem" );
  return nil;
end

----------------------------------------------------------------------------------------------------
-- WNE_AddTargetToTargetHistory - This method will be used to to add our current Target to our 
--                                of Targets.
----------------------------------------------------------------------------------------------------

function WNE_AddTargetToTargetHistory( )
  if WNE_TargetHistory[ UnitName ( "Target" ) ] == nil then
    WNE_TargetHistory[ UnitName ( "Target" ) ] = {};
  end;
end

function WNE_ClearTargetHistory()
  WNE_TargetHistory = {};
end;

function WNE_CheckTargetDeath(arg1)
  if arg1 ~= nil then
	  if ( UnitHealth( "target" ) == 0 ) or
	     ( UnitIsCorpse( "target" ) ) or
	     ( UnitIsDeadOrGhost( "target" ) ) then
	   if ( arg1 == WNE_CurrentTargetName ) then
	     WNE_AddNPCKill(arg1);
	     -- AddKill
	     -- ClearTarget
	   end  
	  end   
  end
end

function WNE_AddNPCKill(arg1)
  local NPCInfo = WNE_NPCInfo[ arg1 ];
  
  if ( NPCInfo ~= nil ) then
    if ( NPCInfo[ "Kills" ] == nil ) then
       NPCInfo[ "Kills" ] = 1;
    else
       NPCInfo[ "Kills" ] =  NPCInfo[ "Kills" ] + 1;
    end
    WNE_Print_InfoMsg( "You killed " .. arg1 .. " " .. NPCInfo[ "Kills" ] .. " time(s)." );
    WNE_CurrentTargetName = "";
  end
end;

----------------------------------------------------------------------------------------------------
-- WNE_ParseSelfBuff - This method will be used to Parse Self Buff Chat messages to see if we are
--                     Skinning, Mining, Herbcrafting, Opening or even Disenchanting.
----------------------------------------------------------------------------------------------------

function WNE_ParseSelfBuff( aMsg )
  WNE_Print_Method_Trace( "e", "WNE_ParseSelfBuff" );
  
  local _, _, lGatherAction, lGatherTarget = string.find( aMsg, WNE_GATHER_EXEC );

  if ( UnitName( "NPC" ) ) and ( lGatherAction ) then
    WNE_Print_DebugMsgt( "UnitName(NPC) = " .. UnitName( "NPC" ) .. " Parsing Self Buff " .. lGatherAction );
  end;

  WNE_WorldObject = lGatherTarget;
  
  -- We need to check here if one of the Resource Gathering actions was executed, if that is / was the case, we should add the
  -- WorldObject on which a Gather Action was executed so we can use it later on to attach loot to that World Object.
  if ( lGatherAction == WNE_GATHER_HERB ) then
    WNE_Print_DebugMsg( WNE_WorldObject .. " is some kind of Herb." );   
    WNE_LootType = 1; -- HerbGathering
  elseif ( lGatherAction == WNE_GATHER_MINE ) then
    WNE_Print_DebugMsg( WNE_WorldObject .. " is some kind of Mineral." );   
    WNE_LootType = 2; -- Mining
  elseif ( lGatherAction == WNE_GATHER_WOBJ ) then
    WNE_LootType = 6; -- By Default we will set the LootType to Other

    -- Loop over all Predifined Trasure Types and check if the Tekst was found in our WorldObject.
    for WNE_TreasureTypeName in WNE_Treasure_Index[0] do
      if ( string.find( string.lower( WNE_WorldObject ), WNE_TreasureTypeName ) ) then
        WNE_Print_DebugMsg( WNE_WorldObject .. " contains " .. WNE_TreasureTypeName .. " so it is a Treasure Type world object" );
        WNE_LootType = 3; -- Treasure
      end
    end
  elseif ( lGatherAction == WNE_GATHER_SKIN ) then
    WNE_LootType = 4; -- Skinning
  elseif ( lGatherAction == WNE_GATHER_DISN ) and ( WNE_IsItemInInventory( WNE_WorldObject ) ) then
    WNE_LootType = 5; -- Disenchanting
  else
    WNE_LootType = 0;
    WNE_WorldObject = nil;
  end
  
  if ( WNE_LootType == 1 ) or ( WNE_LootType == 2 ) or ( WNE_LootType == 3 ) or ( WNE_LootType == 6 ) then 
    WNE_AddWorldObject( WNE_WorldObject, WNE_LootType );
  end;
   
  WNE_Print_Method_Trace( "x", "WNE_ParseSelfBuff" );
end

----------------------------------------------------------------------------------------------------
-- WNE_AddWorldObject - This method will be used to Add a World Object and it's Location to the NPC
--                      array.
----------------------------------------------------------------------------------------------------

function WNE_AddWorldObject( aWorldObject, aWorldObjectType )
  WNE_Print_Method_Trace( "e", "WNE_AddWorldObject" );
  WNE_Print_DebugMsg( "Adding WorldObject " .. aWorldObject .. " of type " .. aWorldObjectType );

  if ( aWorldObject == nil ) then
    return;
  end

  -- First make sure there is an entry in the NPC Array for this World Object
  if ( WNE_NPCInfo[ aWorldObject ] == nil ) then
    WNE_NPCInfo[ aWorldObject ] = {};
    WNE_NPCInfo[ aWorldObject ][ "WorldObjectType" ] = aWorldObjectType;
    WNE_NPCInfo[ aWorldObject ][ "Kills" ] = 0;
  end
    
  local aNPCInfo = WNE_NPCInfo[ aWorldObject ];
  
  if ( aNPCInfo ) then
    WNE_Print_InfoMsg( "World Object " .. aWorldObject .. " exists in NPC Array" );
    if ( aNPCInfo[ "Kills" ] == nil ) then
      aNPCInfo[ "Kills" ] = 1;
    end  
    aNPCInfo[ "Kills" ] = aNPCInfo[ "Kills" ] + 1;
  end
  
  SetMapToCurrentZone();
  local px, py = GetPlayerMapPosition("player");
  local cont = GetCurrentMapContinent();
  local zone = GetCurrentMapZone();
  local found =false;
  px=math.floor(px*100);
  py=math.floor(py*100);
  local newloc={ ["cont"]=cont, ["zone"]=zone, ["x"]=px, ["y"]=py, ["timesseen"] = 1 };
  
  if ( zone == 0 ) then
    WNE_Print_DebugMsg( "Zone is 0" );
  end
  if ( zone == 10000 ) then
    WNE_Print_DebugMsg( "Zone is 1000" );
  end
  if ( zone == 2000 ) then
    WNE_Print_DebugMsg( "Zone is 2000" );
  end
  if ( px == 0 and py == 0 ) then
    WNE_Print_DebugMsg( "both locations are 0" );
  end

  if ( zone == 0 or zone == 1000 or zone == 2000 or ( px == 0 and py == 0 ) ) then
    -- Make sure there is an Instances array in our NPC Info
    if ( aNPCInfo[ "instances" ] == nil ) then
      aNPCInfo[ "instances" ] = {};
    end  
    local InstanceName = GetZoneText( );
    -- Loop through the Instances array to see if we have already an entry for this Instance
    for Index, Inst in aNPCInfo[ "instances" ] do
      if ( Inst == InstanceName ) then
        found = true;
      end
    end
    -- If we didn't see it in this instance yet, we should add the new location
    if ( not found ) then
      table.insert( aNPCInfo[ "instances" ], InstanceName );
    end
  else
    -- Make sure there is a Locations array in our NPC Info
    if ( aNPCInfo[ "locations" ] == nil ) then
      aNPCInfo[ "locations" ] = {};
    end
    -- Loop through the Locations array to see if we have already an entry for this location
    for Index in aNPCInfo[ "locations" ] do
      lz = aNPCInfo[ "locations" ][ Index]["zone"];
      lc = aNPCInfo[ "locations" ][ Index]["cont"];
      lx = aNPCInfo[ "locations" ][ Index]["x"];
      ly = aNPCInfo[ "locations" ][ Index]["y"];					
      if(lc==cont and lz==zone and lx==px and ly==py) then
        if (  aNPCInfo[ "locations" ][ Index][ "timesseen" ] == nil ) then
           aNPCInfo[ "locations" ][ Index][ "timesseen" ] = 1;
        end
        aNPCInfo[ "locations" ][ Index][ "timesseen" ] = aNPCInfo[ "locations" ][ Index][ "timesseen" ] + 1;
        found=true;
      end
    end
    -- If we didn't see it at this location yet, we should add the new location
    if(not found) then		
      table.insert( aNPCInfo["locations"], newloc );
    end
  end
  WNE_Print_Method_Trace( "x", "WNE_AddWorldObject" );
end;

----------------------------------------------------------------------------------------------------
-- WNE_LogTrainerInfo                      This method will be used to log all Trainer Related
--                                         Info.
----------------------------------------------------------------------------------------------------

function WNE_LogTrainerInfo()
  WNE_Print_Method_Trace( "x", "WNE_LogTrainerInfo" );

  if ( IsTradeskillTrainer() ) then
    WNE_LogTradeSkillTrainerInfo();
  end
 
  WNE_Print_Method_Trace( "x", "WNE_LogTrainerInfo" );
end

----------------------------------------------------------------------------------------------------
-- WNE_LogTradeSkillTrainerInfo            This method will be used to log all TradeSkill Trainer 
--                                         Related Info.
----------------------------------------------------------------------------------------------------

function WNE_LogTradeSkillTrainerInfo()
  WNE_Print_Method_Trace( "x", "WNE_LogTradeSkillTrainerInfo" );

  local lTrainerName = UnitName( "NPC" );
  SetTrainerServiceTypeFilter("used", 1);

  local lTrainerGreeting = GetTrainerGreetingText();
  local lNumTrainerServices = GetNumTrainerServices();
  local lServiceCategory = "";
 
  for idx = 1, lNumTrainerServices,  1 do
    local lServiceName, lServiceSubText, lServiceType, lIsExpanded = GetTrainerServiceInfo( idx );
    local lServiceSkillName, lServiceSkillAmt = GetTrainerServiceSkillReq( idx );   
    local lServiceDesc = GetTrainerServiceDescription( idx );
    local lServiceIcon = GetTrainerServiceIcon( idx );
    local lServiceCost, lServiceCost1, lServiceCost2 = GetTrainerServiceCost( idx );
    
    if ( lServiceType == "header" ) then
      lServiceCategory = lServiceName;
    else
      WNE_Print_DebugMsg( "lServiceName       : " .. lServiceName );    
      WNE_Print_DebugMsg( "lServiceCategory   : " .. lServiceCategory );    
      WNE_Print_DebugMsg( "lServiceSubText    : " .. lServiceSubText );    
      WNE_Print_DebugMsg( "lServiceCost       : " .. lServiceCost );

      if ( lServiceCost1 ) then
        WNE_Print_DebugMsg( "lServiceCost1      : " .. lServiceCost1 );
      end
      if ( lServiceCost2 ) then
        WNE_Print_DebugMsg( "lServiceCost2      : " .. lServiceCost2 );
      end
      if ( lServiceDesc ) then
        WNE_Print_DebugMsg( "lServiceDesc       : " .. lServiceDesc );    
      end
      
      -- Check if we found a Min Skill Level Requirement
      if ( lServiceSkillName ) then
        WNE_Print_DebugMsg( "lServiceSkillName  : " .. lServiceSkillName );    
        WNE_Print_DebugMsg( "lServiceSkillAmt   : " .. lServiceSkillAmt );    
                    
        local lProfessionInfo = WNE_GetProfessionInfo( lServiceSkillName, lServiceName );
        
        if ( lProfessionInfo ) then
          if ( lServiceSkillAmt ) then
            lProfessionInfo[ "ReqSkillLevel" ] = lServiceSkillAmt;
            WNE_Print_DebugMsg( lServiceSkillName .. " Recipe " .. lServiceName .. " found in WNE_Profession, Skill level should be set to " .. lServiceSkillAmt );
          end        
          
          if ( lServiceCategory ) and ( lProfessionInfo[ "Category" ] ~= lServiceCategory ) then
            lProfessionInfo[ "Category" ] = lServiceCategory;
          end     
          if ( lServiceIcon ) and ( lProfessionInfo[ "Icon" ] ~= lServiceIcon ) then
            lProfessionInfo[ "Icon" ] = lServiceIcon;
          end     
          if ( lServiceDesc ) and ( lProfessionInfo[ "Description" ] ~= lServiceDesc ) then
            lProfessionInfo[ "Description" ] = lServiceDesc;
          end     
          if ( lServiceCost ) and ( lProfessionInfo[ "TrainCost" ] ~= lServiceCost ) then
            lProfessionInfo[ "TrainCost" ] = lServiceCost;
          end     
        end
      end
      --WNE_Print_DebugMsg( "lServiceType       : " .. lServiceType );    
    end  
  end
  
  SetTrainerServiceTypeFilter("used", 0);
  
--  WNE_Print_DebugMsg( "lTrainerName       : " .. lTrainerName );
--  WNE_Print_DebugMsg( "lTrainerGreeting   : " .. lTrainerGreeting );
  
  
  WNE_Print_Method_Trace( "x", "WNE_LogTradeSkillTrainerInfo" );
end

----------------------------------------------------------------------------------------------------
-- WNE_LogTradeSkillInfo                   This method will be used to log all TradeSkill Related
--                                         Info ( Recipe + Reagents ).
----------------------------------------------------------------------------------------------------

function WNE_LogTradeSkillInfo( )
  WNE_Print_Method_Trace( "e", "WNE_LogTradeSkillInfo" );

  local lNumTradeSkills = GetNumTradeSkills();
  local lTradeSkillCategory = '';
  local lTradeSkillLineArray;
  local lTradeSkillInfo;
  
  -- Make sure our WNE_Professions Array Exists before we continue
  if not ( WNE_Professions ) then
    WNE_Professions = {};
  end
  
  -- If the Character doesn't have any Trade Skills, there is no need to continue
  if ( lNumTradeSkills == 0 ) then
    WNE_Print_Method_Trace( "x", "WNE_LogTradeSkillInfo" );
    return;
  end
  
  -- Loop over each TradeSkill to get some Base Info
  for idx = 1, lNumTradeSkills,  1 do
    local lTradeSkillName, lTradeSkillType, lNumAvailable, lIsExpanded = GetTradeSkillInfo( idx );
           
    if ( lTradeSkillName ) then
      if ( lTradeSkillType == "header" ) then
        lTradeSkillCategory = lTradeSkillName;
      else
        SelectTradeSkill( idx );
        
        local lTradeSkillLineName, lTradeSkillLineRank, lTradeSkillLineMaxRank = GetTradeSkillLine();
        local lTradeSkillMinMade, lTradeSkillMaxMade = GetTradeSkillNumMade( idx );
        local lTradeSkillIcon = GetTradeSkillIcon( idx );
        local lTradeSkillResultItemLink = GetTradeSkillItemLink( idx );
        local lTradeSkillResult = WNE_AddBaseItemInfo( lTradeSkillResultItemLink, lTradeSkillIcon );
      
        if not ( WNE_Professions[ lTradeSkillLineName ] ) then
          WNE_Professions[ lTradeSkillLineName ] = {};
        end
        
        lTradeSkillLineArray = WNE_Professions[ lTradeSkillLineName ];
    
        if not ( lTradeSkillLineArray[ lTradeSkillName ] ) then
          lTradeSkillLineArray[ lTradeSkillName ] = {};
        end
        
        lTradeSkillInfo = lTradeSkillLineArray[ lTradeSkillName ];
        
        if ( lTradeSkillInfo[ "Category" ] ~= lTradeSkillCategory ) then
          lTradeSkillInfo[ "Category" ] = lTradeSkillCategory;
        end     
        if ( lTradeSkillInfo[ "Icon" ] ~= lTradeSkillIcon ) then
          lTradeSkillInfo[ "Icon" ] = lTradeSkillIcon;
        end     

        if ( lTradeSkillResult ) then
          lTradeSkillInfo[ "Result" ] = lTradeSkillResult[ "Item" ] .. ":" .. lTradeSkillResult[ "Name" ];
        end
        
        --WNE_Print_DebugMsg( "lTradeSkillName        : " .. lTradeSkillName );
        --WNE_Print_DebugMsg( "lTradeSkillType        : " .. lTradeSkillType );
        --WNE_Print_DebugMsg( "lTradeSkillCategory    : " .. lTradeSkillCategory );
        --WNE_Print_DebugMsg( "lTradeSkillLineName    : " .. lTradeSkillLineName );
        --WNE_Print_DebugMsg( "lTradeSkillLineRank    : " .. lTradeSkillLineRank );
        --WNE_Print_DebugMsg( "lTradeSkillLineMaxRank : " .. lTradeSkillLineMaxRank );
        --WNE_Print_DebugMsg( "lTradeSkillMinMade     : " .. lTradeSkillMinMade );
        --WNE_Print_DebugMsg( "lTradeSkillMaxMade     : " .. lTradeSkillMaxMade );
        --WNE_Print_DebugMsg( "lTradeSkillIcon        : " .. lTradeSkillIcon );
        --WNE_Print_DebugMsg( "lTradeSkillResultItemLink      : " .. lTradeSkillResultItemLink );
        
        -- Now Add the Reagents to the TradeSkill Recipe
        local lNumReagents = GetTradeSkillNumReagents( idx );
        
        -- If there are Reagents, make sure that we have a Reagents Array
        if ( lNumReagents ~= 0 ) then
          if not ( lTradeSkillInfo[ "Reagents" ] ) then
            lTradeSkillInfo[ "Reagents" ] = {};
          end
        end
        
        local lReagents = lTradeSkillInfo[ "Reagents" ];
         
        for ridx = 1, lNumReagents, 1 do
          local lReagentName, lReagentTexture, lReagentCount, lPlayerReagentCount = GetTradeSkillReagentInfo( idx, ridx );
          local lReagentItemLink = GetTradeSkillReagentItemLink( idx, ridx )
          local lReagentInfo = WNE_AddBaseItemInfo( lReagentItemLink, lReagentTexture );
          
          if ( lReagentInfo ) then
            local aItemIdx = lReagentInfo[ "Item" ] .. ":" .. lReagentInfo[ "Name" ];
            
            if not ( lReagents[ aItemIdx ] ) then
              lReagents[ aItemIdx ] = lReagentCount;
            end
          end
        end
      end
    end
  end
  WNE_Print_Method_Trace( "x", "WNE_LogTradeSkillInfo" );
end

function WNE_GetProfessionInfo( aProfessionName, aRecipeName )
  if not ( WNE_Professions ) then
    WNE_Professions = {};
  end
  
  if not ( WNE_Professions[ aProfessionName ] ) then
    WNE_Professions[ aProfessionName ] = {};
  end
  
  if not ( WNE_Professions[ aProfessionName ][ aRecipeName ] ) then
    WNE_Professions[ aProfessionName ][ aRecipeName ] = {};
  end

  return WNE_Professions[ aProfessionName ][ aRecipeName ];
end

----------------------------------------------------------------------------------------------------
-- WNE_LogMerchantInfo                     This method will be used to log all Items a Merchant is
--                                         Selling.
----------------------------------------------------------------------------------------------------

function WNE_LogMerchantInfo() 
  WNE_Print_Method_Trace( "e", "WNE_LogMerchantInfo" );
  
  local lMerchantName = UnitName( "NPC" );
  local lMerchantItems = GetMerchantNumItems();

  for lcv=1, lMerchantItems, 1 do
    local itemButton = getglobal( "MerchantItem"..lcv.."ItemButton" );
    local merchantButton = getglobal( "MerchantItem"..lcv);
    local lValue;
	local lMerchantItemLink = GetMerchantItemLink( lcv );
  
    local lVendorItemName, lVendorItemTexture, lVendorItemPrice, lVendorItemQuantity, lVendorItemNumAvailable, lVendorItemIsUsable=GetMerchantItemInfo( lcv );

	if ( lMerchantItemLink ) then
      local lItemInfo = WNE_AddBaseItemInfo( lMerchantItemLink, lVendorItemTexture ); 

	  lItemID = lItemInfo[ "Item" ]..":"..lItemInfo[ "Name" ];
	  
	  if ( WNE_NPCInfo[ lMerchantName ] ) then
	    if ( not WNE_NPCInfo[ lMerchantName ][ "inv" ] ) then
	      WNE_NPCInfo[ lMerchantName ][ "inv" ] = {};
	    end
	    
	    if ( not ( WNE_NPCInfo[ lMerchantName ]["inv"][lItemID] ) ) then
	      WNE_NPCInfo[ lMerchantName ]["inv"][lItemID] = {};
	      WNE_NPCInfo[ lMerchantName ][ "inv" ][lItemID]["ItemPrice"] = lVendorItemPrice;
	      WNE_NPCInfo[ lMerchantName ][ "inv" ][lItemID]["NumAvailable"] = lVendorItemNumAvailable;
	    end
	  end
	end
  end       
  WNE_Print_Method_Trace( "e", "WNE_LogMerchantInfo" );
end

----------------------------------------------------------------------------------------------------
-- General Item Information Routines
----------------------------------------------------------------------------------------------------

----------------------------------------------------------------------------------------------------
-- WNE_GetBaseInfo                         This method will be used to retrieve the Base ItemInfo
--                                         for a given ItemID and ItemName.  If the Base ItemInfo
--                                         wasn't found a new one will be created and Returned.
----------------------------------------------------------------------------------------------------

function WNE_GetBaseItemInfo( aItemID, aItemName )



  WNE_Print_Method_Trace( "e", "WNE_GetBaseItemInfo" );

  -- if our ItemInfo array in the SavedVariables is still empty, make sure it is created
  if ( WNE_ItemInfo == nil ) then
    WNE_ItemInfo = {};
  end

  if ( aItemID ) and ( aItemName ) then
    local aItemIdx = aItemID .. ":" .. aItemName;
    local lItemInfo;
    
    if ( WNE_ItemInfo[ aItemIdx ] ) then
      --WNE_Print_DebugMsg( 'Item Found' );
      return WNE_ItemInfo[ aItemIdx ]; 
    else
      --WNE_Print_DebugMsg( 'Item Not Found' );
      WNE_ItemInfo[ aItemIdx ] = {};  
      return WNE_ItemInfo[ aItemIdx ]; 
    end
  else
    WNE_Print_DebugMsg( 'No aItemID or aItemName was Supplied' );
    return nil;
  end
  
  WNE_Print_Method_Trace( "x", "WNE_GetBaseItemInfo" );
end;

----------------------------------------------------------------------------------------------------
-- WNE_AddBaseInfo                         This method will be used to store the Base Item Data for
--                                         a given ItemLink in our WNE_Item Array.
----------------------------------------------------------------------------------------------------

function WNE_AddBaseItemInfo( aItemLink, aItemTexture )
  WNE_Print_Method_Trace( "e", "WNE_AddBaseItemInfo" );

  if ( aItemLink ) then
    local i, j, lItemColor, lItemID, li1, li2, li3 , lItemName = string.find( aItemLink, "|c(%x+)|Hitem:(%d+):(%d+):(%d+):(%d+)|h%[(.+)%]|h|r");

    --WNE_Print_DebugMsg( 'ItemLink' .. aItemLink );
    --WNE_Tooltip:SetOwner( this, "ANCHOR_NONE" );
    --WNE_Tooltip:Clear();
    WNE_ClearToolTip();
    WNE_ToolTip:SetHyperlink( "item:" .. lItemID .. ":" .. li1 .. ":" .. li2 .. ":" .. li3 );    
    
    local lItemToolTip = WNE_GetToolTipString( "WNE_ToolTip" ); 
    local lItemInfo    = WNE_GetBaseItemInfo( lItemID, lItemName );
    if ( lItemToolTip ) then
       WNE_Print_DebugMsg( 'lItemToolTip' );
        WNE_Print_DebugMsg( lItemToolTip );
      end

  
    
      
      if ( lItemInfo ) then
        if ( lItemInfo[ "Item" ]    ~= lItemID ) then
          lItemInfo[ "Item" ] = lItemID;
        end 
        if ( lItemInfo[ "Color" ]   ~= lItemColor ) then
          lItemInfo[ "Color" ] = lItemColor;
        end 
        if ( lItemInfo[ "Tooltip" ] ~= lItemToolTip ) then
          lItemInfo[ "Tooltip" ] = lItemToolTip;
        end
        if ( lItemInfo[ "Texture" ] ~= aItemTexture ) then
          lItemInfo[ "Texture" ] = aItemTexture;
        end 
        if ( lItemInfo[ "Name" ]    ~= lItemName ) then
          lItemInfo[ "Name" ] = lItemName;
        end

	local sssName, sLink, iQuality, iLevel, sType, sSubType, iCount,sSlot = GetItemInfo("item:" .. lItemID .. ":" .. li1 .. ":" .. li2 .. ":" .. li3);
	     lItemInfo[ "Quality" ] = iQuality;
     	     lItemInfo[ "Level" ] = iLevel;
     	     lItemInfo[ "Type" ] = sType;
     	     lItemInfo[ "SubType" ] = sSubType;
     	     lItemInfo[ "Slot" ] = sSlot;



        return lItemInfo;
      else
        return nil;  
      end
  else
    WNE_Print_DebugMsg( 'No aItemLink was Supplied' );
    return nil;
  end
  
  WNE_Print_Method_Trace( "x", "WNE_AddBaseItemInfo" );
end;

----------------------------------------------------------------------------------------------------
-- General Debuggin Routines
----------------------------------------------------------------------------------------------------

----------------------------------------------------------------------------------------------------
-- WNE_Print_DebugMsg                      This method will be used to print a Debug Message to the
--                                         CombatLog.
----------------------------------------------------------------------------------------------------

function WNE_Print_DebugMsg(str)
  if ( lShowDebugMessages ) then
    if( ChatFrame2 ) then
      ChatFrame2:AddMessage(str, 1.0, 1.0, 0.0);
    end
  end
end

function WNE_Print_InfoMsg( str )
  if ( lShowInfoMessages ) then
    if( ChatFrame2 ) then
      ChatFrame2:AddMessage(str, 1.0, 1.0, 0.0);
    end
  end
end
----------------------------------------------------------------------------------------------------
-- WNE_Print_Method_Trace                  This method is simply a helper method which prints method
--                                         enter / method exit debug Messages to the CombatLog.
----------------------------------------------------------------------------------------------------

function WNE_Print_Method_Trace( aType, aMethodName )
  local lMessage;
  
  if ( aType == 'E' ) or ( aType == 'e' ) then
    lMessage = '-->' .. aMethodName;
  else
    lMessage = "<--" .. aMethodName;
  end
  
  WNE_Print_DebugMsg( lMessage );    
end

----------------------------------------------------------------------------------------------------
-- WNE_Print_WarningMsg                    This method will be used to print a Debug WarningMessage 
--                                         to the CombatLog and display a Warning Banner.
----------------------------------------------------------------------------------------------------

function WNE_Print_WarningMsg(str)
  if ( lShowDebugMessages ) then
    if( ChatFrame2 ) then
      ChatFrame2:AddMessage(str, 1.0, 0.0, 0.0);
    end
    UIErrorsFrame:AddMessage( str, 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);
  end
end


--return tooltip html readme
function GameProfilestrTooltip()
	local strings = ScanTooltip("ItemHiddenTooltip");	
	local str = {};
	local htmlstr = nil;
	for i=1, getn(strings) do
		if (not strings[i].right) then
			strings[i].right = "";
		else
			strings[i].right = "\t" .. strings[i].right;
		end
		str[i] = string.gsub(string.gsub(strings[i].left .. strings[i].right, "\n", "<br>"), "\r", "");
		if ( htmlstr ) then
			htmlstr = htmlstr .. "<br>" .. strings[i].left .. strings[i].right;
		else
			htmlstr = strings[i].left .. strings[i].right;
		end
	end
	ClearTooltip("ItemHiddenTooltip");
	return htmlstr;	
end



function WNE_ClearToolTip()
--  WNE_Print_Method_Trace( "e", "WNE_ClearToolTip" );
  for aLine = 1, 20 do
    getglobal( WNE_ToolTip:GetName().."TextLeft"..aLine ):SetText( "" );
    getglobal( WNE_ToolTip:GetName().."TextRight"..aLine ):SetText( "" );
  end
--  WNE_Print_Method_Trace( "x", "WNE_ClearToolTip" );
end

function WNE_GetToolTipString(TooltipNameBase)
  WNE_Print_Method_Trace( "e", "WNE_GetToolTipString" );

  local strToolTip = "";

  if ( TooltipNameBase == nil ) then 
    TooltipNameBase = "WNE_ToolTip";
  end

--  WNE_Print_DebugMsg( "TooltipNameBase = " .. TooltipNameBase );
	
  tooltipFrame=getglobal(TooltipNameBase);

  for idx = 1, tooltipFrame:NumLines() do  
    --WNE_Print_DebugMsg( "TooltipNameBase scanning line " .. idx );

    local textLeft = nil;
    local textRight = nil;

    -- Get the Left part of the ToolTip Line
    ttText=getglobal( TooltipNameBase .. "TextLeft" .. idx);
    if(ttText and ttText:IsShown() and ttText:GetText()) then
      textLeft = ttText:GetText();
    end

    -- Get the Right part of the ToolTip Line
    ttText=getglobal( TooltipNameBase .. "TextRight" .. idx);
    if(ttText and ttText:IsShown() and ttText:GetText()) then
      textRight = ttText:GetText();
    end


    if (textLeft or textRight) then
       
      if ( not textRight ) then
        textRight = "";
      else
        textRight = "\t" .. textRight;
      end
      strToolTip = strToolTip .."<br>"..string.gsub( string.gsub( textLeft .. textRight, "\n", "<br>"), "\r", "");
      
--      if ( strToolTip[ idx ] ) then
--        WNE_Print_DebugMsg( "StrToolTipLine : " .. strToolTip[ idx ] );
--      else
--        WNE_Print_DebugMsg( "StrToolTipLine is empty" );
--      end
    end
  end
--  WNE_Print_DebugMsg( strToolTip[ 1 ] );	
  WNE_Print_Method_Trace( "x", "WNE_GetToolTipString" );
  return strToolTip;
end


