--[[

	MonkeyQuest:
	Displays your quests for quick viewing.
	
	Website:	http://wow.visualization.ca/
	Author:		Trentin (trentin@toctastic.net)
	
--]]

-- ** NOTE ** The other languages are getting out of date, 
-- if you'd like to submit an update please email it to trentin@toctastic.net


-- Chinese, the default
MONKEYQUEST_TITLE					= "任务监视";
MONKEYQUEST_VERSION					= MONKEYLIB_VERSION;
MONKEYQUEST_TITLE_VERSION			= MONKEYQUEST_TITLE .. " v" .. MONKEYQUEST_VERSION;
MONKEYQUEST_DESCRIPTION				= "快速显示任务相关信息";
MONKEYQUEST_INFO_COLOUR				= "|cffffff00";
MONKEYQUEST_LOADED_MSG				= MONKEYQUEST_INFO_COLOUR .. MONKEYQUEST_TITLE .. " v" .. MONKEYQUEST_VERSION .. " 已载入";


MONKEYQUEST_QUEST_DONE				= "完成";
MONKEYQUEST_CONFIRM_RESET			= "确认恢复 " .. MONKEYQUEST_TITLE .. " 默认设置?";


MONKEYQUEST_CHAT_COLOUR				= "|cff00ff00";
MONKEYQUEST_SET_WIDTH_MSG			= MONKEYQUEST_CHAT_COLOUR .. MONKEYQUEST_TITLE .. ": 你需要用'/console reloadui'来观看宽度的修改效果";
MONKEYQUEST_RESET_MSG				= MONKEYQUEST_CHAT_COLOUR .. MONKEYQUEST_TITLE .. ": 设置已经恢复到默认值";

MONKEYQUEST_HELP_MSG				= MONKEYQUEST_INFO_COLOUR .. "用法: /mquest help <command>\n" ..
									  MONKEYQUEST_CHAT_COLOUR .. "<command>为下列各参数: \n" ..
									  "reset, open, close, showhidden, hidehidden, useoverviews, nooverviews, " ..
									  "tipanchor, alpha, width, hideheaders, showheaders, hideborder, showborder, " ..
									  "growup, growdown, hidenumquests, shownumquests, lock, unlock, colourtitleon, " ..
									  "colourtitleoff, hidecompletedquests, showcompletedquests, hidecompletedobjectives, " ..
									  "showcompletedobjectives, fontheight, showtooltipobjectives, hidetootipobjectives, " ..
									  "allowrightclick, disallowrightclick, hidetitlebuttons, showtitlebuttons.";
MONKEYQUEST_HELP_RESET_MSG			= MONKEYQUEST_INFO_COLOUR .. "用法: /mquest reset\n" ..
									  MONKEYQUEST_CHAT_COLOUR .. "显示重设配置对话框。\n";


MONKEYQUEST_HELP_OPEN_MSG			= MONKEYQUEST_INFO_COLOUR .. "用法: /mquest open\n" ..
									  MONKEYQUEST_CHAT_COLOUR .. "显示主 " .. MONKEYQUEST_TITLE .. " 窗体。\n";
MONKEYQUEST_HELP_CLOSE_MSG			= MONKEYQUEST_INFO_COLOUR .. "用法: /mquest close\n" ..
									  MONKEYQUEST_CHAT_COLOUR .. "隐藏主 " .. MONKEYQUEST_TITLE .. " 窗体。\n";
MONKEYQUEST_HELP_SHOWHIDDEN_MSG		= MONKEYQUEST_INFO_COLOUR .. "用法: /mquest showhidden\n" ..
									  MONKEYQUEST_CHAT_COLOUR .. "显示失败的地区名称并隐藏任务。\n";
MONKEYQUEST_HELP_HIDEHIDDEN_MSG		= MONKEYQUEST_INFO_COLOUR .. "用法: /mquest hidehidden\n" ..
									  MONKEYQUEST_CHAT_COLOUR .. "隐藏失败的地区名称并隐藏任务.\n";
MONKEYQUEST_HELP_USEOVERVIEWS_MSG	= MONKEYQUEST_INFO_COLOUR .. "用法: /mquest useoverviews\n" ..
									  MONKEYQUEST_CHAT_COLOUR .. "显示没有物品收集或者怪物猎杀的任务摘要。\n";
MONKEYQUEST_HELP_NOOVERVIEWS_MSG	= MONKEYQUEST_INFO_COLOUR .. "用法: /mquest nooverviews\n" ..
									  MONKEYQUEST_CHAT_COLOUR .. "隐藏没有物品收集或者怪物猎杀的任务摘要。\n";
MONKEYQUEST_HELP_TIPANCHOR_MSG		= MONKEYQUEST_INFO_COLOUR .. "用法: /mquest tipanchor=<anchor position>\n" ..
									  MONKEYQUEST_CHAT_COLOUR .. "设置提示栏的位置到 <anchor position> " .. 
									  "下列位置可用:\nANCHOR_TOPLEFT(左上), ANCHOR_TOPRIGHT(右上), ANCHOR_TOP(中上), ANCHOR_LEFT(左), " ..
									  "ANCHOR_RIGHT(右), ANCHOR_BOTTOMLEFT(下左), ANCHOR_BOTTOMRIGHT(下右), ANCHOR_BOTTOM(下), ANCHOR_CURSOR(鼠标指针), " .. 
									  "DEFAULT(默认), NONE(无)";
MONKEYQUEST_HELP_ALPHA_MSG			= MONKEYQUEST_INFO_COLOUR .. "用法: /mquest alpha=<0 - 255>\n" ..
									  MONKEYQUEST_CHAT_COLOUR .. "设置背景透明度到指定的值。\n";
MONKEYQUEST_HELP_WIDTH_MSG			= MONKEYQUEST_INFO_COLOUR .. "用法: /mquest width=<positive integer>\n" ..
									  MONKEYQUEST_CHAT_COLOUR .. "设置宽度到指定的值，默认是255。\n";
MONKEYQUEST_HELP_HIDEHEADERS_MSG	= MONKEYQUEST_INFO_COLOUR .. "用法: /mquest hideheaders\n" ..
									  MONKEYQUEST_CHAT_COLOUR .. "从不显示地区名称。\n";
MONKEYQUEST_HELP_SHOWHEADERS_MSG	= MONKEYQUEST_INFO_COLOUR .. "用法: /mquest showheaders\n" ..
									  MONKEYQUEST_CHAT_COLOUR .. "一直显示地区名称。\n";
MONKEYQUEST_HELP_HIDEBORDER_MSG		= MONKEYQUEST_INFO_COLOUR .. "用法: /mquest hideborder\n" ..
									  MONKEYQUEST_CHAT_COLOUR .. "隐藏主 " .. MONKEYQUEST_TITLE .. " 窗体的边框。\n";
MONKEYQUEST_HELP_SHOWBORDER_MSG		= MONKEYQUEST_INFO_COLOUR .. "用法: /mquest showborder\n" ..
									  MONKEYQUEST_CHAT_COLOUR .. "显示主 " .. MONKEYQUEST_TITLE .. " 窗体的边框。\n";
MONKEYQUEST_HELP_GROWUP_MSG			= MONKEYQUEST_INFO_COLOUR .. "用法: /mquest growup\n" ..
									  MONKEYQUEST_CHAT_COLOUR .. "使主 " .. MONKEYQUEST_TITLE .. " 窗体向上扩展。\n";
MONKEYQUEST_HELP_GROWDOWN_MSG		= MONKEYQUEST_INFO_COLOUR .. "用法: /mquest growdown\n" ..
									  MONKEYQUEST_CHAT_COLOUR .. "使主 " .. MONKEYQUEST_TITLE .. " 窗体向下扩展。\n";
MONKEYQUEST_HELP_HIDENUMQUESTS_MSG	= MONKEYQUEST_INFO_COLOUR .. "用法: /mquest hidenumquests\n" ..
									  MONKEYQUEST_CHAT_COLOUR .. "隐藏标题栏上的任务数量。\n";
MONKEYQUEST_HELP_SHOWNUMQUESTS_MSG	= MONKEYQUEST_INFO_COLOUR .. "用法: /mquest shownumquests\n" ..
									  MONKEYQUEST_CHAT_COLOUR .. "显示主标题栏上的任务数量。\n";
MONKEYQUEST_HELP_LOCK_MSG			= MONKEYQUEST_INFO_COLOUR .. "用法: /mquest lock\n" ..
									  MONKEYQUEST_CHAT_COLOUR .. "锁定 " .. MONKEYQUEST_TITLE .. " 窗体。\n";
MONKEYQUEST_HELP_UNLOCK_MSG			= MONKEYQUEST_INFO_COLOUR .. "用法: /mquest unlock\n" ..
									  MONKEYQUEST_CHAT_COLOUR .. "解锁 " .. MONKEYQUEST_TITLE .. " 窗体。\n";
MONKEYQUEST_HELP_COLOURTITLEON_MSG	= MONKEYQUEST_INFO_COLOUR .. "用法: /mquest colourtitleon\n" ..
									  MONKEYQUEST_CHAT_COLOUR .. "根据任务难度使用颜色来标示任务标题。\n";
MONKEYQUEST_HELP_COLOURTITLEOFF_MSG	= MONKEYQUEST_INFO_COLOUR .. "用法: /mquest colourtitleoff\n" ..
									  MONKEYQUEST_CHAT_COLOUR .. "不根据任务难度使用颜色来标示任务标题。\n";
MONKEYQUEST_HELP_HIDECOMPLETEDQUESTS_MSG	= MONKEYQUEST_INFO_COLOUR .. "用法: /mquest hidecompletedquests\n" ..
									  MONKEYQUEST_CHAT_COLOUR .. "隐藏已完成任务。\n";
MONKEYQUEST_HELP_SHOWCOMPLETEDQUESTS_MSG	= MONKEYQUEST_INFO_COLOUR .. "用法: /mquest showcompletedquests\n" ..
									  MONKEYQUEST_CHAT_COLOUR .. "显示已完成任务。\n";
MONKEYQUEST_HELP_HIDECOMPLETEDOBJECTIVES_MSG	= MONKEYQUEST_INFO_COLOUR .. "用法: /mquest hidecompletedobjectives\n" ..
									  MONKEYQUEST_CHAT_COLOUR .. "隐藏完整任务描述。\n";
MONKEYQUEST_HELP_SHOWCOMPLETEDOBJECTIVES_MSG	= MONKEYQUEST_INFO_COLOUR .. "用法: /mquest showcompletedobjectives\n" ..
									  MONKEYQUEST_CHAT_COLOUR .. "显示完整任务描述。\n";
MONKEYQUEST_HELP_FONTHEIGHT_MSG		= MONKEYQUEST_INFO_COLOUR .. "用法: /mquest fontheight=<positive integer>\n" ..
									  MONKEYQUEST_CHAT_COLOUR .. "设置字体大小到指定值，默认是12。\n";
MONKEYQUEST_HELP_SHOWTOOLTIPOBJECTIVES_MSG	= MONKEYQUEST_INFO_COLOUR .. "用法: /mquest showtooltipobjectives\n" ..
									  MONKEYQUEST_CHAT_COLOUR .. "在提示窗口添加一条线显示完整任务提示。\n";
MONKEYQUEST_HELP_HIDETOOLTIPOBJECTIVES_MSG	= MONKEYQUEST_INFO_COLOUR .. "用法: /mquest hidetooltipobjectives\n" ..
									  MONKEYQUEST_CHAT_COLOUR .. "不在提示窗口添加一条线显示完整任务提示。\n";
MONKEYQUEST_HELP_ALLOWRIGHTCLICK_MSG	= MONKEYQUEST_INFO_COLOUR .. "用法: /mquest allowrightclick\n" ..
									  MONKEYQUEST_CHAT_COLOUR .. "允许右键点击打开MonkeyBuddy。\n";
MONKEYQUEST_HELP_DISALLOWRIGHTCLICK_MSG	= MONKEYQUEST_INFO_COLOUR .. "用法: /mquest disallowrightclick\n" ..
									  MONKEYQUEST_CHAT_COLOUR .. "禁止右键点击打开MonkeyBuddy。\n";
MONKEYQUEST_HELP_HIDETITLEBUTTONS_MSG	= MONKEYQUEST_INFO_COLOUR .. "用法: /mquest hidetitlebuttons\n" ..
									  MONKEYQUEST_CHAT_COLOUR .. "隐藏标题栏按钮。\n";
MONKEYQUEST_HELP_SHOWTITLEBUTTONS_MSG	= MONKEYQUEST_INFO_COLOUR .. "用法: /mquest showtitlebuttons\n" ..
									  MONKEYQUEST_CHAT_COLOUR .. "显示标题栏按钮。\n";

									  
-- tooltip strings
MONKEYQUEST_TOOLTIP_QUESTITEM		= "任务相关";		-- as it appears in the tooltip of unique quest items
MONKEYQUEST_TOOLTIP_SLAIN			= "已杀死";			-- as it appears in the objective text

-- misc quest strings
MONKEYQUEST_DUNGEON					= "副本";
MONKEYQUEST_PVP						= "PvP";

-- noob tips
MONKEYQUEST_NOOBTIP_HEADER			= "新手提示:";

MONKEYQUEST_NOOBTIP_CLOSE			= "点击关闭。再次打开:";
MONKEYQUEST_NOOBTIP_MINIMIZE		= "点击此处最小化主窗体";
MONKEYQUEST_NOOBTIP_RESTORE			= "点击此处最大化主窗体";
MONKEYQUEST_NOOBTIP_SHOWALLHIDDEN	= "点击此处显示被隐藏条目";
MONKEYQUEST_NOOBTIP_HIDEALLHIDDEN	= "点击此处隐藏可隐藏条目";
MONKEYQUEST_NOOBTIP_HIDEBUTTON		= "点击此处隐藏该任务。 开启 '显示隐藏的全部条目' 便于再次浏览这项任务";
MONKEYQUEST_NOOBTIP_TITLE			= "右键点击打开 MonkeyBuddy 配置面板";
MONKEYQUEST_NOOBTIP_QUESTHEADER		= "点击此处隐藏/显示该地区的全部任务。 开启 '显示隐藏的全部条目' 以便显示你隐藏的地区标题。";

-- bindings
BINDING_HEADER_MONKEYQUEST 			= MONKEYQUEST_TITLE;
BINDING_NAME_MONKEYQUEST_CLOSE 		= "关闭/打开";
BINDING_NAME_MONKEYQUEST_MINIMIZE 	= "最小化/最大化";
BINDING_NAME_MONKEYQUEST_HIDDEN		= "隐藏/显示条目";
BINDING_NAME_MONKEYQUEST_NOHEADERS	= "切换标题显示";

-- using to get the number of Quest Item in Chinese
MONKEYQUEST_QUESTITEM_COLON		= "："

